/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.script;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.hivemind.Location;
import org.apache.tapestry.services.ExpressionEvaluator;

/**
 * Base class for creating tokens which may contain other tokens.
 * 
 * @author Howard Lewis Ship
 * @since 0.2.9
 */

abstract class AbstractToken implements IScriptToken
{public static com.cortexeb.tools.clover.d __CLOVER_251_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1097439627296L);
    private List _tokens;

    private Location _location;

    protected AbstractToken(Location location)
    {try { __CLOVER_251_0.M[3231]++;
        __CLOVER_251_0.S[13800]++;_location = location;
    } finally { }}

    public Location getLocation()
    {try { __CLOVER_251_0.M[3232]++;
        __CLOVER_251_0.S[13801]++;return _location;
    } finally { }}

    public void addToken(IScriptToken token)
    {try { __CLOVER_251_0.M[3233]++;
        __CLOVER_251_0.S[13802]++;if ((((_tokens == null) && (++__CLOVER_251_0.CT[2317] != 0)) || (++__CLOVER_251_0.CF[2317] == 0))){
            __CLOVER_251_0.S[13803]++;_tokens = new ArrayList();}

        __CLOVER_251_0.S[13804]++;_tokens.add(token);
    } finally { }}

    /**
     * Invokes {@link IScriptToken#write(StringBuffer,ScriptSession)}on each child token (if there
     * are any).
     */

    protected void writeChildren(StringBuffer buffer, ScriptSession session)
    {try { __CLOVER_251_0.M[3234]++;
        __CLOVER_251_0.S[13805]++;if ((((_tokens == null) && (++__CLOVER_251_0.CT[2318] != 0)) || (++__CLOVER_251_0.CF[2318] == 0))){
            __CLOVER_251_0.S[13806]++;return;}

        __CLOVER_251_0.S[13807]++;Iterator i = _tokens.iterator();

        __CLOVER_251_0.S[13808]++;while ((((i.hasNext()) && (++__CLOVER_251_0.CT[2319] != 0)) || (++__CLOVER_251_0.CF[2319] == 0))){
        {
            __CLOVER_251_0.S[13809]++;IScriptToken token = (IScriptToken) i.next();

            __CLOVER_251_0.S[13810]++;token.write(buffer, session);
        }}
    } finally { }}

    /**
     * Evaluates the expression against the session's symbols, using
     * {@link ExpressionEvaluator#read(Object, String)}and returns the result.
     */
    protected Object evaluate(String expression, ScriptSession session)
    {try { __CLOVER_251_0.M[3235]++;

        __CLOVER_251_0.S[13811]++;try
        {
            __CLOVER_251_0.S[13812]++;return session.evaluate(expression);
        }
        catch (Exception ex)
        {
            __CLOVER_251_0.S[13813]++;throw new ApplicationRuntimeException(ex.getMessage(), _location, ex);
        }
    } finally { }}
}