/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.script;

import java.util.Iterator;
import java.util.Map;

import org.apache.hivemind.Location;
import org.apache.tapestry.Tapestry;

/**
 *  A looping operator, modeled after the Foreach component.  It takes
 *  as its source as property and iterates through the values, updating
 *  a symbol on each pass.
 * 
 *  <p>As of 3.0, the index attribute has been added to foreach to keep 
 *  track of the current index of the iterating collection.</p>
 *
 *  @author Howard Lewis Ship, Harish Krishnaswamy
 *  @since 1.0.1
 * 
 **/

class ForeachToken extends AbstractToken
{public static com.cortexeb.tools.clover.d __CLOVER_256_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1097439627296L);
    private String _key;
    private String _index;
    private String _expression;

    ForeachToken(String key, String index, String expression, Location location)
    {
        super(location);__CLOVER_256_0.S[13821]++;try { __CLOVER_256_0.M[3238]++;

        __CLOVER_256_0.S[13822]++;_key = key;
        __CLOVER_256_0.S[13823]++;_index = index;
        __CLOVER_256_0.S[13824]++;_expression = expression;
    } finally { }}

    public void write(StringBuffer buffer, ScriptSession session)
    {try { __CLOVER_256_0.M[3239]++;
        __CLOVER_256_0.S[13825]++;Map symbols = session.getSymbols();

        __CLOVER_256_0.S[13826]++;Object rawSource = evaluate(_expression, session);

        __CLOVER_256_0.S[13827]++;Iterator i = Tapestry.coerceToIterator(rawSource);
        
        __CLOVER_256_0.S[13828]++;if ((((i == null) && (++__CLOVER_256_0.CT[2321] != 0)) || (++__CLOVER_256_0.CF[2321] == 0))){
            __CLOVER_256_0.S[13829]++;return;}

        __CLOVER_256_0.S[13830]++;int index = 0;

        __CLOVER_256_0.S[13831]++;while ((((i.hasNext()) && (++__CLOVER_256_0.CT[2322] != 0)) || (++__CLOVER_256_0.CF[2322] == 0))){
        {
            __CLOVER_256_0.S[13832]++;Object newValue = i.next();

            __CLOVER_256_0.S[13833]++;symbols.put(_key, newValue);
            
            __CLOVER_256_0.S[13834]++;if ((((_index != null) && (++__CLOVER_256_0.CT[2323] != 0)) || (++__CLOVER_256_0.CF[2323] == 0))){
            	__CLOVER_256_0.S[13835]++;symbols.put(_index, String.valueOf(index));}

            __CLOVER_256_0.S[13836]++;writeChildren(buffer, session);
            
            __CLOVER_256_0.S[13837]++;index++;
        }}

        // We leave the last value as a symbol; don't know if that's
        // good or bad.
    } finally { }}
}