/* $$ Clover has instrumented this file $$ */package org.apache.tapestry.services;

/**
 * Service used to construct absolute URLs (often used for redirects).
 * 
 * @author Howard M. Lewis Ship
 * @since 3.1
 */
public interface AbsoluteURLBuilder
{
    /**
     * Constructs a URL from the given URI (that is, service path), schema, server and port.
     * 
     * @param URI
     *            either a complete URL (that is, containing a colon), in which case it is returned
     *            unchanged, or the path within the server.
     * @param scheme
     *            scheme to prefix URI with
     * @param server
     *            to prefix the URI with (unless the URI begins with "//"
     * @param port
     *            to suffix the server with (unless the URI begins with "//")
     */
    public String constructURL(String URI, String scheme, String server, int port);

    /**
     * Constructs a URL, defaulting scheme, server and port to the values for the current request.
     */

    public String constructURL(String URI);
}