/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.services.impl;

import java.util.Map;

import ognl.ClassResolver;
import ognl.Ognl;
import ognl.TypeConverter;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.tapestry.Tapestry;
import org.apache.tapestry.services.ExpressionCache;
import org.apache.tapestry.services.ExpressionEvaluator;
import org.apache.tapestry.spec.IApplicationSpecification;
import org.apache.tapestry.util.prop.OgnlClassResolver;

/**
 * @author Howard M. Lewis Ship
 * @since 3.1
 */
public class ExpressionEvaluatorImpl implements ExpressionEvaluator
{public static com.cortexeb.tools.clover.d __CLOVER_496_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1097439627296L);
    // Uses Thread's context class loader

    private ClassResolver _ognlResolver = new OgnlClassResolver();

    private ExpressionCache _expressionCache;

    private IApplicationSpecification _applicationSpecification;

    private TypeConverter _typeConverter;

    public void setApplicationSpecification(IApplicationSpecification applicationSpecification)
    {try { __CLOVER_496_0.M[3307]++;
        __CLOVER_496_0.S[14099]++;_applicationSpecification = applicationSpecification;
    } finally { }}
    
    public void initializeService()
    {try { __CLOVER_496_0.M[3308]++;
        __CLOVER_496_0.S[14100]++;if ((((_applicationSpecification.checkExtension(Tapestry.OGNL_TYPE_CONVERTER)) && (++__CLOVER_496_0.CT[2360] != 0)) || (++__CLOVER_496_0.CF[2360] == 0))){
            __CLOVER_496_0.S[14101]++;_typeConverter = (TypeConverter) _applicationSpecification.getExtension(
                    Tapestry.OGNL_TYPE_CONVERTER,
                    TypeConverter.class);}
    } finally { }}

    public Object read(Object target, String expression)
    {try { __CLOVER_496_0.M[3309]++;
        __CLOVER_496_0.S[14102]++;return readCompiled(target, _expressionCache.getCompiledExpression(expression));
    } finally { }}

    public Object readCompiled(Object target, Object expression)
    {try { __CLOVER_496_0.M[3310]++;
        __CLOVER_496_0.S[14103]++;try
        {
            __CLOVER_496_0.S[14104]++;Map context = createContext(target);

            __CLOVER_496_0.S[14105]++;return Ognl.getValue(expression, context, target);
        }
        catch (Exception ex)
        {
            __CLOVER_496_0.S[14106]++;throw new ApplicationRuntimeException(ImplMessages.unableToReadExpression(ImplMessages
                    .parsedExpression(), target, ex), target, null, ex);
        }
    } finally { }}

    private Map createContext(Object target)
    {try { __CLOVER_496_0.M[3311]++;
        __CLOVER_496_0.S[14107]++;Map result = Ognl.createDefaultContext(target, _ognlResolver);

        __CLOVER_496_0.S[14108]++;if ((((_typeConverter != null) && (++__CLOVER_496_0.CT[2361] != 0)) || (++__CLOVER_496_0.CF[2361] == 0))){
            __CLOVER_496_0.S[14109]++;Ognl.setTypeConverter(result, _typeConverter);}

        __CLOVER_496_0.S[14110]++;return result;
    } finally { }}

    public void write(Object target, String expression, Object value)
    {try { __CLOVER_496_0.M[3312]++;
        __CLOVER_496_0.S[14111]++;writeCompiled(target, _expressionCache.getCompiledExpression(expression), value);
    } finally { }}

    public void writeCompiled(Object target, Object expression, Object value)
    {try { __CLOVER_496_0.M[3313]++;
        __CLOVER_496_0.S[14112]++;try
        {
            __CLOVER_496_0.S[14113]++;Map context = createContext(target);

            __CLOVER_496_0.S[14114]++;Ognl.setValue(expression, context, target, value);
        }
        catch (Exception ex)
        {
            __CLOVER_496_0.S[14115]++;throw new ApplicationRuntimeException(ImplMessages.unableToWriteExpression(ImplMessages
                    .parsedExpression(), target, value, ex), target, null, ex);
        }

    } finally { }}

    public boolean isConstant(String expression)
    {try { __CLOVER_496_0.M[3314]++;
        __CLOVER_496_0.S[14116]++;Object compiled = _expressionCache.getCompiledExpression(expression);

        __CLOVER_496_0.S[14117]++;try
        {
            __CLOVER_496_0.S[14118]++;return Ognl.isConstant(compiled);
        }
        catch (Exception ex)
        {
            __CLOVER_496_0.S[14119]++;throw new ApplicationRuntimeException(ImplMessages.isConstantExpressionError(
                    expression,
                    ex), ex);
        }
    } finally { }}

    public void setExpressionCache(ExpressionCache expressionCache)
    {try { __CLOVER_496_0.M[3315]++;
        __CLOVER_496_0.S[14120]++;_expressionCache = expressionCache;
    } finally { }}
}