/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.services.impl;

import java.net.URL;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Locale;

import javax.servlet.http.HttpServlet;

import org.apache.hivemind.HiveMind;
import org.apache.hivemind.Resource;
import org.apache.hivemind.impl.MessageFormatter;
import org.apache.tapestry.IComponent;
import org.apache.tapestry.engine.IEngineService;
import org.apache.tapestry.services.Infrastructure;
import org.apache.tapestry.spec.IContainedComponent;

/**
 * @author Howard Lewis Ship
 * @since 3.1
 */
final class ImplMessages
{public static com.cortexeb.tools.clover.d __CLOVER_314_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1097439627296L);
    private static final MessageFormatter _formatter = new MessageFormatter(ImplMessages.class,
            "ImplStrings");

    public static String initializerContribution()
    {try { __CLOVER_314_0.M[3316]++;
        __CLOVER_314_0.S[14121]++;return _formatter.getMessage("initializer-contribution");
    } finally { }}

    public static String noApplicationSpecification(HttpServlet servlet)
    {try { __CLOVER_314_0.M[3317]++;
        __CLOVER_314_0.S[14122]++;return _formatter.format("no-application-specification", servlet.getServletName());
    } finally { }}

    public static String errorInstantiatingEngine(Class engineClass, Throwable cause)
    {try { __CLOVER_314_0.M[3318]++;
        __CLOVER_314_0.S[14123]++;return _formatter.format("error-instantiating-engine", engineClass.getName(), cause);
    } finally { }}

    public static String noTemplateForComponent(String componentId, Locale locale)
    {try { __CLOVER_314_0.M[3319]++;
        __CLOVER_314_0.S[14124]++;return _formatter.format("no-template-for-component", componentId, locale);
    } finally { }}

    public static String noTemplateForPage(String pageName, Locale locale)
    {try { __CLOVER_314_0.M[3320]++;
        __CLOVER_314_0.S[14125]++;return _formatter.format("no-template-for-page", pageName, locale);
    } finally { }}

    public static String unableToReadTemplate(Object template)
    {try { __CLOVER_314_0.M[3321]++;
        __CLOVER_314_0.S[14126]++;return _formatter.format("unable-to-read-template", template);
    } finally { }}

    public static String unableToParseTemplate(Resource resource)
    {try { __CLOVER_314_0.M[3322]++;
        __CLOVER_314_0.S[14127]++;return _formatter.format("unable-to-parse-template", resource);
    } finally { }}

    public static String unableToParseSpecification(Resource resource)
    {try { __CLOVER_314_0.M[3323]++;
        __CLOVER_314_0.S[14128]++;return _formatter.format("unable-to-parse-specification", resource);
    } finally { }}

    public static String unableToReadInfrastructureProperty(String propertyName,
            Infrastructure service, Throwable cause)
    {try { __CLOVER_314_0.M[3324]++;
        __CLOVER_314_0.S[14129]++;return _formatter.format(
                "unable-to-read-infrastructure-property",
                propertyName,
                service,
                cause);
    } finally { }}

    public static String multipleComponentReferences(IComponent component, String id)
    {try { __CLOVER_314_0.M[3325]++;
        __CLOVER_314_0.S[14130]++;return _formatter.format("multiple-component-references", component.getExtendedId(), id);
    } finally { }}

    public static String dupeComponentId(String id, IContainedComponent containedComponent)
    {try { __CLOVER_314_0.M[3326]++;
        __CLOVER_314_0.S[14131]++;return _formatter.format("dupe-component-id", id, HiveMind
                .getLocationString(containedComponent));
    } finally { }}

    public static String unbalancedCloseTags()
    {try { __CLOVER_314_0.M[3327]++;
        __CLOVER_314_0.S[14132]++;return _formatter.getMessage("unbalanced-close-tags");
    } finally { }}

    public static String templateBindingForInformalParameter(IComponent loadComponent,
            String parameterName, IComponent component)
    {try { __CLOVER_314_0.M[3328]++;
        __CLOVER_314_0.S[14133]++;return _formatter.format("template-binding-for-informal-parameter", loadComponent
                .getExtendedId(), parameterName, component.getExtendedId());
    } finally { }}

    public static String templateBindingForReservedParameter(IComponent loadComponent,
            String parameterName, IComponent component)
    {try { __CLOVER_314_0.M[3329]++;
        __CLOVER_314_0.S[14134]++;return _formatter.format("template-binding-for-reserved-parameter", loadComponent
                .getExtendedId(), parameterName, component.getExtendedId());
    } finally { }}

    public static String missingComponentSpec(IComponent component, Collection ids)
    {try { __CLOVER_314_0.M[3330]++;
        __CLOVER_314_0.S[14135]++;StringBuffer buffer = new StringBuffer();
        __CLOVER_314_0.S[14136]++;List idList = new ArrayList(ids);
        __CLOVER_314_0.S[14137]++;int count = idList.size();

        __CLOVER_314_0.S[14138]++;for (int i = 0; (((i < count) && (++__CLOVER_314_0.CT[2362] != 0)) || (++__CLOVER_314_0.CF[2362] == 0)); i++){
        {
            __CLOVER_314_0.S[14139]++;if ((((i > 0) && (++__CLOVER_314_0.CT[2363] != 0)) || (++__CLOVER_314_0.CF[2363] == 0))){
                __CLOVER_314_0.S[14140]++;buffer.append(", ");}

            __CLOVER_314_0.S[14141]++;buffer.append(idList.get(i));
        }}

        __CLOVER_314_0.S[14142]++;return _formatter.format("missing-component-spec", component.getExtendedId(), new Integer(
                count), buffer.toString());
    } finally { }}

    public static String bodylessComponent()
    {try { __CLOVER_314_0.M[3331]++;
        __CLOVER_314_0.S[14143]++;return _formatter.getMessage("bodyless-component");
    } finally { }}

    public static String dupeTemplateBinding(String name, IComponent component,
            IComponent loadComponent)
    {try { __CLOVER_314_0.M[3332]++;
        __CLOVER_314_0.S[14144]++;return _formatter.format(
                "dupe-template-binding",
                name,
                component.getExtendedId(),
                loadComponent.getExtendedId());
    } finally { }}

    public static String unableToLoadProperties(URL url, Throwable cause)
    {try { __CLOVER_314_0.M[3333]++;
        __CLOVER_314_0.S[14145]++;return _formatter.format("unable-to-load-properties", url, cause);
    } finally { }}

    public static String noSuchService(String name)
    {try { __CLOVER_314_0.M[3334]++;
        __CLOVER_314_0.S[14146]++;return _formatter.format("no-such-service", name);
    } finally { }}

    public static String dupeService(String name, IEngineService existing)
    {try { __CLOVER_314_0.M[3335]++;
        __CLOVER_314_0.S[14147]++;return _formatter.format("dupe-service", name, HiveMind.getLocationString(existing));
    } finally { }}

    public static String unableToParseExpression(String expression, Throwable cause)
    {try { __CLOVER_314_0.M[3336]++;
        __CLOVER_314_0.S[14148]++;return _formatter.format("unable-to-parse-expression", expression, cause);
    } finally { }}

    public static String parsedExpression()
    {try { __CLOVER_314_0.M[3337]++;
        __CLOVER_314_0.S[14149]++;return _formatter.getMessage("parsed-expression");
    } finally { }}

    public static String unableToReadExpression(String expression, Object target, Throwable cause)
    {try { __CLOVER_314_0.M[3338]++;
        __CLOVER_314_0.S[14150]++;return _formatter.format("unable-to-read-expression", expression, target, cause);
    } finally { }}

    public static String unableToWriteExpression(String expression, Object target, Object value,
            Throwable cause)
    {try { __CLOVER_314_0.M[3339]++;
        __CLOVER_314_0.S[14151]++;return _formatter.format("unable-to-write-expression", new Object[]
        { expression, target, value, cause });
    } finally { }}

    public static String isConstantExpressionError(String expression, Exception ex)
    {try { __CLOVER_314_0.M[3340]++;
        __CLOVER_314_0.S[14152]++;return _formatter.format("is-constant-expression-error", expression, ex);
    } finally { }}
}