/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.services.impl;

import org.apache.hivemind.ClassResolver;
import org.apache.tapestry.engine.IComponentClassEnhancer;
import org.apache.tapestry.engine.IPageSource;
import org.apache.tapestry.engine.IPropertySource;
import org.apache.tapestry.engine.IScriptSource;
import org.apache.tapestry.engine.ISpecificationSource;
import org.apache.tapestry.services.ComponentMessagesSource;
import org.apache.tapestry.services.DataSqueezer;
import org.apache.tapestry.services.Infrastructure;
import org.apache.tapestry.services.ObjectPool;
import org.apache.tapestry.services.RequestExceptionReporter;
import org.apache.tapestry.services.ResetEventCoordinator;
import org.apache.tapestry.services.ResponseRenderer;
import org.apache.tapestry.services.ServiceMap;
import org.apache.tapestry.services.TemplateSource;
import org.apache.tapestry.spec.IApplicationSpecification;

/**
 * Allows access to selected HiveMind services.
 * 
 * @author Howard Lewis Ship
 * @since 3.1
 */
public class InfrastructureImpl implements Infrastructure
{public static com.cortexeb.tools.clover.d __CLOVER_315_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1097439627296L);
    private IApplicationSpecification _applicationSpecification;

    private IPropertySource _applicationPropertySource;

    private ResetEventCoordinator _resetEventCoordinator;

    private ComponentMessagesSource _componentMessagesSource;

    private TemplateSource _templateSource;

    private ISpecificationSource _specificationSource;

    private ObjectPool _objectPool;

    private IComponentClassEnhancer _componentClassEnhancer;

    private IPageSource _pageSource;

    private ClassResolver _classResolver;

    private DataSqueezer _dataSqueezer;

    private IScriptSource _scriptSource;

    private ServiceMap _serviceMap;

    private RequestExceptionReporter _requestExceptionReporter;

    private ResponseRenderer _responseRenderer;

    public IScriptSource getScriptSource()
    {try { __CLOVER_315_0.M[3341]++;
        __CLOVER_315_0.S[14153]++;return _scriptSource;
    } finally { }}

    public void setScriptSource(IScriptSource scriptSource)
    {try { __CLOVER_315_0.M[3342]++;
        __CLOVER_315_0.S[14154]++;_scriptSource = scriptSource;
    } finally { }}

    public DataSqueezer getDataSqueezer()
    {try { __CLOVER_315_0.M[3343]++;
        __CLOVER_315_0.S[14155]++;return _dataSqueezer;

    } finally { }}

    public void setDataSqueezer(DataSqueezer dataSqueezer)
    {try { __CLOVER_315_0.M[3344]++;
        __CLOVER_315_0.S[14156]++;_dataSqueezer = dataSqueezer;
    } finally { }}

    public void setApplicationPropertySource(IPropertySource source)
    {try { __CLOVER_315_0.M[3345]++;
        __CLOVER_315_0.S[14157]++;_applicationPropertySource = source;
    } finally { }}

    public IPropertySource getApplicationPropertySource()
    {try { __CLOVER_315_0.M[3346]++;
        __CLOVER_315_0.S[14158]++;return _applicationPropertySource;
    } finally { }}

    public ComponentMessagesSource getComponentMessagesSource()
    {try { __CLOVER_315_0.M[3347]++;
        __CLOVER_315_0.S[14159]++;return _componentMessagesSource;
    } finally { }}

    public ResetEventCoordinator getResetEventCoordinator()
    {try { __CLOVER_315_0.M[3348]++;
        __CLOVER_315_0.S[14160]++;return _resetEventCoordinator;
    } finally { }}

    public void setComponentMessagesSource(ComponentMessagesSource source)
    {try { __CLOVER_315_0.M[3349]++;
        __CLOVER_315_0.S[14161]++;_componentMessagesSource = source;
    } finally { }}

    public void setResetEventCoordinator(ResetEventCoordinator coordinator)
    {try { __CLOVER_315_0.M[3350]++;
        __CLOVER_315_0.S[14162]++;_resetEventCoordinator = coordinator;
    } finally { }}

    public TemplateSource getTemplateSource()
    {try { __CLOVER_315_0.M[3351]++;
        __CLOVER_315_0.S[14163]++;return _templateSource;
    } finally { }}

    public void setTemplateSource(TemplateSource source)
    {try { __CLOVER_315_0.M[3352]++;
        __CLOVER_315_0.S[14164]++;_templateSource = source;
    } finally { }}

    public ISpecificationSource getSpecificationSource()
    {try { __CLOVER_315_0.M[3353]++;
        __CLOVER_315_0.S[14165]++;return _specificationSource;
    } finally { }}

    public void setSpecificationSource(ISpecificationSource source)
    {try { __CLOVER_315_0.M[3354]++;
        __CLOVER_315_0.S[14166]++;_specificationSource = source;
    } finally { }}

    public ObjectPool getObjectPool()
    {try { __CLOVER_315_0.M[3355]++;
        __CLOVER_315_0.S[14167]++;return _objectPool;
    } finally { }}

    public void setObjectPool(ObjectPool pool)
    {try { __CLOVER_315_0.M[3356]++;
        __CLOVER_315_0.S[14168]++;_objectPool = pool;
    } finally { }}

    public IComponentClassEnhancer getComponentClassEnhancer()
    {try { __CLOVER_315_0.M[3357]++;
        __CLOVER_315_0.S[14169]++;return _componentClassEnhancer;
    } finally { }}

    public void setComponentClassEnhancer(IComponentClassEnhancer enhancer)
    {try { __CLOVER_315_0.M[3358]++;
        __CLOVER_315_0.S[14170]++;_componentClassEnhancer = enhancer;
    } finally { }}

    public IApplicationSpecification getApplicationSpecification()
    {try { __CLOVER_315_0.M[3359]++;
        __CLOVER_315_0.S[14171]++;return _applicationSpecification;
    } finally { }}

    public void setApplicationSpecification(IApplicationSpecification specification)
    {try { __CLOVER_315_0.M[3360]++;
        __CLOVER_315_0.S[14172]++;_applicationSpecification = specification;
    } finally { }}

    public IPageSource getPageSource()
    {try { __CLOVER_315_0.M[3361]++;
        __CLOVER_315_0.S[14173]++;return _pageSource;
    } finally { }}

    public void setPageSource(IPageSource source)
    {try { __CLOVER_315_0.M[3362]++;
        __CLOVER_315_0.S[14174]++;_pageSource = source;
    } finally { }}

    public ClassResolver getClassResolver()
    {try { __CLOVER_315_0.M[3363]++;
        __CLOVER_315_0.S[14175]++;return _classResolver;
    } finally { }}

    public void setClassResolver(ClassResolver resolver)
    {try { __CLOVER_315_0.M[3364]++;
        __CLOVER_315_0.S[14176]++;_classResolver = resolver;
    } finally { }}

    public ServiceMap getServiceMap()
    {try { __CLOVER_315_0.M[3365]++;
        __CLOVER_315_0.S[14177]++;return _serviceMap;
    } finally { }}

    public void setServiceMap(ServiceMap serviceMap)
    {try { __CLOVER_315_0.M[3366]++;
        __CLOVER_315_0.S[14178]++;_serviceMap = serviceMap;
    } finally { }}

    public RequestExceptionReporter getRequestExceptionReporter()
    {try { __CLOVER_315_0.M[3367]++;
        __CLOVER_315_0.S[14179]++;return _requestExceptionReporter;
    } finally { }}

    public void setRequestExceptionReporter(RequestExceptionReporter requestExceptionReporter)
    {try { __CLOVER_315_0.M[3368]++;
        __CLOVER_315_0.S[14180]++;_requestExceptionReporter = requestExceptionReporter;
    } finally { }}

    public ResponseRenderer getResponseRenderer()
    {try { __CLOVER_315_0.M[3369]++;
        __CLOVER_315_0.S[14181]++;return _responseRenderer;
    } finally { }}

    public void setResponseRenderer(ResponseRenderer responseRenderer)
    {try { __CLOVER_315_0.M[3370]++;
        __CLOVER_315_0.S[14182]++;_responseRenderer = responseRenderer;
    } finally { }}
}