/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.spec;

import org.apache.tapestry.bean.ExpressionBeanInitializer;
import org.apache.tapestry.bean.IBeanInitializer;
import org.apache.tapestry.bean.MessageBeanInitializer;
import org.apache.tapestry.services.ExpressionEvaluator;

/**
 *  A Factory used by {@link org.apache.tapestry.parse.SpecificationParser} to create Tapestry
 *  domain objects.
 * 
 *  <p>
 *  The default implementation here creates the expected runtime
 *  instances of classes in packages:
 *  <ul>
 *  <li>org.apache.tapestry.spec</li>
 *  <li>org.apache.tapestry.bean</li>
 *  </ul>
 * 
 *  <p>
 *  This class is extended by Spindle - the Eclipse Plugin for Tapestry
 * 
 *  @author GWL
 *  @since 1.0.9
 * 
 **/

public class SpecFactory
{public static com.cortexeb.tools.clover.d __CLOVER_366_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1097439627296L);
    /**
     * Creates a concrete instance of {@link ApplicationSpecification}.
     **/

    public IApplicationSpecification createApplicationSpecification()
    {try { __CLOVER_366_0.M[3399]++;
        __CLOVER_366_0.S[14276]++;return new ApplicationSpecification();
    } finally { }}

    /**
     *  Creates an instance of {@link LibrarySpecification}.
     * 
     *  @since 2.2
     * 
     **/

    public ILibrarySpecification createLibrarySpecification()
    {try { __CLOVER_366_0.M[3400]++;
        __CLOVER_366_0.S[14277]++;return new LibrarySpecification();
    } finally { }}

	/**
	 *  Returns a new instance of {@link IAssetSpecification}.
	 * 
	 *  @since 3.0
	 * 
	 **/
	
	public IAssetSpecification createAssetSpecification()
	{try { __CLOVER_366_0.M[3401]++;
		__CLOVER_366_0.S[14278]++;return new AssetSpecification();
	} finally { }}

	/**
	 *  Creates a new instance of {@link IBeanSpecification}.
	 * 
	 *  @since 3.0
	 * 
	 **/
	
	public IBeanSpecification createBeanSpecification()
	{try { __CLOVER_366_0.M[3402]++;
		__CLOVER_366_0.S[14279]++;return new BeanSpecification();
	} finally { }}

	public IBindingSpecification createBindingSpecification() 
	{try { __CLOVER_366_0.M[3403]++;
		__CLOVER_366_0.S[14280]++;return new BindingSpecification();
	} finally { }}

    /**
     *  Creates a new concrete instance of {@link IListenerBindingSpecification} for the
     *  given language (which is option) and script.
     * 
     *  @since 3.0
     *  
     **/

    public IListenerBindingSpecification createListenerBindingSpecification()
    {try { __CLOVER_366_0.M[3404]++;
        __CLOVER_366_0.S[14281]++;return new ListenerBindingSpecification();
    } finally { }}

    /**
     * Creates a concrete instance of {@link IComponentSpecification}.
     **/

    public IComponentSpecification createComponentSpecification()
    {try { __CLOVER_366_0.M[3405]++;
        __CLOVER_366_0.S[14282]++;return new ComponentSpecification();
    } finally { }}

    /**
     * Creates a concrete instance of {@link IContainedComponent}.
     **/

    public IContainedComponent createContainedComponent()
    {try { __CLOVER_366_0.M[3406]++;
        __CLOVER_366_0.S[14283]++;return new ContainedComponent();
    } finally { }}

    /**
     * Creates a concrete instance of {@link ParameterSpecification}.
     **/

    public IParameterSpecification createParameterSpecification()
    {try { __CLOVER_366_0.M[3407]++;
        __CLOVER_366_0.S[14284]++;return new ParameterSpecification();
    } finally { }}

	/**
	 *  Creates a new instance of {@link ExpressionBeanInitializer}.
	 * 
	 *  @since 3.0
	 * 
	 **/
	
	public IBeanInitializer createExpressionBeanInitializer(ExpressionEvaluator evaluator)
	{try { __CLOVER_366_0.M[3408]++;
		__CLOVER_366_0.S[14285]++;return new ExpressionBeanInitializer(evaluator);
	} finally { }}

	/**
	 *  Returns a new instance of {@link MessageBeanInitializer}.
	 * 
	 *  @since 3.0
	 * 
	 **/
	
	public IBeanInitializer createMessageBeanInitializer()
	{try { __CLOVER_366_0.M[3409]++;
		__CLOVER_366_0.S[14286]++;return new MessageBeanInitializer();
	} finally { }}

    /**
     *  Creates a concrete instance of {@link org.apache.tapestry.spec.IExtensionSpecification}.
     * 
     *  @since 2.2
     * 
     **/

    public IExtensionSpecification createExtensionSpecification(ExpressionEvaluator evaluator)
    {try { __CLOVER_366_0.M[3410]++;
        __CLOVER_366_0.S[14287]++;return new ExtensionSpecification(evaluator);
    } finally { }}
    
    /**
     *  Creates a concrete instance of {@link org.apache.tapestry.spec.IPropertySpecification}.
     * 
     *  @since 3.0
     * 
     **/
    
    public IPropertySpecification createPropertySpecification()
    {try { __CLOVER_366_0.M[3411]++;
    	__CLOVER_366_0.S[14288]++;return new PropertySpecification();
    } finally { }}
}