/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.hivemind.HiveMind;
import org.apache.hivemind.Location;

/**
 *  A general exception describing an {@link IBinding}
 *  and an {@link IComponent}.
 *
 *  @author Howard Lewis Ship
 *
 **/

public class BindingException extends ApplicationRuntimeException
{public static com.cortexeb.tools.clover.d __CLOVER_5_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private transient IBinding _binding;

    public BindingException(String message, IBinding binding)
    {
        this(message, binding, null);__CLOVER_5_0.S[530]++;try { __CLOVER_5_0.M[147]++;
    } finally { }}

    public BindingException(String message, IBinding binding, Throwable rootCause)
    {
        this(message, null, null, binding, rootCause);__CLOVER_5_0.S[531]++;try { __CLOVER_5_0.M[148]++;
    } finally { }}


    public BindingException(
        String message,
        Object component,
        Location location,
        IBinding binding,
        Throwable rootCause)
    {
        super(
            message,
            component,
            HiveMind.findLocation(new Object[] { location, binding, component }),
            rootCause);__CLOVER_5_0.S[532]++;try { __CLOVER_5_0.M[149]++;

        __CLOVER_5_0.S[533]++;_binding = binding;
    } finally { }}

    public IBinding getBinding()
    {try { __CLOVER_5_0.M[150]++;
        __CLOVER_5_0.S[534]++;return _binding;
    } finally { }}
}