/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry;

import org.apache.hivemind.ApplicationRuntimeException;

/**
 *  Exception thrown to force a redirection to an arbitrary location.
 *  This is used when, after processing a request (such as a form
 *  submission or a link being clicked), it is desirable to go
 *  to some arbitrary new location.
 *
 *  @author Howard Lewis Ship
 *  @since 1.0.6
 *
 **/

public class RedirectException extends ApplicationRuntimeException
{public static com.cortexeb.tools.clover.d __CLOVER_28_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
	private String _redirectLocation;

	public RedirectException(String redirectLocation)
	{
		this(null, redirectLocation);__CLOVER_28_0.S[540]++;try { __CLOVER_28_0.M[155]++;
	} finally { }}

	/** 
	 *  @param message A message describing why the redirection is taking place.
	 *  @param redirectLocation The location to redirect to, may be a relative path (relative
	 *  to the {@link javax.servlet.ServletContext}).
	 *
	 *  @see javax.servlet.http.HttpServletResponse#sendRedirect(String)
	 *  @see javax.servlet.http.HttpServletResponse#encodeRedirectURL(String)
	 *
	 **/

	public RedirectException(String message, String redirectLocation)
	{
		super(message);__CLOVER_28_0.S[541]++;try { __CLOVER_28_0.M[156]++;

		__CLOVER_28_0.S[542]++;_redirectLocation = redirectLocation;
	} finally { }}

	public String getRedirectLocation()
	{try { __CLOVER_28_0.M[157]++;
		__CLOVER_28_0.S[543]++;return _redirectLocation;
	} finally { }}
}