/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * Filter used to redirect a root context URL (i.e., "/context" or "/context/"
 * to the Tapestry application servlet (typically, "/context/app").  This
 * servlet is mapped to "/" and must have a &lt;init-parameter&;gt; 
 * <code>redirect-path</code> that is the application servlet's path (i.e.,
 * "/app").  If no value is specified, then "/app" is used.  The path
 * is always relative to the servlet context, and should always
 * begin with a leading slash.
 *  
 * <p>Filters are only available in Servlet API 2.3 and above.
 * 
 * <p>Servlet API 2.4 is expected to allow a servlets in the welcome list
 * (equivalent to index.html or index.jsp), at which point this filter
 * should no longer be necessary.
 *
 * @author Howard Lewis Ship
 * @since 3.0
 */

public class RedirectFilter implements Filter
{public static com.cortexeb.tools.clover.d __CLOVER_29_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private static final Log LOG = LogFactory.getLog(RedirectFilter.class);
    public static final String REDIRECT_PATH_PARAM = "redirect-path";

    private String _redirectPath;

    public void init(FilterConfig config) throws ServletException
    {try { __CLOVER_29_0.M[158]++;
        __CLOVER_29_0.S[544]++;_redirectPath = config.getInitParameter(REDIRECT_PATH_PARAM);

        __CLOVER_29_0.S[545]++;if ((((Tapestry.isBlank(_redirectPath)) && (++__CLOVER_29_0.CT[113] != 0)) || (++__CLOVER_29_0.CF[113] == 0))){
            __CLOVER_29_0.S[546]++;_redirectPath = "/app";}

        __CLOVER_29_0.S[547]++;if ((((LOG.isDebugEnabled()) && (++__CLOVER_29_0.CT[114] != 0)) || (++__CLOVER_29_0.CF[114] == 0))){
            __CLOVER_29_0.S[548]++;LOG.debug(Tapestry.format("RedirectServlet.redirect-path", _redirectPath));}
    } finally { }}

    public void destroy()
    {try { __CLOVER_29_0.M[159]++;

    } finally { }}

    /**
     * This filter intercepts the so-called "default" servlet, whose job is
     * to provide access to standard resources packaged within the web application
     * context.  This code is interested in only the very root, redirecting
     * to the appropriate Tapestry application servlet.  Other values
     * are passed through unchanged.
     */
    public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain)
        throws IOException, ServletException
    {try { __CLOVER_29_0.M[160]++;
        __CLOVER_29_0.S[549]++;HttpServletRequest hrequest = (HttpServletRequest) request;
        __CLOVER_29_0.S[550]++;HttpServletResponse hresponse = (HttpServletResponse) response;

        __CLOVER_29_0.S[551]++;String servletPath = hrequest.getServletPath();
        __CLOVER_29_0.S[552]++;String pathInfo = hrequest.getPathInfo();

        // Been experimenting with different servlet containers.  In Jetty 4.2.8 and Tomcat 4.1,
        // resources have a non-null servletPath.  If JBossWeb 3.0.6, the servletPath is
        // null and the pathInfo indicates the relative location of the resource.

        __CLOVER_29_0.S[553]++;if (((((Tapestry.isBlank(servletPath) || servletPath.equals("/"))
            && (Tapestry.isBlank(pathInfo) || pathInfo.equals("/"))) && (++__CLOVER_29_0.CT[115] != 0)) || (++__CLOVER_29_0.CF[115] == 0))){
        {
            __CLOVER_29_0.S[554]++;String path = hrequest.getContextPath() + _redirectPath;

            __CLOVER_29_0.S[555]++;if ((((LOG.isDebugEnabled()) && (++__CLOVER_29_0.CT[116] != 0)) || (++__CLOVER_29_0.CF[116] == 0))){
                __CLOVER_29_0.S[556]++;LOG.debug(Tapestry.format("RedirectServlet.redirecting", path));}

            __CLOVER_29_0.S[557]++;hresponse.sendRedirect(path);
            __CLOVER_29_0.S[558]++;return;
        }}

        __CLOVER_29_0.S[559]++;chain.doFilter(request, response);
    } finally { }}

}
