/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry;

import org.apache.hivemind.ApplicationRuntimeException;

/**
 *  Exception thrown by an {@link org.apache.tapestry.engine.IEngineService} when it discovers that
 *  the {@link javax.servlet.http.HttpSession}
 *  has timed out (and been replaced by a new, empty
 *  one).
 *
 *  <p>The application should redirect to the stale-session page.
 *
 *
 *  @author Howard Lewis Ship
 *
 **/

public class StaleSessionException extends ApplicationRuntimeException
{public static com.cortexeb.tools.clover.d __CLOVER_32_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private transient IPage _page;
    private String _pageName;

    public StaleSessionException()
    {
        this(null, null);__CLOVER_32_0.S[575]++;try { __CLOVER_32_0.M[170]++;
    } finally { }}

    public StaleSessionException(String message, IPage page)
    {
        super(message, page, null, null);__CLOVER_32_0.S[576]++;try { __CLOVER_32_0.M[171]++;
        __CLOVER_32_0.S[577]++;_page = page;

        __CLOVER_32_0.S[578]++;if ((((page != null) && (++__CLOVER_32_0.CT[117] != 0)) || (++__CLOVER_32_0.CF[117] == 0))){
            __CLOVER_32_0.S[579]++;_pageName = page.getPageName();}
    } finally { }}

    public String getPageName()
    {try { __CLOVER_32_0.M[172]++;
        __CLOVER_32_0.S[580]++;return _pageName;
    } finally { }}

    /**
     *  Returns the page referenced by the service URL, if known, or null otherwise.
     *
     **/

    public IPage getPage()
    {try { __CLOVER_32_0.M[173]++;
        __CLOVER_32_0.S[581]++;return _page;
    } finally { }}
}