/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.asset;

import java.io.InputStream;
import java.net.URL;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.hivemind.Location;
import org.apache.tapestry.IAsset;
import org.apache.tapestry.IEngine;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.Tapestry;
import org.apache.tapestry.resource.ContextResource;

/**
 *  An asset whose path is relative to the {@link javax.servlet.ServletContext} containing
 *  the application.
 *
 *  @author Howard Lewis Ship
 **/

public class ContextAsset extends AbstractAsset implements IAsset
{public static com.cortexeb.tools.clover.d __CLOVER_38_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private String _resolvedURL;

    public ContextAsset(ContextResource resourceLocation, Location location)
    {
        super(resourceLocation, location);__CLOVER_38_0.S[971]++;try { __CLOVER_38_0.M[245]++;
    } finally { }}

    /**
     *  Generates a URL for the client to retrieve the asset.  The context path
     *  is prepended to the asset path, which means that assets deployed inside
     *  web applications will still work (if things are configured properly).
     *
     **/

    public String buildURL(IRequestCycle cycle)
    {try { __CLOVER_38_0.M[246]++;
        __CLOVER_38_0.S[972]++;if ((((_resolvedURL == null) && (++__CLOVER_38_0.CT[191] != 0)) || (++__CLOVER_38_0.CF[191] == 0))){
        {
            __CLOVER_38_0.S[973]++;IEngine engine = cycle.getEngine();
            __CLOVER_38_0.S[974]++;String contextPath = engine.getContextPath();

            __CLOVER_38_0.S[975]++;_resolvedURL = contextPath + getResourceLocation().getPath();
        }}
        
        __CLOVER_38_0.S[976]++;return _resolvedURL;
    } finally { }}

    public InputStream getResourceAsStream(IRequestCycle cycle)
    {try { __CLOVER_38_0.M[247]++;
        __CLOVER_38_0.S[977]++;try
        {
            __CLOVER_38_0.S[978]++;URL url = getResourceLocation().getResourceURL();

            __CLOVER_38_0.S[979]++;return url.openStream();
        }
        catch (Exception ex)
        {
            __CLOVER_38_0.S[980]++;throw new ApplicationRuntimeException(
                Tapestry.format("ContextAsset.resource-missing", getResourceLocation()),
                ex);
        }
    } finally { }}
}