/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.bean;

import org.apache.tapestry.IBinding;

/**
 *  A helper bean to assist with providing defaults for unspecified
 *  parameters.    It is initalized
 *  with an {@link IBinding} and a default value.  It's value property
 *  is either the value of the binding, but if the binding is null,
 *  or the binding returns null, the default value is returned.
 *
 *  @author Howard Lewis Ship
 *  @since 1.0.5
 * 
 **/

public class Default
{public static com.cortexeb.tools.clover.d __CLOVER_44_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private IBinding binding;
    private Object defaultValue;

    public void resetForPool()
    {try { __CLOVER_44_0.M[271]++;
        __CLOVER_44_0.S[1093]++;binding = null;
        __CLOVER_44_0.S[1094]++;defaultValue = null;
    } finally { }}

    public void setBinding(IBinding value)
    {try { __CLOVER_44_0.M[272]++;
        __CLOVER_44_0.S[1095]++;binding = value;
    } finally { }}

    public IBinding getBinding()
    {try { __CLOVER_44_0.M[273]++;
        __CLOVER_44_0.S[1096]++;return binding;
    } finally { }}

    public void setDefaultValue(Object value)
    {try { __CLOVER_44_0.M[274]++;
        __CLOVER_44_0.S[1097]++;defaultValue = value;
    } finally { }}

    public Object getDefaultValue()
    {try { __CLOVER_44_0.M[275]++;
        __CLOVER_44_0.S[1098]++;return defaultValue;
    } finally { }}

    /**
     *  Returns the value of the binding.  However, if the binding is null, or the binding
     *  returns null, then the defaultValue is returned instead.
     *
     **/

    public Object getValue()
    {try { __CLOVER_44_0.M[276]++;
        __CLOVER_44_0.S[1099]++;if ((((binding == null) && (++__CLOVER_44_0.CT[215] != 0)) || (++__CLOVER_44_0.CF[215] == 0))){
            __CLOVER_44_0.S[1100]++;return defaultValue;}

        __CLOVER_44_0.S[1101]++;Object value = binding.getObject();

        __CLOVER_44_0.S[1102]++;if ((((value == null) && (++__CLOVER_44_0.CT[216] != 0)) || (++__CLOVER_44_0.CF[216] == 0))){
            __CLOVER_44_0.S[1103]++;return defaultValue;}

        __CLOVER_44_0.S[1104]++;return value;
    } finally { }}
    
    /** @since 3.0 **/
    
    public void discardFromPool()
    {try { __CLOVER_44_0.M[277]++;
    } finally { }}

}