/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.binding;

import org.apache.hivemind.Location;

/**
 * Stores a static (invariant) String as the value.
 *
 * <p>It may be useful to cache static bindings the way {@link FieldBinding}s are cached.
 *
 * @author Howard Lewis Ship
 * 
 **/

public class StaticBinding extends AbstractBinding
{public static com.cortexeb.tools.clover.d __CLOVER_54_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private String _value;
    private boolean _parsedInt;
    private int _intValue;
    private boolean _parsedDouble;
    private double _doubleValue;

    public StaticBinding(String value, Location location)
    {
    	super(location);__CLOVER_54_0.S[1370]++;try { __CLOVER_54_0.M[332]++;
    	
        __CLOVER_54_0.S[1371]++;_value = value;
    } finally { }}

    /**
     *  Interprets the static value as an integer.
     *
     **/

    public int getInt()
    {try { __CLOVER_54_0.M[333]++;
        __CLOVER_54_0.S[1372]++;if ((((!_parsedInt) && (++__CLOVER_54_0.CT[268] != 0)) || (++__CLOVER_54_0.CF[268] == 0))){
        {
            __CLOVER_54_0.S[1373]++;_intValue = Integer.parseInt(_value);
            __CLOVER_54_0.S[1374]++;_parsedInt = true;
        }}

        __CLOVER_54_0.S[1375]++;return _intValue;
    } finally { }}

    /**
     *  Interprets the static value as a double.
     *
     **/

    public double getDouble()
    {try { __CLOVER_54_0.M[334]++;
        __CLOVER_54_0.S[1376]++;if ((((!_parsedDouble) && (++__CLOVER_54_0.CT[269] != 0)) || (++__CLOVER_54_0.CF[269] == 0))){
        {
            __CLOVER_54_0.S[1377]++;_doubleValue = Double.parseDouble(_value);
            __CLOVER_54_0.S[1378]++;_parsedDouble = true;
        }}

        __CLOVER_54_0.S[1379]++;return _doubleValue;
    } finally { }}

    public String getString()
    {try { __CLOVER_54_0.M[335]++;
        __CLOVER_54_0.S[1380]++;return _value;
    } finally { }}

    public Object getObject()
    {try { __CLOVER_54_0.M[336]++;
        __CLOVER_54_0.S[1381]++;return _value;
    } finally { }}

    public String toString()
    {try { __CLOVER_54_0.M[337]++;
        __CLOVER_54_0.S[1382]++;return "StaticBinding[" + _value + "]";
    } finally { }}
}