/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.components;

import org.apache.tapestry.AbstractComponent;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.Tapestry;

/**
 *  A conditional element on a page which will render its wrapped elements
 *  zero or one times.
 *
 *  [<a href="../../../../../ComponentReference/Conditional.html">Component Reference</a>]
 *
 *  @author Howard Lewis Ship, David Solis
 * 
 **/

public abstract class Conditional extends AbstractComponent 
{public static com.cortexeb.tools.clover.d __CLOVER_63_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
	/**
	 *  Renders its wrapped components only if the condition is true (technically,
	 *  if condition matches invert). 
	 *  Additionally, if element is specified, can emulate that HTML element if condition is met
	 *
	 **/

	protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle) 
	{try { __CLOVER_63_0.M[361]++;
		__CLOVER_63_0.S[1457]++;if ((((evaluateCondition()) && (++__CLOVER_63_0.CT[277] != 0)) || (++__CLOVER_63_0.CF[277] == 0))){ 
		{
			__CLOVER_63_0.S[1458]++;String element = getElement();
			
			__CLOVER_63_0.S[1459]++;boolean render = !cycle.isRewinding() && Tapestry.isNonBlank(element);
			
			__CLOVER_63_0.S[1460]++;if ((((render) && (++__CLOVER_63_0.CT[278] != 0)) || (++__CLOVER_63_0.CF[278] == 0))){
			{
				__CLOVER_63_0.S[1461]++;writer.begin(element);
				__CLOVER_63_0.S[1462]++;renderInformalParameters(writer, cycle);
			}}

			__CLOVER_63_0.S[1463]++;renderBody(writer, cycle);
			
			__CLOVER_63_0.S[1464]++;if ((((render) && (++__CLOVER_63_0.CT[279] != 0)) || (++__CLOVER_63_0.CF[279] == 0))){
				__CLOVER_63_0.S[1465]++;writer.end(element);}
		}}
	} finally { }}
	
	protected boolean evaluateCondition()
	{try { __CLOVER_63_0.M[362]++;
		__CLOVER_63_0.S[1466]++;return getCondition() != getInvert();
	} finally { }}

	public abstract boolean getCondition();
	public abstract boolean getInvert();

	public abstract String getElement();
}