/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.components;

import java.text.Format;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.tapestry.AbstractComponent;
import org.apache.tapestry.IBinding;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.Tapestry;

/**
 *  Used to insert some text (from a parameter) into the HTML.
 *
 *  [<a href="../../../../../ComponentReference/Insert.html">Component Reference</a>]
 *
 *  @author Howard Lewis Ship
 * 
 **/

public abstract class Insert extends AbstractComponent
{public static com.cortexeb.tools.clover.d __CLOVER_67_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    public abstract IBinding getFormatBinding();

    /**
     *  Prints its value parameter, possibly formatted by its format parameter.
     *
     **/

    protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle)
    {try { __CLOVER_67_0.M[368]++;
        __CLOVER_67_0.S[1507]++;if ((((cycle.isRewinding()) && (++__CLOVER_67_0.CT[290] != 0)) || (++__CLOVER_67_0.CF[290] == 0))){
            __CLOVER_67_0.S[1508]++;return;}

        __CLOVER_67_0.S[1509]++;Object value = getValue();

        __CLOVER_67_0.S[1510]++;if ((((value == null) && (++__CLOVER_67_0.CT[291] != 0)) || (++__CLOVER_67_0.CF[291] == 0))){
            __CLOVER_67_0.S[1511]++;return;}

        __CLOVER_67_0.S[1512]++;String insert = null;

        __CLOVER_67_0.S[1513]++;Format format = getFormat();

        __CLOVER_67_0.S[1514]++;if ((((format == null) && (++__CLOVER_67_0.CT[292] != 0)) || (++__CLOVER_67_0.CF[292] == 0))){
        {
            __CLOVER_67_0.S[1515]++;insert = value.toString();
        }}
        else{
        {
            __CLOVER_67_0.S[1516]++;try
            {
                __CLOVER_67_0.S[1517]++;insert = format.format(value);
            }
            catch (Exception ex)
            {
                __CLOVER_67_0.S[1518]++;throw new ApplicationRuntimeException(
                    Tapestry.format("Insert.unable-to-format", value),
                    this,
                    getFormatBinding().getLocation(),
                    ex);
            }
        }}

        __CLOVER_67_0.S[1519]++;String styleClass = getStyleClass();

        __CLOVER_67_0.S[1520]++;if ((((styleClass != null) && (++__CLOVER_67_0.CT[293] != 0)) || (++__CLOVER_67_0.CF[293] == 0))){
        {
            __CLOVER_67_0.S[1521]++;writer.begin("span");
            __CLOVER_67_0.S[1522]++;writer.attribute("class", styleClass);

            __CLOVER_67_0.S[1523]++;renderInformalParameters(writer, cycle);
        }}

        __CLOVER_67_0.S[1524]++;if ((((getRaw()) && (++__CLOVER_67_0.CT[294] != 0)) || (++__CLOVER_67_0.CF[294] == 0))){
            __CLOVER_67_0.S[1525]++;writer.printRaw(insert);}
        else{
            __CLOVER_67_0.S[1526]++;writer.print(insert);}

        __CLOVER_67_0.S[1527]++;if ((((styleClass != null) && (++__CLOVER_67_0.CT[295] != 0)) || (++__CLOVER_67_0.CF[295] == 0))){
            __CLOVER_67_0.S[1528]++;writer.end();} // <span>
    } finally { }}

    public abstract Object getValue();

    public abstract Format getFormat();

    public abstract String getStyleClass();

    public abstract boolean getRaw();

}