/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.engine;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpSession;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.tapestry.IComponent;
import org.apache.tapestry.IDirect;
import org.apache.tapestry.IPage;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.StaleSessionException;
import org.apache.tapestry.Tapestry;
import org.apache.tapestry.request.RequestContext;
import org.apache.tapestry.request.ResponseOutputStream;

/**
 *  Implementation of the direct service, which encodes the page and component id in
 *  the service context, and passes application-defined parameters as well.
 *
 *  @author Howard Lewis Ship
 *  @since 1.0.9
 *
 **/

public class DirectService extends AbstractService
{public static com.cortexeb.tools.clover.d __CLOVER_80_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    /**
     *  Encoded into URL if engine was stateful.
     * 
     *  @since 3.0
     **/

    private static final String STATEFUL_ON = "1";

    /**
     *  Encoded into URL if engine was not stateful.
     * 
     *  @since 3.0
     **/

    private static final String STATEFUL_OFF = "0";

    public ILink getLink(IRequestCycle cycle, IComponent component, Object[] parameters)
    {try { __CLOVER_80_0.M[460]++;

        // New since 1.0.1, we use the component to determine
        // the page, not the cycle.  Through the use of tricky
        // things such as Block/InsertBlock, it is possible 
        // that a component from a page different than
        // the response page will render.
        // In 1.0.6, we start to record *both* the render page
        // and the component page (if different), as the extended
        // context.

        __CLOVER_80_0.S[1998]++;IPage renderPage = cycle.getPage();
        __CLOVER_80_0.S[1999]++;IPage componentPage = component.getPage();

        __CLOVER_80_0.S[2000]++;boolean complex = renderPage != componentPage;

        __CLOVER_80_0.S[2001]++;String[] context = (((complex ) && (++__CLOVER_80_0.CT[375] != 0)) || (++__CLOVER_80_0.CF[375] == 0))? new String[4] : new String[3];

        __CLOVER_80_0.S[2002]++;int i = 0;

        __CLOVER_80_0.S[2003]++;String stateful = (((cycle.getEngine().isStateful() ) && (++__CLOVER_80_0.CT[376] != 0)) || (++__CLOVER_80_0.CF[376] == 0))? STATEFUL_ON : STATEFUL_OFF;

        __CLOVER_80_0.S[2004]++;context[i++] = stateful;

        __CLOVER_80_0.S[2005]++;if ((((complex) && (++__CLOVER_80_0.CT[377] != 0)) || (++__CLOVER_80_0.CF[377] == 0))){
            __CLOVER_80_0.S[2006]++;context[i++] = renderPage.getPageName();}

        __CLOVER_80_0.S[2007]++;context[i++] = componentPage.getPageName();
        __CLOVER_80_0.S[2008]++;context[i++] = component.getIdPath();

        __CLOVER_80_0.S[2009]++;return constructLink(cycle, Tapestry.DIRECT_SERVICE, context, parameters, true);
    } finally { }}

    public void service(
        IEngineServiceView engine,
        IRequestCycle cycle,
        ResponseOutputStream output)
        throws ServletException, IOException
    {try { __CLOVER_80_0.M[461]++;
        __CLOVER_80_0.S[2010]++;IDirect direct;
        __CLOVER_80_0.S[2011]++;int count = 0;
        __CLOVER_80_0.S[2012]++;String componentPageName;
        __CLOVER_80_0.S[2013]++;IPage componentPage;
        __CLOVER_80_0.S[2014]++;RequestContext requestContext = cycle.getRequestContext();
        __CLOVER_80_0.S[2015]++;String[] serviceContext = getServiceContext(requestContext);

        __CLOVER_80_0.S[2016]++;if ((((serviceContext != null) && (++__CLOVER_80_0.CT[378] != 0)) || (++__CLOVER_80_0.CF[378] == 0))){
            __CLOVER_80_0.S[2017]++;count = serviceContext.length;}

        __CLOVER_80_0.S[2018]++;if ((((count != 3 && count != 4) && (++__CLOVER_80_0.CT[379] != 0)) || (++__CLOVER_80_0.CF[379] == 0))){
            __CLOVER_80_0.S[2019]++;throw new ApplicationRuntimeException(
                Tapestry.getMessage("DirectService.context-parameters"));}

        __CLOVER_80_0.S[2020]++;boolean complex = count == 4;

        __CLOVER_80_0.S[2021]++;int i = 0;
        __CLOVER_80_0.S[2022]++;String stateful = serviceContext[i++];
        __CLOVER_80_0.S[2023]++;String pageName = serviceContext[i++];

        __CLOVER_80_0.S[2024]++;if ((((complex) && (++__CLOVER_80_0.CT[380] != 0)) || (++__CLOVER_80_0.CF[380] == 0))){
            __CLOVER_80_0.S[2025]++;componentPageName = serviceContext[i++];}
        else{
            __CLOVER_80_0.S[2026]++;componentPageName = pageName;}

        __CLOVER_80_0.S[2027]++;String componentPath = serviceContext[i++];

        __CLOVER_80_0.S[2028]++;IPage page = cycle.getPage(pageName);

        __CLOVER_80_0.S[2029]++;cycle.activate(page);

        __CLOVER_80_0.S[2030]++;if ((((complex) && (++__CLOVER_80_0.CT[381] != 0)) || (++__CLOVER_80_0.CF[381] == 0))){
            __CLOVER_80_0.S[2031]++;componentPage = cycle.getPage(componentPageName);}
        else{
            __CLOVER_80_0.S[2032]++;componentPage = page;}

        __CLOVER_80_0.S[2033]++;IComponent component = componentPage.getNestedComponent(componentPath);

        __CLOVER_80_0.S[2034]++;try
        {
            __CLOVER_80_0.S[2035]++;direct = (IDirect) component;
        }
        catch (ClassCastException ex)
        {
            __CLOVER_80_0.S[2036]++;throw new ApplicationRuntimeException(
                Tapestry.format("DirectService.component-wrong-type", component.getExtendedId()),
                component,
                null,
                ex);
        }

        // Check for a StateSession only the session was stateful when
        // the Gesture was created.

        __CLOVER_80_0.S[2037]++;if ((((stateful.equals(STATEFUL_ON) && direct.isStateful()) && (++__CLOVER_80_0.CT[382] != 0)) || (++__CLOVER_80_0.CF[382] == 0))){
        {
            __CLOVER_80_0.S[2038]++;HttpSession session = cycle.getRequestContext().getSession();

            __CLOVER_80_0.S[2039]++;if ((((session == null || session.isNew()) && (++__CLOVER_80_0.CT[383] != 0)) || (++__CLOVER_80_0.CF[383] == 0))){
                __CLOVER_80_0.S[2040]++;throw new StaleSessionException(
                    Tapestry.format(
                        "DirectService.stale-session-exception",
                        direct.getExtendedId()),
                    direct.getPage());}
        }}

        __CLOVER_80_0.S[2041]++;Object[] parameters = getParameters(cycle);

        __CLOVER_80_0.S[2042]++;cycle.setServiceParameters(parameters);
        __CLOVER_80_0.S[2043]++;direct.trigger(cycle);

        // Render the response.  This will be the response page (the first element in the context)
        // unless the direct (or its delegate) changes it.

        __CLOVER_80_0.S[2044]++;engine.renderResponse(cycle, output);
    } finally { }}

    public String getName()
    {try { __CLOVER_80_0.M[462]++;
        __CLOVER_80_0.S[2045]++;return Tapestry.DIRECT_SERVICE;
    } finally { }}
}