/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.engine;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.Tapestry;
import org.apache.tapestry.request.RequestContext;

/**
 * Used by {@link org.apache.tapestry.engine.AbstractEngine} when
 * processing a {@link org.apache.tapestry.RedirectException}.
 * 
 * @author Howard Lewis Ship
 * @since 3.0
 */
class RedirectAnalyzer
{public static com.cortexeb.tools.clover.d __CLOVER_101_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private boolean _internal;

    private String _location;

    public RedirectAnalyzer(String location)
    {try { __CLOVER_101_0.M[544]++;
        __CLOVER_101_0.S[2262]++;if ((((Tapestry.isBlank(location)) && (++__CLOVER_101_0.CT[421] != 0)) || (++__CLOVER_101_0.CF[421] == 0))){
        {
            __CLOVER_101_0.S[2263]++;_location = "";
            __CLOVER_101_0.S[2264]++;_internal = true;

            __CLOVER_101_0.S[2265]++;return;
        }}

        __CLOVER_101_0.S[2266]++;_location = location;

        __CLOVER_101_0.S[2267]++;_internal = !(location.startsWith("/") || location.indexOf("://") > 0);
    } finally { }}

    public void process(IRequestCycle cycle)
    {try { __CLOVER_101_0.M[545]++;
        __CLOVER_101_0.S[2268]++;RequestContext context = cycle.getRequestContext();

        __CLOVER_101_0.S[2269]++;if ((((_internal) && (++__CLOVER_101_0.CT[422] != 0)) || (++__CLOVER_101_0.CF[422] == 0))){
            __CLOVER_101_0.S[2270]++;forward(context);}
        else{
            __CLOVER_101_0.S[2271]++;redirect(context);}
    } finally { }}

    private void forward(RequestContext context)
    {try { __CLOVER_101_0.M[546]++;
        __CLOVER_101_0.S[2272]++;HttpServletRequest request = context.getRequest();
        __CLOVER_101_0.S[2273]++;HttpServletResponse response = context.getResponse();

        __CLOVER_101_0.S[2274]++;RequestDispatcher dispatcher = request.getRequestDispatcher("/" + _location);

        __CLOVER_101_0.S[2275]++;if ((((dispatcher == null) && (++__CLOVER_101_0.CT[423] != 0)) || (++__CLOVER_101_0.CF[423] == 0))){
            __CLOVER_101_0.S[2276]++;throw new ApplicationRuntimeException(Tapestry.format(
                    "AbstractEngine.unable-to-find-dispatcher",
                    _location));}

        __CLOVER_101_0.S[2277]++;try
        {
            __CLOVER_101_0.S[2278]++;dispatcher.forward(request, response);
        }
        catch (ServletException ex)
        {
            __CLOVER_101_0.S[2279]++;throw new ApplicationRuntimeException(Tapestry.format(
                    "AbstractEngine.unable-to-forward",
                    _location), ex);
        }
        catch (IOException ex)
        {
            __CLOVER_101_0.S[2280]++;throw new ApplicationRuntimeException(Tapestry.format(
                    "AbstractEngine.unable-to-forward",
                    _location), ex);
        }
    } finally { }}

    private void redirect(RequestContext context)
    {try { __CLOVER_101_0.M[547]++;
        __CLOVER_101_0.S[2281]++;HttpServletResponse response = context.getResponse();

        __CLOVER_101_0.S[2282]++;String finalURL = response.encodeRedirectURL(_location);

        __CLOVER_101_0.S[2283]++;try
        {
            __CLOVER_101_0.S[2284]++;response.sendRedirect(finalURL);
        }
        catch (IOException ex)
        {
            __CLOVER_101_0.S[2285]++;throw new ApplicationRuntimeException(Tapestry.format(
                    "AbstractEngine.unable-to-redirect",
                    _location), ex);
        }
    } finally { }}

}