/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.form;

import org.apache.tapestry.IForm;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;

/**
 *  Implements a component that manages an HTML &lt;input type=button&gt; form element.
 *
 *  [<a href="../../../../../ComponentReference/Button.html">Component Reference</a>]
 *  
 *  <p>This component is useful for attaching JavaScript onclick event handlers.
 *
 *  @author Howard Lewis Ship
 *  @author Paul Geerts
 *  @author Malcolm Edgar
 **/

public abstract class Button extends AbstractFormComponent
{public static com.cortexeb.tools.clover.d __CLOVER_126_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle)
    {try { __CLOVER_126_0.M[673]++;
        __CLOVER_126_0.S[2908]++;IForm form = getForm(cycle);

        __CLOVER_126_0.S[2909]++;boolean rewinding = form.isRewinding();

        __CLOVER_126_0.S[2910]++;String name = form.getElementId(this);

        __CLOVER_126_0.S[2911]++;if ((((rewinding) && (++__CLOVER_126_0.CT[527] != 0)) || (++__CLOVER_126_0.CF[527] == 0))){
        {
            __CLOVER_126_0.S[2912]++;return;
        }}

        __CLOVER_126_0.S[2913]++;writer.beginEmpty("input");
        __CLOVER_126_0.S[2914]++;writer.attribute("type", "button");
        __CLOVER_126_0.S[2915]++;writer.attribute("name", name);

        __CLOVER_126_0.S[2916]++;if ((((isDisabled()) && (++__CLOVER_126_0.CT[528] != 0)) || (++__CLOVER_126_0.CF[528] == 0))){
        {
            __CLOVER_126_0.S[2917]++;writer.attribute("disabled", "disabled");
        }}

        __CLOVER_126_0.S[2918]++;String label = getLabel();

        __CLOVER_126_0.S[2919]++;if ((((label != null) && (++__CLOVER_126_0.CT[529] != 0)) || (++__CLOVER_126_0.CF[529] == 0))){
        {
            __CLOVER_126_0.S[2920]++;writer.attribute("value", label);
        }}

        __CLOVER_126_0.S[2921]++;renderInformalParameters(writer, cycle);

        __CLOVER_126_0.S[2922]++;writer.closeTag();
    } finally { }}

    public abstract String getLabel();

    public abstract boolean isDisabled();
}
