/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.form;

import org.apache.tapestry.IForm;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;

/**
 *  Implements a component that manages an HTML &lt;input type=checkbox&gt;
 *  form element.
 *
 *  [<a href="../../../../../ComponentReference/Checkbox.html">Component Reference</a>]
 *
 *  @author Howard Lewis Ship
 * 
 **/

public abstract class Checkbox extends AbstractFormComponent
{public static com.cortexeb.tools.clover.d __CLOVER_127_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    /**
     *  Renders the form elements, or responds when the form containing the element
     *  is submitted (by checking {@link Form#isRewinding()}.
     *
     *  <p>In traditional HTML, many checkboxes would have the same name but different values.
     *  Under Tapestry, it makes more sense to have different names and a fixed value.
     *  For a checkbox, we only care about whether the name appears as a request parameter.
     *
     **/

    protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle)
    {try { __CLOVER_127_0.M[674]++;
        __CLOVER_127_0.S[2923]++;IForm form = getForm(cycle);
		
        // Used whether rewinding or not.

        __CLOVER_127_0.S[2924]++;String name = form.getElementId(this);

        __CLOVER_127_0.S[2925]++;if ((((form.isRewinding()) && (++__CLOVER_127_0.CT[530] != 0)) || (++__CLOVER_127_0.CF[530] == 0))){
        {
            __CLOVER_127_0.S[2926]++;String value = cycle.getRequestContext().getParameter(name);

            __CLOVER_127_0.S[2927]++;setSelected((value != null));

            __CLOVER_127_0.S[2928]++;return;
        }}

        __CLOVER_127_0.S[2929]++;writer.beginEmpty("input");
        __CLOVER_127_0.S[2930]++;writer.attribute("type", "checkbox");

        __CLOVER_127_0.S[2931]++;writer.attribute("name", name);

        __CLOVER_127_0.S[2932]++;if ((((isDisabled()) && (++__CLOVER_127_0.CT[531] != 0)) || (++__CLOVER_127_0.CF[531] == 0))){
            __CLOVER_127_0.S[2933]++;writer.attribute("disabled", "disabled");}

        __CLOVER_127_0.S[2934]++;if ((((isSelected()) && (++__CLOVER_127_0.CT[532] != 0)) || (++__CLOVER_127_0.CF[532] == 0))){
            __CLOVER_127_0.S[2935]++;writer.attribute("checked", "checked");}

        __CLOVER_127_0.S[2936]++;renderInformalParameters(writer, cycle);

        __CLOVER_127_0.S[2937]++;writer.closeTag();
    } finally { }}

    public abstract boolean isDisabled();

    /** @since 2.2 **/

    public abstract boolean isSelected();

    /** @since 2.2 **/

    public abstract void setSelected(boolean selected);

}