/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.form;

import java.io.IOException;
import java.util.Iterator;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.tapestry.IActionListener;
import org.apache.tapestry.IBinding;
import org.apache.tapestry.IForm;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.Tapestry;
import org.apache.tapestry.request.RequestContext;
import org.apache.tapestry.services.DataSqueezer;

/**
 *  A specialized component used to edit a list of items
 *  within a form; it is similar to a {@link org.apache.tapestry.components.Foreach} but leverages
 *  hidden inputs within the &lt;form&gt; to store the items in the list.
 *
 *  [<a href="../../../../../ComponentReference/ListEdit.html">Component Reference</a>]
 *
 *  @author Howard Lewis Ship
 *  @since 1.0.2
 * 
 **/

public abstract class ListEdit extends AbstractFormComponent
{public static com.cortexeb.tools.clover.d __CLOVER_138_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);

    protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle)
    {try { __CLOVER_138_0.M[729]++;
        __CLOVER_138_0.S[3352]++;Iterator i = null;

        __CLOVER_138_0.S[3353]++;IForm form = getForm(cycle);

        __CLOVER_138_0.S[3354]++;boolean cycleRewinding = cycle.isRewinding();

        // If the cycle is rewinding, but not this particular form,
        // then do nothing (don't even render the body).

        __CLOVER_138_0.S[3355]++;if ((((cycleRewinding && !form.isRewinding()) && (++__CLOVER_138_0.CT[619] != 0)) || (++__CLOVER_138_0.CF[619] == 0))){
            __CLOVER_138_0.S[3356]++;return;}

        __CLOVER_138_0.S[3357]++;String name = form.getElementId(this);

        __CLOVER_138_0.S[3358]++;if ((((!cycleRewinding) && (++__CLOVER_138_0.CT[620] != 0)) || (++__CLOVER_138_0.CF[620] == 0))){
        {
            __CLOVER_138_0.S[3359]++;i = Tapestry.coerceToIterator(getSourceBinding().getObject());
        }}
        else{
        {
            __CLOVER_138_0.S[3360]++;RequestContext context = cycle.getRequestContext();
            __CLOVER_138_0.S[3361]++;String[] submittedValues = context.getParameters(name);

            __CLOVER_138_0.S[3362]++;i = Tapestry.coerceToIterator(submittedValues);
        }}

        // If the source (when rendering), or the submitted values (on submit)
        // are null, then skip the remainder (nothing to update, nothing to
        // render).

        __CLOVER_138_0.S[3363]++;if ((((i == null) && (++__CLOVER_138_0.CT[621] != 0)) || (++__CLOVER_138_0.CF[621] == 0))){
            __CLOVER_138_0.S[3364]++;return;}

        __CLOVER_138_0.S[3365]++;int index = 0;

        __CLOVER_138_0.S[3366]++;IBinding indexBinding = getIndexBinding();
        __CLOVER_138_0.S[3367]++;IBinding valueBinding = getValueBinding();
        __CLOVER_138_0.S[3368]++;IActionListener listener = getListener();
        __CLOVER_138_0.S[3369]++;String element = getElement();

        __CLOVER_138_0.S[3370]++;while ((((i.hasNext()) && (++__CLOVER_138_0.CT[622] != 0)) || (++__CLOVER_138_0.CF[622] == 0))){
        {
            __CLOVER_138_0.S[3371]++;Object value = null;

            __CLOVER_138_0.S[3372]++;if ((((indexBinding != null) && (++__CLOVER_138_0.CT[623] != 0)) || (++__CLOVER_138_0.CF[623] == 0))){
                __CLOVER_138_0.S[3373]++;indexBinding.setInt(index++);}

            __CLOVER_138_0.S[3374]++;if ((((cycleRewinding) && (++__CLOVER_138_0.CT[624] != 0)) || (++__CLOVER_138_0.CF[624] == 0))){
                __CLOVER_138_0.S[3375]++;value = convertValue((String) i.next());}
            else{
            {
                __CLOVER_138_0.S[3376]++;value = i.next();
                __CLOVER_138_0.S[3377]++;writeValue(form, name, value);
            }}

            __CLOVER_138_0.S[3378]++;valueBinding.setObject(value);

            __CLOVER_138_0.S[3379]++;if ((((listener != null) && (++__CLOVER_138_0.CT[625] != 0)) || (++__CLOVER_138_0.CF[625] == 0))){
                __CLOVER_138_0.S[3380]++;listener.actionTriggered(this, cycle);}

            __CLOVER_138_0.S[3381]++;if ((((element != null) && (++__CLOVER_138_0.CT[626] != 0)) || (++__CLOVER_138_0.CF[626] == 0))){
            {
                __CLOVER_138_0.S[3382]++;writer.begin(element);
                __CLOVER_138_0.S[3383]++;renderInformalParameters(writer, cycle);
            }}

            __CLOVER_138_0.S[3384]++;renderBody(writer, cycle);

            __CLOVER_138_0.S[3385]++;if ((((element != null) && (++__CLOVER_138_0.CT[627] != 0)) || (++__CLOVER_138_0.CF[627] == 0))){
                __CLOVER_138_0.S[3386]++;writer.end();}

        }}
    } finally { }}

    private void writeValue(IForm form, String name, Object value)
    {try { __CLOVER_138_0.M[730]++;
        __CLOVER_138_0.S[3387]++;String externalValue;

        __CLOVER_138_0.S[3388]++;try
        {
            __CLOVER_138_0.S[3389]++;externalValue = getDataSqueezer().squeeze(value);
        }
        catch (IOException ex)
        {
            __CLOVER_138_0.S[3390]++;throw new ApplicationRuntimeException(
                Tapestry.format("ListEdit.unable-to-convert-value", value),
                this,
                null,
                ex);
        }

        __CLOVER_138_0.S[3391]++;form.addHiddenValue(name, externalValue);
    } finally { }}

    private Object convertValue(String value)
    {try { __CLOVER_138_0.M[731]++;
        __CLOVER_138_0.S[3392]++;try
        {
            __CLOVER_138_0.S[3393]++;return getDataSqueezer().unsqueeze(value);
        }
        catch (IOException ex)
        {
            __CLOVER_138_0.S[3394]++;throw new ApplicationRuntimeException(
                Tapestry.format("ListEdit.unable-to-convert-string", value),
                this,
                null,
                ex);
        }
    } finally { }}

    public abstract String getElement();

    private DataSqueezer getDataSqueezer()
    {try { __CLOVER_138_0.M[732]++;
        __CLOVER_138_0.S[3395]++;return getPage().getEngine().getDataSqueezer();
    } finally { }}

    /** @since 2.2 **/

    public abstract IActionListener getListener();

    /** @since 3.0 **/

    public abstract IBinding getSourceBinding();

    public abstract IBinding getValueBinding();

    public abstract IBinding getIndexBinding();

    /** @since 3.0 **/

    public boolean isDisabled()
    {try { __CLOVER_138_0.M[733]++;
        __CLOVER_138_0.S[3396]++;return false;
    } finally { }}

}