/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.form;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.tapestry.AbstractComponent;
import org.apache.tapestry.IBinding;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.Tapestry;

/**
 *  A component that renders an HTML &lt;option&gt; form element.
 *  Such a component must be wrapped (possibly indirectly)
 *  inside a {@link Select} component.
 *
 *  [<a href="../../../../../ComponentReference/Option.html">Component Reference</a>]
 *
 *  @author Howard Lewis Ship
 * 
 **/

public abstract class Option extends AbstractComponent
{public static com.cortexeb.tools.clover.d __CLOVER_140_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    /**
     *  Renders the &lt;option&gt; element, or responds when the form containing the element 
     *  is submitted (by checking {@link Form#isRewinding()}.
     *
     *  <p>If the <code>label</code> property is set, it is inserted inside the
     *  &lt;option&gt; element.
     *
     **/

    protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle)
    {try { __CLOVER_140_0.M[747]++;
        __CLOVER_140_0.S[3439]++;Select select = Select.get(cycle);
        __CLOVER_140_0.S[3440]++;if ((((select == null) && (++__CLOVER_140_0.CT[637] != 0)) || (++__CLOVER_140_0.CF[637] == 0))){
            __CLOVER_140_0.S[3441]++;throw new ApplicationRuntimeException(
                Tapestry.getMessage("Option.must-be-contained-by-select"),
                this,
                null,
                null);}

        // It isn't enough to know whether the cycle in general is rewinding, need to know
        // specifically if the form which contains this component is rewinding.

        __CLOVER_140_0.S[3442]++;boolean rewinding = select.isRewinding();

        __CLOVER_140_0.S[3443]++;String value = select.getNextOptionId();

        __CLOVER_140_0.S[3444]++;if ((((rewinding) && (++__CLOVER_140_0.CT[638] != 0)) || (++__CLOVER_140_0.CF[638] == 0))){
        {
            __CLOVER_140_0.S[3445]++;if ((((!select.isDisabled()) && (++__CLOVER_140_0.CT[639] != 0)) || (++__CLOVER_140_0.CF[639] == 0))){
                __CLOVER_140_0.S[3446]++;getSelectedBinding().setBoolean(select.isSelected(value));}

            __CLOVER_140_0.S[3447]++;renderBody(writer, cycle);
        }}
        else{
        {
            __CLOVER_140_0.S[3448]++;writer.begin("option");

            __CLOVER_140_0.S[3449]++;writer.attribute("value", value);

            __CLOVER_140_0.S[3450]++;if ((((getSelectedBinding().getBoolean()) && (++__CLOVER_140_0.CT[640] != 0)) || (++__CLOVER_140_0.CF[640] == 0))){
                __CLOVER_140_0.S[3451]++;writer.attribute("selected", "selected");}

            __CLOVER_140_0.S[3452]++;renderInformalParameters(writer, cycle);

            __CLOVER_140_0.S[3453]++;String label = getLabel();

            __CLOVER_140_0.S[3454]++;if ((((label != null) && (++__CLOVER_140_0.CT[641] != 0)) || (++__CLOVER_140_0.CF[641] == 0))){
                __CLOVER_140_0.S[3455]++;writer.print(label);}

            __CLOVER_140_0.S[3456]++;renderBody(writer, cycle);

            __CLOVER_140_0.S[3457]++;writer.end();
        }}

    } finally { }}

    public abstract IBinding getSelectedBinding();

    public abstract String getLabel();
}