/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.form;

import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;

/**
 *  Implementation of {@link IPropertySelectionRenderer} that
 *  produces a table of radio (&lt;input type=radio&gt;) elements.
 *
 *  @author Howard Lewis Ship
 *
 **/

public class RadioPropertySelectionRenderer implements IPropertySelectionRenderer
{public static com.cortexeb.tools.clover.d __CLOVER_144_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);

    /**
     *  Writes the &lt;table&gt; element.
     *
     **/

    public void beginRender(PropertySelection component, IMarkupWriter writer, IRequestCycle cycle)
    {try { __CLOVER_144_0.M[759]++;
        __CLOVER_144_0.S[3576]++;writer.begin("table");
        __CLOVER_144_0.S[3577]++;writer.attribute("border", 0);
        __CLOVER_144_0.S[3578]++;writer.attribute("cellpadding", 0);
        __CLOVER_144_0.S[3579]++;writer.attribute("cellspacing", 2);
    } finally { }}

    /**
     *  Closes the &lt;table&gt; element.
     *
     **/

    public void endRender(PropertySelection component, IMarkupWriter writer, IRequestCycle cycle)
    {try { __CLOVER_144_0.M[760]++;
        __CLOVER_144_0.S[3580]++;writer.end(); // <table>
    } finally { }}

    /**
     *  Writes a row of the table.  The table contains two cells; the first is the radio
     *  button, the second is the label for the radio button.
     *
     **/

    public void renderOption(
        PropertySelection component,
        IMarkupWriter writer,
        IRequestCycle cycle,
        IPropertySelectionModel model,
        Object option,
        int index,
        boolean selected)
    {try { __CLOVER_144_0.M[761]++;
        __CLOVER_144_0.S[3581]++;writer.begin("tr");
        __CLOVER_144_0.S[3582]++;writer.begin("td");

        __CLOVER_144_0.S[3583]++;writer.beginEmpty("input");
        __CLOVER_144_0.S[3584]++;writer.attribute("type", "radio");
        __CLOVER_144_0.S[3585]++;writer.attribute("name", component.getName());
        __CLOVER_144_0.S[3586]++;writer.attribute("value", model.getValue(index));

        __CLOVER_144_0.S[3587]++;if ((((component.isDisabled()) && (++__CLOVER_144_0.CT[672] != 0)) || (++__CLOVER_144_0.CF[672] == 0))){
            __CLOVER_144_0.S[3588]++;writer.attribute("disabled", "disabled");}

        __CLOVER_144_0.S[3589]++;if ((((selected) && (++__CLOVER_144_0.CT[673] != 0)) || (++__CLOVER_144_0.CF[673] == 0))){
            __CLOVER_144_0.S[3590]++;writer.attribute("checked", "checked");}

        __CLOVER_144_0.S[3591]++;writer.end(); // <td>

        __CLOVER_144_0.S[3592]++;writer.println();

        __CLOVER_144_0.S[3593]++;writer.begin("td");
        __CLOVER_144_0.S[3594]++;writer.print(model.getLabel(index));
        __CLOVER_144_0.S[3595]++;writer.end(); // <td>
        __CLOVER_144_0.S[3596]++;writer.end(); // <tr>	

        __CLOVER_144_0.S[3597]++;writer.println();
    } finally { }}
}