/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.form;

/**
 *  Implementation of {@link IPropertySelectionModel} that allows one String from
 *  an array of Strings to be selected as the property.
 *
 *  <p>Uses a simple index number as the value (used to represent the selected String).
 *  This assumes that the possible values for the Strings will remain constant between
 *  request cycles.
 *
 *  @author Howard Lewis Ship
 * 
 **/

public class StringPropertySelectionModel implements IPropertySelectionModel
{public static com.cortexeb.tools.clover.d __CLOVER_147_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private String[] options;

    /**
     * Standard constructor.
     *
     * The options are retained (not copied).
     **/

    public StringPropertySelectionModel(String[] options)
    {try { __CLOVER_147_0.M[772]++;
        __CLOVER_147_0.S[3655]++;this.options = options;
    } finally { }}

    public int getOptionCount()
    {try { __CLOVER_147_0.M[773]++;
        __CLOVER_147_0.S[3656]++;return options.length;
    } finally { }}

    public Object getOption(int index)
    {try { __CLOVER_147_0.M[774]++;
        __CLOVER_147_0.S[3657]++;return options[index];
    } finally { }}

    /**
     *  Labels match options.
     *
     **/

    public String getLabel(int index)
    {try { __CLOVER_147_0.M[775]++;
        __CLOVER_147_0.S[3658]++;return options[index];
    } finally { }}

    /**
     *  Values are indexes into the array of options.
     *
     **/

    public String getValue(int index)
    {try { __CLOVER_147_0.M[776]++;
        __CLOVER_147_0.S[3659]++;return Integer.toString(index);
    } finally { }}

    public Object translateValue(String value)
    {try { __CLOVER_147_0.M[777]++;
        __CLOVER_147_0.S[3660]++;int index;

        __CLOVER_147_0.S[3661]++;index = Integer.parseInt(value);

        __CLOVER_147_0.S[3662]++;return options[index];
    } finally { }}

}