/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.html;

import org.apache.tapestry.BaseComponent;
import org.apache.tapestry.IBinding;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.bean.EvenOdd;
import org.apache.tapestry.util.exception.ExceptionDescription;

/**
 *  Component used to display an already formatted exception.
 * 
 *  [<a href="../../../../../ComponentReference/ExceptionDisplay.html">Component Reference</a>]
 *
 *  @author Howard Lewis Ship
 * 
 **/

public class ExceptionDisplay extends BaseComponent
{public static com.cortexeb.tools.clover.d __CLOVER_154_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private IBinding _exceptionsBinding;
    private ExceptionDescription _exception;
    private int _count;
    private int _index;
    private EvenOdd _evenOdd;

    public void setExceptionsBinding(IBinding value)
    {try { __CLOVER_154_0.M[796]++;
        __CLOVER_154_0.S[3825]++;_exceptionsBinding = value;
    } finally { }}

    public IBinding getExceptionsBinding()
    {try { __CLOVER_154_0.M[797]++;
        __CLOVER_154_0.S[3826]++;return _exceptionsBinding;
    } finally { }}

    /**
     *  Each time the current exception is set, as a side effect,
     *  the evenOdd helper bean is reset to even.
     * 
     **/
    
    public void setException(ExceptionDescription value)
    {try { __CLOVER_154_0.M[798]++;
        __CLOVER_154_0.S[3827]++;_exception = value;
        
        __CLOVER_154_0.S[3828]++;_evenOdd.setEven(true);
    } finally { }}

    public ExceptionDescription getException()
    {try { __CLOVER_154_0.M[799]++;
        __CLOVER_154_0.S[3829]++;return _exception;
    } finally { }}

    protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle)
    {try { __CLOVER_154_0.M[800]++;
        __CLOVER_154_0.S[3830]++;ExceptionDescription[] exceptions =
            (ExceptionDescription[]) _exceptionsBinding.getObject(
                "exceptions",
                ExceptionDescription[].class);

        __CLOVER_154_0.S[3831]++;_count = exceptions.length;
        
        __CLOVER_154_0.S[3832]++;try
        {
            __CLOVER_154_0.S[3833]++;_evenOdd = (EvenOdd)getBeans().getBean("evenOdd");
            
            __CLOVER_154_0.S[3834]++;super.renderComponent(writer, cycle);
        }
        finally
        {
            __CLOVER_154_0.S[3835]++;_exception = null;
            __CLOVER_154_0.S[3836]++;_evenOdd = null;
        }
    } finally { }}

    public void setIndex(int value)
    {try { __CLOVER_154_0.M[801]++;
        __CLOVER_154_0.S[3837]++;_index = value;
    } finally { }}

    public boolean isLast()
    {try { __CLOVER_154_0.M[802]++;
        __CLOVER_154_0.S[3838]++;return _index == (_count - 1);
    } finally { }}
}