/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.html;

import org.apache.commons.lang.enum.Enum;
import org.apache.tapestry.IMarkupWriter;

/**
 *  Defines a number of ways to format multi-line text for proper
 *  renderring.
 *
 *  @author Howard Lewis Ship
 *
 **/

public abstract class InsertTextMode extends Enum
{public static com.cortexeb.tools.clover.d __CLOVER_159_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    /**
     *  Mode where each line (after the first) is preceded by a &lt;br&gt; tag.
     *
     **/

    public static final InsertTextMode BREAK = new BreakMode();

    /**
     *  Mode where each line is wrapped with a &lt;p&gt; element.
     *
     **/

    public static final InsertTextMode PARAGRAPH = new ParagraphMode();

    protected InsertTextMode(String name)
    {
        super(name);__CLOVER_159_0.S[3890]++;try { __CLOVER_159_0.M[815]++;
    } finally { }}

    /**
     *  Invoked by the {@link InsertText} component to write the next line.
     *
     *  @param lineNumber the line number of the line, starting with 0 for the first line.
     *  @param line the String for the current line.
     *  @param writer the {@link IMarkupWriter} to send output to.
     **/

    public abstract void writeLine(
        int lineNumber,
        String line,
        IMarkupWriter writer);

    private static class BreakMode extends InsertTextMode
    {
        private BreakMode()
        {
            super("BREAK");__CLOVER_159_0.S[3891]++;try { __CLOVER_159_0.M[816]++;
        } finally { }}

        public void writeLine(int lineNumber, String line, IMarkupWriter writer)
        {try { __CLOVER_159_0.M[817]++;
            __CLOVER_159_0.S[3892]++;if ((((lineNumber > 0) && (++__CLOVER_159_0.CT[731] != 0)) || (++__CLOVER_159_0.CF[731] == 0))){
                __CLOVER_159_0.S[3893]++;writer.beginEmpty("br");}

            __CLOVER_159_0.S[3894]++;writer.print(line);
        } finally { }}
    }

    private static class ParagraphMode extends InsertTextMode
    {
        private ParagraphMode()
        {
            super("PARAGRAPH");__CLOVER_159_0.S[3895]++;try { __CLOVER_159_0.M[818]++;
        } finally { }}

        public void writeLine(int lineNumber, String line, IMarkupWriter writer)
        {try { __CLOVER_159_0.M[819]++;
            __CLOVER_159_0.S[3896]++;writer.begin("p");

            __CLOVER_159_0.S[3897]++;writer.print(line);

            __CLOVER_159_0.S[3898]++;writer.end();
        } finally { }}
    }

}