/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.html;

import java.io.CharArrayWriter;
import java.io.PrintWriter;

import org.apache.tapestry.IMarkupWriter;

/**
 *  Subclass of {@link HTMLWriter} that is nested.  A nested writer
 *  buffers its output, then inserts it into its parent writer when it is
 *  closed.
 *
 *  @author Howard Ship
 */

public class NestedHTMLWriter extends HTMLWriter
{public static com.cortexeb.tools.clover.d __CLOVER_160_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
	private IMarkupWriter _parent;
	private CharArrayWriter _internalBuffer;

	public NestedHTMLWriter(IMarkupWriter parent)
	{
		super(parent.getContentType());__CLOVER_160_0.S[3899]++;try { __CLOVER_160_0.M[820]++;

		__CLOVER_160_0.S[3900]++;_parent = parent;

		__CLOVER_160_0.S[3901]++;_internalBuffer = new CharArrayWriter();

		__CLOVER_160_0.S[3902]++;setWriter(new PrintWriter(_internalBuffer));
	} finally { }}

	/**
	*  Invokes the {@link HTMLWriter#close() super-class
	*  implementation}, then gets the data accumulated in the
	*  internal buffer and provides it to the containing writer using
	*  {@link IMarkupWriter#printRaw(char[], int, int)}.
	*
	*/

	public void close()
	{try { __CLOVER_160_0.M[821]++;
		__CLOVER_160_0.S[3903]++;super.close();

		__CLOVER_160_0.S[3904]++;char[] data = _internalBuffer.toCharArray();

		__CLOVER_160_0.S[3905]++;_parent.printRaw(data, 0, data.length);

		__CLOVER_160_0.S[3906]++;_internalBuffer = null;
		__CLOVER_160_0.S[3907]++;_parent = null;
	} finally { }}
}