/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.html;

import java.util.HashMap;
import java.util.Map;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.hivemind.Resource;
import org.apache.tapestry.AbstractComponent;
import org.apache.tapestry.IAsset;
import org.apache.tapestry.IEngine;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.IScript;
import org.apache.tapestry.Tapestry;
import org.apache.tapestry.components.ILinkComponent;
import org.apache.tapestry.components.LinkEventType;
import org.apache.tapestry.engine.IScriptSource;

/**
 *  Combines a link component (such as {@link org.apache.tapestry.link.DirectLink}) 
 *  with an &lt;img&gt; and JavaScript code
 *  to create a rollover effect that works with both Netscape Navigator and 
 *  Internet Explorer.
 *
 *  [<a href="../../../../../ComponentReference/Rollover.html">Component Reference</a>]
 *
 *
 *  @author Howard Lewis Ship
 * 
 **/

public abstract class Rollover extends AbstractComponent
{public static com.cortexeb.tools.clover.d __CLOVER_161_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private IScript _parsedScript;

    /**
     *  Converts an {@link IAsset} binding into a usable URL.  Returns null
     *  if the binding does not exist or the binding's value is null.
     *
     **/

    protected String getAssetURL(IAsset asset, IRequestCycle cycle)
    {try { __CLOVER_161_0.M[822]++;
        __CLOVER_161_0.S[3908]++;if ((((asset == null) && (++__CLOVER_161_0.CT[732] != 0)) || (++__CLOVER_161_0.CF[732] == 0))){
            __CLOVER_161_0.S[3909]++;return null;}

        __CLOVER_161_0.S[3910]++;return asset.buildURL(cycle);
    } finally { }}

    protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle)
    {try { __CLOVER_161_0.M[823]++;
        // No body, so we skip it all if not rewinding (assumes no side effects on
        // accessors).

        __CLOVER_161_0.S[3911]++;if ((((cycle.isRewinding()) && (++__CLOVER_161_0.CT[733] != 0)) || (++__CLOVER_161_0.CF[733] == 0))){
            __CLOVER_161_0.S[3912]++;return;}

        __CLOVER_161_0.S[3913]++;String imageURL = null;
        __CLOVER_161_0.S[3914]++;String focusURL = null;
        __CLOVER_161_0.S[3915]++;String blurURL = null;
        __CLOVER_161_0.S[3916]++;boolean dynamic = false;
        __CLOVER_161_0.S[3917]++;String imageName = null;

        __CLOVER_161_0.S[3918]++;Body body = Body.get(cycle);
        __CLOVER_161_0.S[3919]++;if ((((body == null) && (++__CLOVER_161_0.CT[734] != 0)) || (++__CLOVER_161_0.CF[734] == 0))){
            __CLOVER_161_0.S[3920]++;throw new ApplicationRuntimeException(
                Tapestry.getMessage("Rollover.must-be-contained-by-body"),
                this,
                null,
                null);}

        __CLOVER_161_0.S[3921]++;ILinkComponent serviceLink =
            (ILinkComponent) cycle.getAttribute(Tapestry.LINK_COMPONENT_ATTRIBUTE_NAME);

        __CLOVER_161_0.S[3922]++;if ((((serviceLink == null) && (++__CLOVER_161_0.CT[735] != 0)) || (++__CLOVER_161_0.CF[735] == 0))){
            __CLOVER_161_0.S[3923]++;throw new ApplicationRuntimeException(
                Tapestry.getMessage("Rollover.must-be-contained-by-link"),
                this,
                null,
                null);}

        __CLOVER_161_0.S[3924]++;boolean linkDisabled = serviceLink.isDisabled();

        __CLOVER_161_0.S[3925]++;if ((((linkDisabled) && (++__CLOVER_161_0.CT[736] != 0)) || (++__CLOVER_161_0.CF[736] == 0))){
        {
            __CLOVER_161_0.S[3926]++;imageURL = getAssetURL(getDisabled(), cycle);

            __CLOVER_161_0.S[3927]++;if ((((imageURL == null) && (++__CLOVER_161_0.CT[737] != 0)) || (++__CLOVER_161_0.CF[737] == 0))){
                __CLOVER_161_0.S[3928]++;imageURL = getAssetURL(getImage(), cycle);}
        }}
        else{
        {
            __CLOVER_161_0.S[3929]++;imageURL = getAssetURL(getImage(), cycle);
            __CLOVER_161_0.S[3930]++;focusURL = getAssetURL(getFocus(), cycle);
            __CLOVER_161_0.S[3931]++;blurURL = getAssetURL(getBlur(), cycle);

            __CLOVER_161_0.S[3932]++;dynamic = (focusURL != null) || (blurURL != null);
        }}

        __CLOVER_161_0.S[3933]++;if ((((imageURL == null) && (++__CLOVER_161_0.CT[738] != 0)) || (++__CLOVER_161_0.CF[738] == 0))){
            __CLOVER_161_0.S[3934]++;throw Tapestry.createRequiredParameterException(this, "image");}

        __CLOVER_161_0.S[3935]++;writer.beginEmpty("img");

        __CLOVER_161_0.S[3936]++;writer.attribute("src", imageURL);

        __CLOVER_161_0.S[3937]++;writer.attribute("border", 0);

        __CLOVER_161_0.S[3938]++;if ((((dynamic) && (++__CLOVER_161_0.CT[739] != 0)) || (++__CLOVER_161_0.CF[739] == 0))){
        {
            __CLOVER_161_0.S[3939]++;if ((((focusURL == null) && (++__CLOVER_161_0.CT[740] != 0)) || (++__CLOVER_161_0.CF[740] == 0))){
                __CLOVER_161_0.S[3940]++;focusURL = imageURL;}

            __CLOVER_161_0.S[3941]++;if ((((blurURL == null) && (++__CLOVER_161_0.CT[741] != 0)) || (++__CLOVER_161_0.CF[741] == 0))){
                __CLOVER_161_0.S[3942]++;blurURL = imageURL;}

            __CLOVER_161_0.S[3943]++;imageName = writeScript(cycle, body, serviceLink, focusURL, blurURL);

            __CLOVER_161_0.S[3944]++;writer.attribute("name", imageName);
        }}

        __CLOVER_161_0.S[3945]++;renderInformalParameters(writer, cycle);

        __CLOVER_161_0.S[3946]++;writer.closeTag();

    } finally { }}

    private IScript getParsedScript()
    {try { __CLOVER_161_0.M[824]++;
        __CLOVER_161_0.S[3947]++;if ((((_parsedScript == null) && (++__CLOVER_161_0.CT[742] != 0)) || (++__CLOVER_161_0.CF[742] == 0))){
        {
            __CLOVER_161_0.S[3948]++;IEngine engine = getPage().getEngine();
            __CLOVER_161_0.S[3949]++;IScriptSource source = engine.getScriptSource();

            __CLOVER_161_0.S[3950]++;Resource scriptLocation =
                getSpecification().getSpecificationLocation().getRelativeResource(
                    "Rollover.script");

            __CLOVER_161_0.S[3951]++;_parsedScript = source.getScript(scriptLocation);
        }}

        __CLOVER_161_0.S[3952]++;return _parsedScript;
    } finally { }}

    private String writeScript(
        IRequestCycle cycle,
        Body body,
        ILinkComponent link,
        String focusURL,
        String blurURL)
    {try { __CLOVER_161_0.M[825]++;
        __CLOVER_161_0.S[3953]++;String imageName = body.getUniqueString(getId());
        __CLOVER_161_0.S[3954]++;String focusImageURL = body.getPreloadedImageReference(focusURL);
        __CLOVER_161_0.S[3955]++;String blurImageURL = body.getPreloadedImageReference(blurURL);

        __CLOVER_161_0.S[3956]++;Map symbols = new HashMap();

        __CLOVER_161_0.S[3957]++;symbols.put("imageName", imageName);
        __CLOVER_161_0.S[3958]++;symbols.put("focusImageURL", focusImageURL);
        __CLOVER_161_0.S[3959]++;symbols.put("blurImageURL", blurImageURL);

        __CLOVER_161_0.S[3960]++;getParsedScript().execute(cycle, body, symbols);

        // Add attributes to the link to control mouse over/out.
        // Because the script is written before the <body> tag,
        // there won't be any timing issues (such as cause
        // bug #113893).

        __CLOVER_161_0.S[3961]++;link.addEventHandler(LinkEventType.MOUSE_OVER, (String) symbols.get("onMouseOverName"));
        __CLOVER_161_0.S[3962]++;link.addEventHandler(LinkEventType.MOUSE_OUT, (String) symbols.get("onMouseOutName"));

        __CLOVER_161_0.S[3963]++;return imageName;
    } finally { }}

    public abstract IAsset getBlur();

    public abstract IAsset getDisabled();

    public abstract IAsset getFocus();

    public abstract IAsset getImage();
}