/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.html;

import java.util.Date;
import java.util.Iterator;

import org.apache.tapestry.AbstractComponent;
import org.apache.tapestry.IAsset;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IPage;
import org.apache.tapestry.IRender;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.Tapestry;
import org.apache.tapestry.engine.IEngineService;
import org.apache.tapestry.engine.ILink;

/**
 *  Component for creating a standard 'shell' for a page, which comprises
 *  the &lt;html&gt; and &lt;head&gt; portions of the page.
 * 
 *  [<a href="../../../../../ComponentReference/Shell.html">Component Reference</a>]
 *
 *  <p>Specifically does <em>not</em> provide a &lt;body&gt; tag, that is
 *  usually accomplished using a {@link Body} component.
 *
 *  @author Howard Lewis Ship
 * 
 **/

public abstract class Shell extends AbstractComponent
{public static com.cortexeb.tools.clover.d __CLOVER_163_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);

    private static final String generatorContent =
        "Tapestry Application Framework, version " + Tapestry.VERSION;

    protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle)
    {try { __CLOVER_163_0.M[833]++;
        __CLOVER_163_0.S[3998]++;long startTime = 0;

        __CLOVER_163_0.S[3999]++;boolean rewinding = cycle.isRewinding();

        __CLOVER_163_0.S[4000]++;if ((((!rewinding) && (++__CLOVER_163_0.CT[749] != 0)) || (++__CLOVER_163_0.CF[749] == 0))){
        {
            __CLOVER_163_0.S[4001]++;startTime = System.currentTimeMillis();

            __CLOVER_163_0.S[4002]++;writeDocType(writer, cycle);

            __CLOVER_163_0.S[4003]++;IPage page = getPage();

            __CLOVER_163_0.S[4004]++;writer.comment("Application: " + page.getEngine().getSpecification().getName());

            __CLOVER_163_0.S[4005]++;writer.comment("Page: " + page.getPageName());
            __CLOVER_163_0.S[4006]++;writer.comment("Generated: " + new Date());

            __CLOVER_163_0.S[4007]++;writer.begin("html");
            __CLOVER_163_0.S[4008]++;writer.println();
            __CLOVER_163_0.S[4009]++;writer.begin("head");
            __CLOVER_163_0.S[4010]++;writer.println();

            __CLOVER_163_0.S[4011]++;writer.beginEmpty("meta");
            __CLOVER_163_0.S[4012]++;writer.attribute("name", "generator");
            __CLOVER_163_0.S[4013]++;writer.attribute("content", generatorContent);
            __CLOVER_163_0.S[4014]++;writer.println();

            __CLOVER_163_0.S[4015]++;if ((((getRenderContentType()) && (++__CLOVER_163_0.CT[750] != 0)) || (++__CLOVER_163_0.CF[750] == 0))){ {
                // This should not be necessary (the HTTP content type should be sufficient), 
                // but some browsers require it for some reason
                __CLOVER_163_0.S[4016]++;writer.beginEmpty("meta");
                __CLOVER_163_0.S[4017]++;writer.attribute("http-equiv", "Content-Type");
                __CLOVER_163_0.S[4018]++;writer.attribute("content", writer.getContentType());
                __CLOVER_163_0.S[4019]++;writer.println();
            }}

            __CLOVER_163_0.S[4020]++;writer.begin("title");

            __CLOVER_163_0.S[4021]++;writer.print(getTitle());
            __CLOVER_163_0.S[4022]++;writer.end(); // title
            __CLOVER_163_0.S[4023]++;writer.println();

            __CLOVER_163_0.S[4024]++;IRender delegate = getDelegate();

            __CLOVER_163_0.S[4025]++;if ((((delegate != null) && (++__CLOVER_163_0.CT[751] != 0)) || (++__CLOVER_163_0.CF[751] == 0))){
                __CLOVER_163_0.S[4026]++;delegate.render(writer, cycle);}

            __CLOVER_163_0.S[4027]++;IAsset stylesheet = getStylesheet();

            __CLOVER_163_0.S[4028]++;if ((((stylesheet != null) && (++__CLOVER_163_0.CT[752] != 0)) || (++__CLOVER_163_0.CF[752] == 0))){
                __CLOVER_163_0.S[4029]++;writeStylesheetLink(writer, cycle, stylesheet);}

            __CLOVER_163_0.S[4030]++;Iterator i = Tapestry.coerceToIterator(getStylesheets());

            __CLOVER_163_0.S[4031]++;if ((((i != null) && (++__CLOVER_163_0.CT[753] != 0)) || (++__CLOVER_163_0.CF[753] == 0))){
            {
                __CLOVER_163_0.S[4032]++;while ((((i.hasNext()) && (++__CLOVER_163_0.CT[754] != 0)) || (++__CLOVER_163_0.CF[754] == 0))){
                {
                    __CLOVER_163_0.S[4033]++;stylesheet = (IAsset) i.next();

                    __CLOVER_163_0.S[4034]++;writeStylesheetLink(writer, cycle, stylesheet);
                }}
            }}

            __CLOVER_163_0.S[4035]++;writeRefresh(writer, cycle);

            __CLOVER_163_0.S[4036]++;writer.end(); // head
        }}

        // Render the body, the actual page content

        __CLOVER_163_0.S[4037]++;renderBody(writer, cycle);

        __CLOVER_163_0.S[4038]++;if ((((!rewinding) && (++__CLOVER_163_0.CT[755] != 0)) || (++__CLOVER_163_0.CF[755] == 0))){
        {
            __CLOVER_163_0.S[4039]++;writer.end(); // html
            __CLOVER_163_0.S[4040]++;writer.println();

            __CLOVER_163_0.S[4041]++;long endTime = System.currentTimeMillis();

            __CLOVER_163_0.S[4042]++;writer.comment("Render time: ~ " + (endTime - startTime) + " ms");
        }}

    } finally { }}

    private void writeDocType(IMarkupWriter writer, IRequestCycle cycle)
    {try { __CLOVER_163_0.M[834]++;
        // This code is deprecated and is here only for backward compatibility
        __CLOVER_163_0.S[4043]++;String DTD = getDTD();
        __CLOVER_163_0.S[4044]++;if ((((Tapestry.isNonBlank(DTD)) && (++__CLOVER_163_0.CT[756] != 0)) || (++__CLOVER_163_0.CF[756] == 0))){ {
            __CLOVER_163_0.S[4045]++;writer.printRaw("<!DOCTYPE HTML PUBLIC \"" + DTD + "\">");
            __CLOVER_163_0.S[4046]++;writer.println();
            __CLOVER_163_0.S[4047]++;return;
        }}

        // This is the real code
        __CLOVER_163_0.S[4048]++;String doctype = getDoctype();
        __CLOVER_163_0.S[4049]++;if ((((Tapestry.isNonBlank(doctype)) && (++__CLOVER_163_0.CT[757] != 0)) || (++__CLOVER_163_0.CF[757] == 0))){ {
            __CLOVER_163_0.S[4050]++;writer.printRaw("<!DOCTYPE " + doctype + ">");
            __CLOVER_163_0.S[4051]++;writer.println();
        }}
    } finally { }}

    private void writeStylesheetLink(IMarkupWriter writer, IRequestCycle cycle, IAsset stylesheet)
    {try { __CLOVER_163_0.M[835]++;
        __CLOVER_163_0.S[4052]++;writer.beginEmpty("link");
        __CLOVER_163_0.S[4053]++;writer.attribute("rel", "stylesheet");
        __CLOVER_163_0.S[4054]++;writer.attribute("type", "text/css");
        __CLOVER_163_0.S[4055]++;writer.attribute("href", stylesheet.buildURL(cycle));
        __CLOVER_163_0.S[4056]++;writer.println();
    } finally { }}

    private void writeRefresh(IMarkupWriter writer, IRequestCycle cycle)
    {try { __CLOVER_163_0.M[836]++;
        __CLOVER_163_0.S[4057]++;int refresh = getRefresh();

        __CLOVER_163_0.S[4058]++;if ((((refresh <= 0) && (++__CLOVER_163_0.CT[758] != 0)) || (++__CLOVER_163_0.CF[758] == 0))){
            __CLOVER_163_0.S[4059]++;return;}

        // Here comes the tricky part ... have to assemble a complete URL
        // for the current page.

        __CLOVER_163_0.S[4060]++;IEngineService pageService = cycle.getEngine().getService(Tapestry.PAGE_SERVICE);
        __CLOVER_163_0.S[4061]++;String pageName = getPage().getPageName();

        __CLOVER_163_0.S[4062]++;ILink link = pageService.getLink(cycle, null, new String[] { pageName });

        __CLOVER_163_0.S[4063]++;StringBuffer buffer = new StringBuffer();
        __CLOVER_163_0.S[4064]++;buffer.append(refresh);
        __CLOVER_163_0.S[4065]++;buffer.append("; URL=");
        __CLOVER_163_0.S[4066]++;buffer.append(link.getAbsoluteURL());

        // Write out the <meta> tag

        __CLOVER_163_0.S[4067]++;writer.beginEmpty("meta");
        __CLOVER_163_0.S[4068]++;writer.attribute("http-equiv", "Refresh");
        __CLOVER_163_0.S[4069]++;writer.attribute("content", buffer.toString());
    } finally { }}

    public abstract IRender getDelegate();

    public abstract int getRefresh();

    public abstract IAsset getStylesheet();

    public abstract String getTitle();

    public abstract String getDoctype();

    public abstract String getDTD();

    public abstract Object getStylesheets();

    public abstract boolean getRenderContentType();
    
}