/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.jsp;

import java.io.IOException;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;

import org.apache.tapestry.Tapestry;

/**
 *  Abstract super-class of Tapestry JSP tags that produce a hyperlink
 *  (<code>&lt;a&gt;</code>) tag.  Tags use a
 *  {@link org.apache.tapestry.jsp.URLRetriever} for the <code>href</code>
 *  attribute, and may include a 
 *  <code>class</code> attribute (based on
 *  the {@link #getStyleClass() styleClass property}.
 *
 *  @author Howard Lewis Ship
 *  @since 3.0
 *
 **/

public abstract class AbstractLinkTag extends AbstractTapestryTag
{public static com.cortexeb.tools.clover.d __CLOVER_164_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private String _styleClass;

    public String getStyleClass()
    {try { __CLOVER_164_0.M[837]++;
        __CLOVER_164_0.S[4070]++;return _styleClass;
    } finally { }}

    public void setStyleClass(String styleClass)
    {try { __CLOVER_164_0.M[838]++;
        __CLOVER_164_0.S[4071]++;_styleClass = styleClass;
    } finally { }}

    /**
    *  Writes a <code>&lt;/a&gt;</code> tag.
    * 
    *  @return {@link javax.servlet.jsp.tagext.Tag#EVAL_PAGE}
    * 
    **/

    public int doEndTag() throws JspException
    {try { __CLOVER_164_0.M[839]++;
        __CLOVER_164_0.S[4072]++;JspWriter out = pageContext.getOut();

        __CLOVER_164_0.S[4073]++;try
        {
            __CLOVER_164_0.S[4074]++;out.print("</a>");
        }
        catch (IOException ex)
        {
            __CLOVER_164_0.S[4075]++;throw new JspException(
                Tapestry.format("AbstractLinkTag.io-exception", ex.getMessage()));
        }

        __CLOVER_164_0.S[4076]++;return EVAL_PAGE;
    } finally { }}

    /**
    *  Writes a <code>&lt;a&gt; tag.  The tag may
    *  have a <code>class</code> attribute if the
    *  {@link #getStyleClass() styleClass property}
    *  is not null.  The <code>href</code>
    *  attribute is provided via
    *  a {@link #getURLRetriever() URLRetriever}.
    * 
    *  @return {@link javax.servlet.jsp.tagext.Tag#EVAL_BODY_INCLUDE}
    * 
    **/

    public int doStartTag() throws JspException
    {try { __CLOVER_164_0.M[840]++;
        __CLOVER_164_0.S[4077]++;JspWriter out = pageContext.getOut();

        __CLOVER_164_0.S[4078]++;try
        {
            __CLOVER_164_0.S[4079]++;out.print("<a");

            __CLOVER_164_0.S[4080]++;if ((((_styleClass != null) && (++__CLOVER_164_0.CT[759] != 0)) || (++__CLOVER_164_0.CF[759] == 0))){
            {
                __CLOVER_164_0.S[4081]++;out.print(" class=\"");
                __CLOVER_164_0.S[4082]++;out.print(_styleClass);
                __CLOVER_164_0.S[4083]++;out.print('"');
            }}

            __CLOVER_164_0.S[4084]++;out.print(" href=\"");

            __CLOVER_164_0.S[4085]++;getURLRetriever().insertURL(getServlet());

            // And we're back!  Finish off the tag.

            __CLOVER_164_0.S[4086]++;out.print("\">");
        }
        catch (IOException ex)
        {
            __CLOVER_164_0.S[4087]++;throw new JspException(
                Tapestry.format("AbstractLinkTag.io-exception", ex.getMessage()));
        }

        __CLOVER_164_0.S[4088]++;return EVAL_BODY_INCLUDE;
    } finally { }}
}
