/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.jsp;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;

import org.apache.tapestry.Tapestry;
import org.apache.tapestry.link.DirectLink;
import org.apache.tapestry.parse.TemplateParser;
import org.apache.tapestry.util.prop.OgnlUtils;

/**
 *  Contains common code and methods for all the Tapestry JSP tag implementations.
 *
 *  @author Howard Lewis Ship
 *  @since 3.0
 *
 **/

public abstract class AbstractTapestryTag extends TagSupport
{public static com.cortexeb.tools.clover.d __CLOVER_165_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);

    private String _servlet = "/app";

    public String getServlet()
    {try { __CLOVER_165_0.M[841]++;
        __CLOVER_165_0.S[4089]++;return _servlet;
    } finally { }}

    public void setServlet(String servlet)
    {try { __CLOVER_165_0.M[842]++;
        __CLOVER_165_0.S[4090]++;_servlet = servlet;
    } finally { }}

    /**
     *  Implemented in subclasses to provide a 
     *  {@link org.apache.tapestry.jsp.URLRetriever} instance that
     *  can insert the correct URL into the output.
     * 
     **/

    protected abstract URLRetriever getURLRetriever() throws JspException;

    /**
     *  Builds an object array appropriate for use as the service parameters
     *  for the external service. The first object in the array is the name
     *  of the page.  Any additional objects are service parameters to be
     *  supplied to the listener method.
     * 
     *  <p>
     *  The parameters are converted to an array of objects
     *  via {@link #convertParameters(String)}.
     * 
     **/

    protected Object[] constructExternalServiceParameters(String pageName, String parameters)
        throws JspException
    {try { __CLOVER_165_0.M[843]++;

        __CLOVER_165_0.S[4091]++;Object[] resolvedParameters = convertParameters(parameters);

        __CLOVER_165_0.S[4092]++;int count = Tapestry.size(resolvedParameters);

        __CLOVER_165_0.S[4093]++;if ((((count == 0) && (++__CLOVER_165_0.CT[760] != 0)) || (++__CLOVER_165_0.CF[760] == 0))){
            __CLOVER_165_0.S[4094]++;return new Object[] { pageName };}

        __CLOVER_165_0.S[4095]++;List list = new ArrayList();
        __CLOVER_165_0.S[4096]++;list.add(pageName);

        __CLOVER_165_0.S[4097]++;for (int i = 0; (((i < count) && (++__CLOVER_165_0.CT[761] != 0)) || (++__CLOVER_165_0.CF[761] == 0)); i++){
            __CLOVER_165_0.S[4098]++;list.add(resolvedParameters[i]);}

        __CLOVER_165_0.S[4099]++;return list.toArray();
    } finally { }}

    /**
     *  <p>The external service allows service parameters (an array of
     *  objects) to be passed along inside the URL.  This method converts
     *  the input string into an array of parameter objects.
     *  <ul>
     *  <li>If parameters is null, the no parameters are passed
     *  <li>If parameters starts with "ognl:" it is treated as an OGNL expression:
     *     <ul>
     *     <li>The expression is evaluated using the 
     *         {@link javax.servlet.jsp.PageContext page context} as the root object
     *     <li>If the expression value is a Map, then the Map is converted to
     *  	   an array via (@link org.apache.tapestry.Tapestry#convertMapToArray(Map)}
     *     <li>Otherwise, the expression value is converted using
     *  {@link org.apache.tapestry.link.DirectLink#constructServiceParameters(Object)}.
     * 		</ul>
     *   <li>Otherwise, parameters are simply a string, which is included as the lone
     *  service parameter
     *  </ul>
     **/

    protected Object[] convertParameters(String _parameters) throws JspException
    {try { __CLOVER_165_0.M[844]++;
        __CLOVER_165_0.S[4100]++;if ((((_parameters == null) && (++__CLOVER_165_0.CT[762] != 0)) || (++__CLOVER_165_0.CF[762] == 0))){
            __CLOVER_165_0.S[4101]++;return null;}

        __CLOVER_165_0.S[4102]++;if ((((_parameters.startsWith(TemplateParser.OGNL_EXPRESSION_PREFIX)) && (++__CLOVER_165_0.CT[763] != 0)) || (++__CLOVER_165_0.CF[763] == 0))){
        {
            __CLOVER_165_0.S[4103]++;String expression =
                _parameters.substring(TemplateParser.OGNL_EXPRESSION_PREFIX.length() + 1);

            __CLOVER_165_0.S[4104]++;return convertExpression(expression);
        }}

        __CLOVER_165_0.S[4105]++;return new Object[] { _parameters };
    } finally { }}

    private Object[] convertExpression(String expression) throws JspException
    {try { __CLOVER_165_0.M[845]++;
        __CLOVER_165_0.S[4106]++;Object value = evaluateExpression(expression);

        __CLOVER_165_0.S[4107]++;if ((((value == null) && (++__CLOVER_165_0.CT[764] != 0)) || (++__CLOVER_165_0.CF[764] == 0))){
            __CLOVER_165_0.S[4108]++;return null;}

        __CLOVER_165_0.S[4109]++;if ((((value instanceof Map) && (++__CLOVER_165_0.CT[765] != 0)) || (++__CLOVER_165_0.CF[765] == 0))){
            __CLOVER_165_0.S[4110]++;return Tapestry.convertMapToArray((Map) value);}

        __CLOVER_165_0.S[4111]++;return DirectLink.constructServiceParameters(value);
    } finally { }}

    private Object evaluateExpression(String expression) throws JspException
    {try { __CLOVER_165_0.M[846]++;
        __CLOVER_165_0.S[4112]++;try
        {
            __CLOVER_165_0.S[4113]++;return OgnlUtils.get(expression, pageContext);
        }
        catch (Throwable t)
        {
            __CLOVER_165_0.S[4114]++;throw new JspException(
                Tapestry.format(
                    "AbstractTapestryTag.unable-to-evaluate-expression",
                    expression,
                    t.getMessage()),
                t);
        }
    } finally { }}
}
