/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.jsp;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.tapestry.Tapestry;

/**
 *  Encapsulates the process of calling into the Tapestry servlet to retrieve
 *  a URL.
 *
 *  @author Howard Lewis Ship
 *  @since 3.0
 *
 **/
public class URLRetriever
{public static com.cortexeb.tools.clover.d __CLOVER_171_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private static final Log LOG = LogFactory.getLog(URLRetriever.class);

    private PageContext _pageContext;
    private String _serviceName;
    private Object[] _serviceParameters;

    public URLRetriever(PageContext pageContext, String serviceName, Object[] serviceParameters)
    {try { __CLOVER_171_0.M[864]++;
        __CLOVER_171_0.S[4133]++;_pageContext = pageContext;
        __CLOVER_171_0.S[4134]++;_serviceName = serviceName;
        __CLOVER_171_0.S[4135]++;_serviceParameters = serviceParameters;
    } finally { }}

    /**
     *  Invokes the servlet to retrieve the URL.  The URL is inserted
     *  into the output (as with
     *  {@link RequestDispatcher#include(javax.servlet.ServletRequest, javax.servlet.ServletResponse)}). 
     * 
     *
     **/

    public void insertURL(String servletPath) throws JspException
    {try { __CLOVER_171_0.M[865]++;
        __CLOVER_171_0.S[4136]++;if ((((LOG.isDebugEnabled()) && (++__CLOVER_171_0.CT[766] != 0)) || (++__CLOVER_171_0.CF[766] == 0))){
            __CLOVER_171_0.S[4137]++;LOG.debug("Obtaining Tapestry URL for service " + _serviceName + " at " + servletPath);}

        __CLOVER_171_0.S[4138]++;ServletRequest request = _pageContext.getRequest();

        __CLOVER_171_0.S[4139]++;RequestDispatcher dispatcher = request.getRequestDispatcher(servletPath);

        __CLOVER_171_0.S[4140]++;if ((((dispatcher == null) && (++__CLOVER_171_0.CT[767] != 0)) || (++__CLOVER_171_0.CF[767] == 0))){
            __CLOVER_171_0.S[4141]++;throw new JspException(
                Tapestry.format("URLRetriever.unable-to-find-dispatcher", servletPath));}

        __CLOVER_171_0.S[4142]++;request.setAttribute(Tapestry.TAG_SUPPORT_SERVICE_ATTRIBUTE, _serviceName);
        __CLOVER_171_0.S[4143]++;request.setAttribute(Tapestry.TAG_SUPPORT_PARAMETERS_ATTRIBUTE, _serviceParameters);
        __CLOVER_171_0.S[4144]++;request.setAttribute(Tapestry.TAG_SUPPORT_SERVLET_PATH_ATTRIBUTE, servletPath);

        __CLOVER_171_0.S[4145]++;try
        {
            __CLOVER_171_0.S[4146]++;_pageContext.getOut().flush();

            __CLOVER_171_0.S[4147]++;dispatcher.include(request, _pageContext.getResponse());
        }
        catch (IOException ex)
        {
            __CLOVER_171_0.S[4148]++;throw new JspException(
                Tapestry.format("URLRetriever.io-exception", servletPath, ex.getMessage()));
        }
        catch (ServletException ex)
        {
            __CLOVER_171_0.S[4149]++;throw new JspException(
                Tapestry.format("URLRetriever.servlet-exception", servletPath, ex.getMessage()));
        }
        finally
        {
            __CLOVER_171_0.S[4150]++;request.removeAttribute(Tapestry.TAG_SUPPORT_SERVICE_ATTRIBUTE);
            __CLOVER_171_0.S[4151]++;request.removeAttribute(Tapestry.TAG_SUPPORT_PARAMETERS_ATTRIBUTE);
            __CLOVER_171_0.S[4152]++;request.removeAttribute(Tapestry.TAG_SUPPORT_SERVLET_PATH_ATTRIBUTE);
        }

    } finally { }}
}
