/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.link;

import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.engine.ILink;

/**
 *  Renders a link using an absolute URL, not simply a URI
 *  (as with {@link org.apache.tapestry.link.DefaultLinkRenderer}.  In addition,
 *  the scheme, server and port may be changed (this may be appropriate when
 *  switching between secure and insecure portions of an application).
 *
 *  @author Howard Lewis Ship
 *  @since 3.0
 * 
 **/

public class AbsoluteLinkRenderer extends DefaultLinkRenderer
{public static com.cortexeb.tools.clover.d __CLOVER_172_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private String _scheme;
    private String _serverName;
    private int _port;

    public int getPort()
    {try { __CLOVER_172_0.M[866]++;
        __CLOVER_172_0.S[4153]++;return _port;
    } finally { }}

    public String getScheme()
    {try { __CLOVER_172_0.M[867]++;
        __CLOVER_172_0.S[4154]++;return _scheme;
    } finally { }}

    public String getServerName()
    {try { __CLOVER_172_0.M[868]++;
        __CLOVER_172_0.S[4155]++;return _serverName;
    } finally { }}

    /**
     *  Used to override the port in the final URL, if specified.  If not specified,
     *  the port provided by the {@link javax.servlet.ServletRequest#getServerPort() request}
     *  is used (typically, the value 80).
     *
     **/

    public void setPort(int port)
    {try { __CLOVER_172_0.M[869]++;
        __CLOVER_172_0.S[4156]++;_port = port;
    } finally { }}
    
    /**
     *  Used to override the scheme in the final URL, if specified.  If not specified,
     *  the scheme provided by the {@link javax.servlet.ServletRequest#getScheme() request}
     *  is used (typically, <code>http</code>).
     *
     **/

    public void setScheme(String scheme)
    {try { __CLOVER_172_0.M[870]++;
        __CLOVER_172_0.S[4157]++;_scheme = scheme;
    } finally { }}

    /**
     *  Used to override the server name in the final URL, if specified.  If not specified,
     *  the port provided by the {@link javax.servlet.ServletRequest#getServerName() request}
     *  is used.
     *
     **/

    public void setServerName(String serverName)
    {try { __CLOVER_172_0.M[871]++;
        __CLOVER_172_0.S[4158]++;_serverName = serverName;
    } finally { }}

    protected String constructURL(ILink link, String anchor, IRequestCycle cycle)
    {try { __CLOVER_172_0.M[872]++;
        __CLOVER_172_0.S[4159]++;return link.getAbsoluteURL(_scheme, _serverName, _port, anchor, true);
    } finally { }}

}
