/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.link;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.Tapestry;
import org.apache.tapestry.components.ILinkComponent;
import org.apache.tapestry.engine.ILink;

/**
 *  Default implementation of {@link org.apache.tapestry.link.ILinkRenderer}, which
 *  does nothing special.  Can be used as a base class to provide
 *  additional handling.
 *
 *  @author Howard Lewis Ship, David Solis
 *  @since 3.0
 **/

public class DefaultLinkRenderer implements ILinkRenderer
{public static com.cortexeb.tools.clover.d __CLOVER_175_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    /**
     *  A shared instance used as a default for any link that doesn't explicitly
     *  override.
     * 
     **/

    public static final ILinkRenderer SHARED_INSTANCE = new DefaultLinkRenderer();

    public void renderLink(IMarkupWriter writer, IRequestCycle cycle, ILinkComponent linkComponent)
    {try { __CLOVER_175_0.M[884]++;
        __CLOVER_175_0.S[4223]++;IMarkupWriter wrappedWriter = null;

        __CLOVER_175_0.S[4224]++;if ((((cycle.getAttribute(Tapestry.LINK_COMPONENT_ATTRIBUTE_NAME) != null) && (++__CLOVER_175_0.CT[779] != 0)) || (++__CLOVER_175_0.CF[779] == 0))){
            __CLOVER_175_0.S[4225]++;throw new ApplicationRuntimeException(
                Tapestry.getMessage("AbstractLinkComponent.no-nesting"),
                linkComponent,
                null,
                null);}

        __CLOVER_175_0.S[4226]++;cycle.setAttribute(Tapestry.LINK_COMPONENT_ATTRIBUTE_NAME, linkComponent);

        __CLOVER_175_0.S[4227]++;boolean hasBody = getHasBody();

        __CLOVER_175_0.S[4228]++;boolean disabled = linkComponent.isDisabled();

        __CLOVER_175_0.S[4229]++;if ((((!disabled) && (++__CLOVER_175_0.CT[780] != 0)) || (++__CLOVER_175_0.CF[780] == 0))){
        {
            __CLOVER_175_0.S[4230]++;ILink l = linkComponent.getLink(cycle);

            __CLOVER_175_0.S[4231]++;if ((((hasBody) && (++__CLOVER_175_0.CT[781] != 0)) || (++__CLOVER_175_0.CF[781] == 0))){
                __CLOVER_175_0.S[4232]++;writer.begin(getElement());}
            else{
                __CLOVER_175_0.S[4233]++;writer.beginEmpty(getElement());}

            __CLOVER_175_0.S[4234]++;writer.attribute(getUrlAttribute(), constructURL(l, linkComponent.getAnchor(), cycle));

            __CLOVER_175_0.S[4235]++;beforeBodyRender(writer, cycle, linkComponent);

            // Allow the wrapped components a chance to render.
            // Along the way, they may interact with this component
            // and cause the name variable to get set.

            __CLOVER_175_0.S[4236]++;wrappedWriter = writer.getNestedWriter();
        }}
        else{
            __CLOVER_175_0.S[4237]++;wrappedWriter = writer;}

        __CLOVER_175_0.S[4238]++;if ((((hasBody) && (++__CLOVER_175_0.CT[782] != 0)) || (++__CLOVER_175_0.CF[782] == 0))){
            __CLOVER_175_0.S[4239]++;linkComponent.renderBody(wrappedWriter, cycle);}

        __CLOVER_175_0.S[4240]++;if ((((!disabled) && (++__CLOVER_175_0.CT[783] != 0)) || (++__CLOVER_175_0.CF[783] == 0))){
        {
            __CLOVER_175_0.S[4241]++;afterBodyRender(writer, cycle, linkComponent);

            __CLOVER_175_0.S[4242]++;linkComponent.renderAdditionalAttributes(writer, cycle);

            __CLOVER_175_0.S[4243]++;if ((((hasBody) && (++__CLOVER_175_0.CT[784] != 0)) || (++__CLOVER_175_0.CF[784] == 0))){
            {
                __CLOVER_175_0.S[4244]++;wrappedWriter.close();

                // Close the <element> tag

                __CLOVER_175_0.S[4245]++;writer.end();
            }}
            else{
                __CLOVER_175_0.S[4246]++;writer.closeTag();}
        }}

        __CLOVER_175_0.S[4247]++;cycle.removeAttribute(Tapestry.LINK_COMPONENT_ATTRIBUTE_NAME);
    } finally { }}

    /**
     *  Converts the EngineServiceLink into a URI or URL.  This implementation
     *  simply invokes {@link ILink#getURL(String, boolean)}.
     * 
     **/

    protected String constructURL(ILink link, String anchor, IRequestCycle cycle)
    {try { __CLOVER_175_0.M[885]++;
        __CLOVER_175_0.S[4248]++;return link.getURL(anchor, true);
    } finally { }}

    /**
     *  Invoked after the href attribute has been written but before
     *  the body of the link is rendered (but only if the link
     *  is not disabled).
     * 
     *  <p>
     *  This implementation does nothing.
     * 
     **/

    protected void beforeBodyRender(IMarkupWriter writer, IRequestCycle cycle, ILinkComponent link)
    {try { __CLOVER_175_0.M[886]++;
    } finally { }}

    /**
     *  Invoked after the body of the link is rendered, but before
     *  {@link ILinkComponent#renderAdditionalAttributes(IMarkupWriter, IRequestCycle)} is invoked
     *  (but only if the link is not disabled).
     * 
     *  <p>
     *  This implementation does nothing.
     * 
     **/

    protected void afterBodyRender(IMarkupWriter writer, IRequestCycle cycle, ILinkComponent link)
    {try { __CLOVER_175_0.M[887]++;
    } finally { }}

    /** @since 3.0 **/

    protected String getElement()
    {try { __CLOVER_175_0.M[888]++;
        __CLOVER_175_0.S[4249]++;return "a";
    } finally { }}

    protected String getUrlAttribute()
    {try { __CLOVER_175_0.M[889]++;
        __CLOVER_175_0.S[4250]++;return "href";
    } finally { }}

    protected boolean getHasBody()
    {try { __CLOVER_175_0.M[890]++;
        __CLOVER_175_0.S[4251]++;return true;
    } finally { }}
}
