/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.multipart;

import java.util.ArrayList;
import java.util.List;

/**
 *  A portion of a multipart request that stores a value, or values, for
 *  a parameter.
 *
 *  @author Howard Lewis Ship
 *  @since 2.0.1
 *
 **/

public class ValuePart implements IPart
{public static com.cortexeb.tools.clover.d __CLOVER_189_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private int _count;
    // Stores either String or List of String
    private Object _value;

    public ValuePart(String value)
    {try { __CLOVER_189_0.M[945]++;
        __CLOVER_189_0.S[4448]++;_count = 1;
        __CLOVER_189_0.S[4449]++;_value = value;
    } finally { }}

    public int getCount()
    {try { __CLOVER_189_0.M[946]++;
        __CLOVER_189_0.S[4450]++;return _count;
    } finally { }}

    /**
     *  Returns the value, or the first value (if multi-valued).
     * 
     **/

    public String getValue()
    {try { __CLOVER_189_0.M[947]++;
        __CLOVER_189_0.S[4451]++;if ((((_count == 1) && (++__CLOVER_189_0.CT[820] != 0)) || (++__CLOVER_189_0.CF[820] == 0))){
            __CLOVER_189_0.S[4452]++;return (String) _value;}

        __CLOVER_189_0.S[4453]++;List l = (List) _value;

        __CLOVER_189_0.S[4454]++;return (String) l.get(0);
    } finally { }}

    /**
     *  Returns the values as an array of strings.  If there is only one value,
     *  it is returned wrapped as a single element array.
     * 
     **/

    public String[] getValues()
    {try { __CLOVER_189_0.M[948]++;
        __CLOVER_189_0.S[4455]++;if ((((_count == 1) && (++__CLOVER_189_0.CT[821] != 0)) || (++__CLOVER_189_0.CF[821] == 0))){
            __CLOVER_189_0.S[4456]++;return new String[] {(String) _value };}

        __CLOVER_189_0.S[4457]++;List l = (List) _value;

        __CLOVER_189_0.S[4458]++;return (String[]) l.toArray(new String[_count]);
    } finally { }}

    public void add(String newValue)
    {try { __CLOVER_189_0.M[949]++;
        __CLOVER_189_0.S[4459]++;if ((((_count == 1) && (++__CLOVER_189_0.CT[822] != 0)) || (++__CLOVER_189_0.CF[822] == 0))){
        {
            __CLOVER_189_0.S[4460]++;List l = new ArrayList();
            __CLOVER_189_0.S[4461]++;l.add(_value);
            __CLOVER_189_0.S[4462]++;l.add(newValue);

            __CLOVER_189_0.S[4463]++;_value = l;
            __CLOVER_189_0.S[4464]++;_count++;
            __CLOVER_189_0.S[4465]++;return;
        }}

        __CLOVER_189_0.S[4466]++;List l = (List) _value;
        __CLOVER_189_0.S[4467]++;l.add(newValue);
        __CLOVER_189_0.S[4468]++;_count++;
    } finally { }}

    /**
     *  Does nothing.
     * 
     **/

    public void cleanup()
    {try { __CLOVER_189_0.M[950]++;
    } finally { }}
}