/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.pageload;

import java.util.Collection;
import java.util.Iterator;

import org.apache.tapestry.IComponent;
import org.apache.tapestry.Tapestry;

/**
 *  Walks through the tree of components and invokes the visitors on each of 
 *  of the components in the tree.
 * 
 *  @author mindbridge
 *  @since 3.0
 */
public class ComponentTreeWalker
{public static com.cortexeb.tools.clover.d __CLOVER_190_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private IComponentVisitor[] _visitors;
    
    public ComponentTreeWalker(IComponentVisitor[] visitors)
    {try { __CLOVER_190_0.M[951]++;
        __CLOVER_190_0.S[4469]++;_visitors = visitors;
    } finally { }}

    public void walkComponentTree(IComponent component)
    {try { __CLOVER_190_0.M[952]++;
        // Invoke visitors
        __CLOVER_190_0.S[4470]++;for (int i = 0; (((i < _visitors.length) && (++__CLOVER_190_0.CT[823] != 0)) || (++__CLOVER_190_0.CF[823] == 0)); i++){
        {
            __CLOVER_190_0.S[4471]++;IComponentVisitor visitor = _visitors[i];
            __CLOVER_190_0.S[4472]++;visitor.visitComponent(component);
        }}

        // Recurse into the embedded components
        __CLOVER_190_0.S[4473]++;Collection components = component.getComponents().values();

        __CLOVER_190_0.S[4474]++;if ((((Tapestry.size(components) == 0) && (++__CLOVER_190_0.CT[824] != 0)) || (++__CLOVER_190_0.CF[824] == 0))){
            __CLOVER_190_0.S[4475]++;return;}

        __CLOVER_190_0.S[4476]++;for (Iterator it = components.iterator(); (((it.hasNext()) && (++__CLOVER_190_0.CT[825] != 0)) || (++__CLOVER_190_0.CF[825] == 0));){
        {
            __CLOVER_190_0.S[4477]++;IComponent embedded = (IComponent) it.next();
            __CLOVER_190_0.S[4478]++;walkComponentTree(embedded);
        }}
    } finally { }}
}
