/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.pageload;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.hivemind.Location;
import org.apache.tapestry.IComponent;
import org.apache.tapestry.Tapestry;
import org.apache.tapestry.event.PageDetachListener;
import org.apache.tapestry.event.PageEvent;
import org.apache.tapestry.util.prop.OgnlUtils;

/**
 *  Given a component, a property and a value, this object will
 *  reset the property to the value whenever the page
 *  (containing the component) is detached.  This is related
 *  to support for {@link org.apache.tapestry.spec.IPropertySpecification}s.
 *
 *  @author Howard Lewis Ship
 *  @since 3.0
 */

public class PropertyInitializer implements PageDetachListener
{public static com.cortexeb.tools.clover.d __CLOVER_197_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private IComponent _component;
    private String _propertyName;
    private String _expression;
    private boolean _invariant;
    private Object _value;
    private Location _location;

    public PropertyInitializer(
        IComponent component,
        String propertyName,
        String expression,
        Location location)
    {try { __CLOVER_197_0.M[1003]++;
        __CLOVER_197_0.S[4724]++;_component = component;
        __CLOVER_197_0.S[4725]++;_propertyName = propertyName;
        __CLOVER_197_0.S[4726]++;_expression = expression;
        __CLOVER_197_0.S[4727]++;_location = location;

        __CLOVER_197_0.S[4728]++;prepareInvariant();
    } finally { }}

    private void prepareInvariant()
    {try { __CLOVER_197_0.M[1004]++;
        __CLOVER_197_0.S[4729]++;_invariant = false;

        __CLOVER_197_0.S[4730]++;try
        {
            // If no initial value expression is provided, then read the current
            // property of the expression.  This may be null, or may be
            // a value set in finishLoad() (via an abstract accessor).

            __CLOVER_197_0.S[4731]++;if ((((Tapestry.isBlank(_expression)) && (++__CLOVER_197_0.CT[856] != 0)) || (++__CLOVER_197_0.CF[856] == 0))){
            {
                __CLOVER_197_0.S[4732]++;_invariant = true;
                __CLOVER_197_0.S[4733]++;_value = OgnlUtils.get(_propertyName, _component);
            }}
            else{
                __CLOVER_197_0.S[4734]++;if ((((OgnlUtils.isConstant(_expression)) && (++__CLOVER_197_0.CT[857] != 0)) || (++__CLOVER_197_0.CF[857] == 0))){
                {
                    // If the expression is a constant, evaluate it and remember the value 
                    __CLOVER_197_0.S[4735]++;_invariant = true;
                    __CLOVER_197_0.S[4736]++;_value = OgnlUtils.get(_expression, _component);
                }}}
        }
        catch (Exception ex)
        {
            __CLOVER_197_0.S[4737]++;throw new ApplicationRuntimeException(
                PageloadMessages.unableToInitializeProperty(_propertyName, _component, ex),
                _location,
                ex);
        }
    } finally { }}

    public void pageDetached(PageEvent event)
    {try { __CLOVER_197_0.M[1005]++;
        __CLOVER_197_0.S[4738]++;try
        {
            __CLOVER_197_0.S[4739]++;if ((((_invariant) && (++__CLOVER_197_0.CT[858] != 0)) || (++__CLOVER_197_0.CF[858] == 0))){
                __CLOVER_197_0.S[4740]++;OgnlUtils.set(_propertyName, _component, _value);}
            else{
            {
                __CLOVER_197_0.S[4741]++;Object value = OgnlUtils.get(_expression, _component);
                __CLOVER_197_0.S[4742]++;OgnlUtils.set(_propertyName, _component, value);
            }}
        }
        catch (Exception ex)
        {
            __CLOVER_197_0.S[4743]++;throw new ApplicationRuntimeException(
                PageloadMessages.unableToInitializeProperty(_propertyName, _component, ex),
                _location,
                ex);
        }
    } finally { }}

}
