/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.pageload;

import java.util.Iterator;

import org.apache.tapestry.IBinding;
import org.apache.tapestry.IComponent;
import org.apache.tapestry.spec.IComponentSpecification;

/**
 * Used to defer connection of inherited informal bindings.
 *
 * @author Howard Lewis Ship
 * @since 3.1
 */
class QueuedInheritInformalBindings implements IQueuedInheritedBinding
{public static com.cortexeb.tools.clover.d __CLOVER_198_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private IComponent _component;

    QueuedInheritInformalBindings(IComponent component)
    {try { __CLOVER_198_0.M[1006]++;
        __CLOVER_198_0.S[4744]++;_component = component;
    } finally { }}

    public void connect()
    {try { __CLOVER_198_0.M[1007]++;

        __CLOVER_198_0.S[4745]++;IComponent container = _component.getContainer();

        __CLOVER_198_0.S[4746]++;for (Iterator it = container.getBindingNames().iterator(); (((it.hasNext()) && (++__CLOVER_198_0.CT[859] != 0)) || (++__CLOVER_198_0.CF[859] == 0));){
        {
            __CLOVER_198_0.S[4747]++;String bindingName = (String) it.next();
            __CLOVER_198_0.S[4748]++;connectInformalBinding(container, _component, bindingName);
        }}
    } finally { }}

    private void connectInformalBinding(
        IComponent container,
        IComponent component,
        String bindingName)
    {try { __CLOVER_198_0.M[1008]++;
        __CLOVER_198_0.S[4749]++;IComponentSpecification componentSpec = component.getSpecification();
        __CLOVER_198_0.S[4750]++;IComponentSpecification containerSpec = container.getSpecification();

        // check if binding already exists in the component
        __CLOVER_198_0.S[4751]++;if ((((component.getBinding(bindingName) != null) && (++__CLOVER_198_0.CT[860] != 0)) || (++__CLOVER_198_0.CF[860] == 0))){
            __CLOVER_198_0.S[4752]++;return;}

        // check if parameter is informal for the component
        __CLOVER_198_0.S[4753]++;if ((((componentSpec.getParameter(bindingName) != null
            || componentSpec.isReservedParameterName(bindingName)) && (++__CLOVER_198_0.CT[861] != 0)) || (++__CLOVER_198_0.CF[861] == 0))){
            __CLOVER_198_0.S[4754]++;return;}

        // check if parameter is informal for the container
        __CLOVER_198_0.S[4755]++;if ((((containerSpec.getParameter(bindingName) != null
            || containerSpec.isReservedParameterName(bindingName)) && (++__CLOVER_198_0.CT[862] != 0)) || (++__CLOVER_198_0.CF[862] == 0))){
            __CLOVER_198_0.S[4756]++;return;}

        // if everything passes, establish binding
        __CLOVER_198_0.S[4757]++;IBinding binding = container.getBinding(bindingName);
        __CLOVER_198_0.S[4758]++;component.setBinding(bindingName, binding);
    } finally { }}
}