/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.parse;

import org.apache.commons.lang.enum.Enum;

/**
 * An {@link Enum} of the different possible token types.
 *
 * @see TemplateToken
 *
 * @author Howard Lewis Ship
 * 
 **/

public class TokenType extends Enum
{public static com.cortexeb.tools.clover.d __CLOVER_231_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    /**
     *  Raw HTML text.
     * 
     *  @see TextToken
     * 
     *
     **/

    public static final TokenType TEXT = new TokenType("TEXT");

    /**
     *  The opening tag of an element.
     * 
     *  @see OpenToken
     *
     **/

    public static final TokenType OPEN = new TokenType("OPEN");

    /**
     *  The closing tag of an element.
     * 
     *  @see CloseToken
     *
     **/

    public static final TokenType CLOSE = new TokenType("CLOSE");

    /**
     * 
     *  A reference to a localized string.
     * 
     *  @since 2.0.4
     * 
     **/
    
    public static final TokenType LOCALIZATION = new TokenType("LOCALIZATION");
    
    private TokenType(String name)
    {
        super(name);__CLOVER_231_0.S[5993]++;try { __CLOVER_231_0.M[1228]++;
    } finally { }}

}