/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.request;

/**
 *  Contains properties of an {@link javax.servlet.http.HttpServletRequest}
 *  that have been extracted from the request (or otherwise determined).
 * 
 *  <p>An alternative idea would have been to create a new 
 *  {@link javax.servlet.http.HttpServletRequest}
 *  wrapper that overode the various methods.  That struck me as causing
 *  more confusion; instead (in the few places it counts), classes will
 *  get the decoded properties from the {@link RequestContext}.
 *
 *  @see IRequestDecoder
 *  @see RequestContext#getScheme()
 *  @see RequestContext#getServerName()
 *  @see RequestContext#getServerPort()
 *  @see RequestContext#getRequestURI()
 * 
 *  @author Howard Lewis Ship
 *  @version DecodedRequest.java,v 1.1 2002/08/20 21:49:58 hship Exp
 *  @since 2.2
 * 
 **/

public class DecodedRequest
{public static com.cortexeb.tools.clover.d __CLOVER_237_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private String _scheme;
    private String _serverName;
    private String _requestURI;
    private int _serverPort;

    public int getServerPort()
    {try { __CLOVER_237_0.M[1256]++;
        __CLOVER_237_0.S[6126]++;return _serverPort;
    } finally { }}

    public String getScheme()
    {try { __CLOVER_237_0.M[1257]++;
        __CLOVER_237_0.S[6127]++;return _scheme;
    } finally { }}

    public String getServerName()
    {try { __CLOVER_237_0.M[1258]++;
        __CLOVER_237_0.S[6128]++;return _serverName;
    } finally { }}

    public String getRequestURI()
    {try { __CLOVER_237_0.M[1259]++;
        __CLOVER_237_0.S[6129]++;return _requestURI;
    } finally { }}

    public void setServerPort(int serverPort)
    {try { __CLOVER_237_0.M[1260]++;
        __CLOVER_237_0.S[6130]++;_serverPort = serverPort;
    } finally { }}

    public void setScheme(String scheme)
    {try { __CLOVER_237_0.M[1261]++;
        __CLOVER_237_0.S[6131]++;_scheme = scheme;
    } finally { }}

    public void setServerName(String serverName)
    {try { __CLOVER_237_0.M[1262]++;
        __CLOVER_237_0.S[6132]++;_serverName = serverName;
    } finally { }}

    public void setRequestURI(String URI)
    {try { __CLOVER_237_0.M[1263]++;
        __CLOVER_237_0.S[6133]++;_requestURI = URI;
    } finally { }}
}