/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.script;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.hivemind.ClassResolver;
import org.apache.hivemind.Location;
import org.apache.tapestry.util.prop.OgnlUtils;

/**
 *  Base class for creating tokens which may contain other tokens.
 *
 *  @author Howard Lewis Ship
 *  @since 0.2.9
 * 
 **/

abstract class AbstractToken implements IScriptToken
{public static com.cortexeb.tools.clover.d __CLOVER_251_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private List _tokens;
    private Location _location;
    private ClassResolver _resolver;

    protected AbstractToken(Location location)
    {try { __CLOVER_251_0.M[1362]++;
        __CLOVER_251_0.S[6694]++;_location = location;
    } finally { }}

    public Location getLocation()
    {try { __CLOVER_251_0.M[1363]++;
        __CLOVER_251_0.S[6695]++;return _location;
    } finally { }}

    public void addToken(IScriptToken token)
    {try { __CLOVER_251_0.M[1364]++;
        __CLOVER_251_0.S[6696]++;if ((((_tokens == null) && (++__CLOVER_251_0.CT[1186] != 0)) || (++__CLOVER_251_0.CF[1186] == 0))){
            __CLOVER_251_0.S[6697]++;_tokens = new ArrayList();}

        __CLOVER_251_0.S[6698]++;_tokens.add(token);
    } finally { }}

    /**
     *  Invokes {@link IScriptToken#write(StringBuffer,ScriptSession)}
     *  on each child token (if there are any).
     *
     **/

    protected void writeChildren(StringBuffer buffer, ScriptSession session)
    {try { __CLOVER_251_0.M[1365]++;
        __CLOVER_251_0.S[6699]++;if ((((_tokens == null) && (++__CLOVER_251_0.CT[1187] != 0)) || (++__CLOVER_251_0.CF[1187] == 0))){
            __CLOVER_251_0.S[6700]++;return;}

        __CLOVER_251_0.S[6701]++;Iterator i = _tokens.iterator();

        __CLOVER_251_0.S[6702]++;while ((((i.hasNext()) && (++__CLOVER_251_0.CT[1188] != 0)) || (++__CLOVER_251_0.CF[1188] == 0))){
        {
            __CLOVER_251_0.S[6703]++;IScriptToken token = (IScriptToken) i.next();

            __CLOVER_251_0.S[6704]++;token.write(buffer, session);
        }}
    } finally { }}

    /**
     * Evaluates the expression against the session's symbols, using
     * {@link OgnlUtils#get(String, ClassResolver, Object)} and
     * returns the result.
     */
    protected Object evaluate(String expression, ScriptSession session)
    {try { __CLOVER_251_0.M[1366]++;

        __CLOVER_251_0.S[6705]++;try
        {
            __CLOVER_251_0.S[6706]++;return OgnlUtils.get(expression, session.getSymbols());
        }
        catch (Exception ex)
        {
            __CLOVER_251_0.S[6707]++;throw new ApplicationRuntimeException(ex.getMessage(), _location, ex);
        }
    } finally { }}
}