/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.script;

import org.apache.hivemind.Location;
import org.apache.tapestry.util.xml.BaseRule;
import org.apache.tapestry.util.xml.RuleDirectedParser;

/**
 * Base class for the rules that build {@link org.apache.tapestry.script.IScriptToken}s.
 * Used with classes that can contain a mix of text and elements (those that
 * accept "full content").
 * 
 *
 * @author Howard Lewis Ship
 * @since 3.0
 **/

abstract class AbstractTokenRule extends BaseRule
{public static com.cortexeb.tools.clover.d __CLOVER_252_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);

    /**
     * Adds a token to its parent, the top object on the stack.
     */
    protected void addToParent(RuleDirectedParser parser, IScriptToken token)
    {try { __CLOVER_252_0.M[1367]++;
        __CLOVER_252_0.S[6708]++;IScriptToken parent = (IScriptToken) parser.peek();

        __CLOVER_252_0.S[6709]++;parent.addToken(token);
    } finally { }}

    /**
     * Peeks at the top object on the stack (which must be a {@link IScriptToken}),
     * and converts the text into a series of {@link org.apache.tapestry.script.StaticToken} and
     * {@link org.apache.tapestry.script.InsertToken}s.
     */

    public void content(RuleDirectedParser parser, String content)
    {try { __CLOVER_252_0.M[1368]++;
        __CLOVER_252_0.S[6710]++;IScriptToken token = (IScriptToken) parser.peek();

        __CLOVER_252_0.S[6711]++;addTextTokens(token, content, parser.getLocation());
    } finally { }}

    private static final int STATE_START = 0;
    private static final int STATE_DOLLAR = 1;
    private static final int STATE_COLLECT_EXPRESSION = 2;

    /**
     * Parses the provided text and converts it into a series of 
     */
    protected void addTextTokens(IScriptToken token, String text, Location location)
    {try { __CLOVER_252_0.M[1369]++;
        __CLOVER_252_0.S[6712]++;char[] buffer = text.toCharArray();
        __CLOVER_252_0.S[6713]++;int state = STATE_START;
        __CLOVER_252_0.S[6714]++;int blockStart = 0;
        __CLOVER_252_0.S[6715]++;int blockLength = 0;
        __CLOVER_252_0.S[6716]++;int expressionStart = -1;
        __CLOVER_252_0.S[6717]++;int expressionLength = 0;
        __CLOVER_252_0.S[6718]++;int i = 0;
        __CLOVER_252_0.S[6719]++;int braceDepth = 0;

        __CLOVER_252_0.S[6720]++;while ((((i < buffer.length) && (++__CLOVER_252_0.CT[1189] != 0)) || (++__CLOVER_252_0.CF[1189] == 0))){
        {
            __CLOVER_252_0.S[6721]++;char ch = buffer[i];

            __CLOVER_252_0.S[6722]++;switch (state)
            {
                case STATE_START :

                    __CLOVER_252_0.S[6723]++;if ((((ch == '$') && (++__CLOVER_252_0.CT[1190] != 0)) || (++__CLOVER_252_0.CF[1190] == 0))){
                    {
                        __CLOVER_252_0.S[6724]++;state = STATE_DOLLAR;
                        __CLOVER_252_0.S[6725]++;i++;
                        __CLOVER_252_0.S[6726]++;continue;
                    }}

                    __CLOVER_252_0.S[6727]++;blockLength++;
                    __CLOVER_252_0.S[6728]++;i++;
                    __CLOVER_252_0.S[6729]++;continue;

                case STATE_DOLLAR :

                    __CLOVER_252_0.S[6730]++;if ((((ch == '{') && (++__CLOVER_252_0.CT[1191] != 0)) || (++__CLOVER_252_0.CF[1191] == 0))){
                    {
                        __CLOVER_252_0.S[6731]++;state = STATE_COLLECT_EXPRESSION;
                        __CLOVER_252_0.S[6732]++;i++;

                        __CLOVER_252_0.S[6733]++;expressionStart = i;
                        __CLOVER_252_0.S[6734]++;expressionLength = 0;
                        __CLOVER_252_0.S[6735]++;braceDepth = 1;

                        __CLOVER_252_0.S[6736]++;continue;
                    }}

                    // The '$' was just what it was, not the start of a ${} expression
                    // block, so include it as part of the static text block.

                    __CLOVER_252_0.S[6737]++;blockLength++;

                    __CLOVER_252_0.S[6738]++;state = STATE_START;
                    __CLOVER_252_0.S[6739]++;continue;

                case STATE_COLLECT_EXPRESSION :

                    __CLOVER_252_0.S[6740]++;if ((((ch != '}') && (++__CLOVER_252_0.CT[1192] != 0)) || (++__CLOVER_252_0.CF[1192] == 0))){
                    {
                        __CLOVER_252_0.S[6741]++;if ((((ch == '{') && (++__CLOVER_252_0.CT[1193] != 0)) || (++__CLOVER_252_0.CF[1193] == 0))){
                            __CLOVER_252_0.S[6742]++;braceDepth++;}

                        __CLOVER_252_0.S[6743]++;i++;
                        __CLOVER_252_0.S[6744]++;expressionLength++;
                        __CLOVER_252_0.S[6745]++;continue;
                    }}

                    __CLOVER_252_0.S[6746]++;braceDepth--;

                    __CLOVER_252_0.S[6747]++;if ((((braceDepth > 0) && (++__CLOVER_252_0.CT[1194] != 0)) || (++__CLOVER_252_0.CF[1194] == 0))){
                    {
                        __CLOVER_252_0.S[6748]++;i++;
                        __CLOVER_252_0.S[6749]++;expressionLength++;
                        __CLOVER_252_0.S[6750]++;continue;
                    }}

                    // Hit the closing brace of an expression.

                    // Degenerate case:  the string "${}".

                    __CLOVER_252_0.S[6751]++;if ((((expressionLength == 0) && (++__CLOVER_252_0.CT[1195] != 0)) || (++__CLOVER_252_0.CF[1195] == 0))){
                        __CLOVER_252_0.S[6752]++;blockLength += 3;}

                    __CLOVER_252_0.S[6753]++;if ((((blockLength > 0) && (++__CLOVER_252_0.CT[1196] != 0)) || (++__CLOVER_252_0.CF[1196] == 0))){
                        __CLOVER_252_0.S[6754]++;token.addToken(constructStatic(text, blockStart, blockLength, location));}

                    __CLOVER_252_0.S[6755]++;if ((((expressionLength > 0) && (++__CLOVER_252_0.CT[1197] != 0)) || (++__CLOVER_252_0.CF[1197] == 0))){
                    {
                        __CLOVER_252_0.S[6756]++;String expression =
                            text.substring(expressionStart, expressionStart + expressionLength);

                        __CLOVER_252_0.S[6757]++;token.addToken(new InsertToken(expression, location));
                    }}

                    __CLOVER_252_0.S[6758]++;i++;
                    __CLOVER_252_0.S[6759]++;blockStart = i;
                    __CLOVER_252_0.S[6760]++;blockLength = 0;

                    // And drop into state start

                    __CLOVER_252_0.S[6761]++;state = STATE_START;

                    __CLOVER_252_0.S[6762]++;continue;
            }

        }}

        // OK, to handle the end.  Couple of degenerate cases where
        // a ${...} was incomplete, so we adust the block length.

        __CLOVER_252_0.S[6763]++;if ((((state == STATE_DOLLAR) && (++__CLOVER_252_0.CT[1198] != 0)) || (++__CLOVER_252_0.CF[1198] == 0))){
            __CLOVER_252_0.S[6764]++;blockLength++;}

        __CLOVER_252_0.S[6765]++;if ((((state == STATE_COLLECT_EXPRESSION) && (++__CLOVER_252_0.CT[1199] != 0)) || (++__CLOVER_252_0.CF[1199] == 0))){
            __CLOVER_252_0.S[6766]++;blockLength += expressionLength + 2;}

        __CLOVER_252_0.S[6767]++;if ((((blockLength > 0) && (++__CLOVER_252_0.CT[1200] != 0)) || (++__CLOVER_252_0.CF[1200] == 0))){
            __CLOVER_252_0.S[6768]++;token.addToken(constructStatic(text, blockStart, blockLength, location));}
    } finally { }}

    private IScriptToken constructStatic(
        String text,
        int blockStart,
        int blockLength,
        Location location)
    {try { __CLOVER_252_0.M[1370]++;
        __CLOVER_252_0.S[6769]++;String literal = text.substring(blockStart, blockStart + blockLength);

        __CLOVER_252_0.S[6770]++;return new StaticToken(literal, location);
    } finally { }}
}
