/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.script;

import java.util.Map;

import org.apache.hivemind.Resource;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.IScriptProcessor;

/**
 *  The result of executing a script, the session is used during the parsing
 *  process as well.  Following {@link org.apache.tapestry.IScript#execute(org.apache.tapestry.IRequestCycle, org.apache.tapestry.IScriptProcessor, java.util.Map)}, the session
 *  provides access to output symbols as well as the body and initialization
 *  blocks created by the script tokens.
 *
 *  @author Howard Lewis Ship
 *  @since 0.2.9
 * 
 **/

public class ScriptSession
{public static com.cortexeb.tools.clover.d __CLOVER_273_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private IRequestCycle _cycle;
    private IScriptProcessor _processor;
    private Resource _scriptLocation;
    private Map _symbols;

    public ScriptSession(
        Resource scriptLocation,
        IRequestCycle cycle,
        IScriptProcessor processor,
        Map symbols)
    {try { __CLOVER_273_0.M[1414]++;
        __CLOVER_273_0.S[6928]++;_scriptLocation = scriptLocation;
        __CLOVER_273_0.S[6929]++;_cycle = cycle;
        __CLOVER_273_0.S[6930]++;_processor = processor;
        __CLOVER_273_0.S[6931]++;_symbols = symbols;
    } finally { }}

    public Resource getScriptPath()
    {try { __CLOVER_273_0.M[1415]++;
        __CLOVER_273_0.S[6932]++;return _scriptLocation;
    } finally { }}

    public Map getSymbols()
    {try { __CLOVER_273_0.M[1416]++;
        __CLOVER_273_0.S[6933]++;return _symbols;
    } finally { }}

	public IRequestCycle getRequestCycle()
	{try { __CLOVER_273_0.M[1417]++;
		__CLOVER_273_0.S[6934]++;return _cycle;
	} finally { }}

    public IScriptProcessor getProcessor()
    {try { __CLOVER_273_0.M[1418]++;
        __CLOVER_273_0.S[6935]++;return _processor;
    } finally { }}

    public String toString()
    {try { __CLOVER_273_0.M[1419]++;
        __CLOVER_273_0.S[6936]++;StringBuffer buffer = new StringBuffer();

        __CLOVER_273_0.S[6937]++;buffer.append("ScriptSession[");
        __CLOVER_273_0.S[6938]++;buffer.append(_scriptLocation);
        __CLOVER_273_0.S[6939]++;buffer.append(']');

        __CLOVER_273_0.S[6940]++;return buffer.toString();
    } finally { }}
}