/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.services.impl;

import org.apache.hivemind.ClassResolver;
import org.apache.tapestry.engine.IComponentClassEnhancer;
import org.apache.tapestry.engine.IPageSource;
import org.apache.tapestry.engine.IPropertySource;
import org.apache.tapestry.engine.IScriptSource;
import org.apache.tapestry.engine.ISpecificationSource;
import org.apache.tapestry.services.ComponentMessagesSource;
import org.apache.tapestry.services.DataSqueezer;
import org.apache.tapestry.services.Infrastructure;
import org.apache.tapestry.services.ObjectPool;
import org.apache.tapestry.services.ResetEventCoordinator;
import org.apache.tapestry.services.ServiceMap;
import org.apache.tapestry.services.TemplateSource;
import org.apache.tapestry.spec.IApplicationSpecification;

/**
 * Allows access to selected HiveMind services.
 * 
 * @author Howard Lewis Ship
 * @since 3.1
 */
public class InfrastructureImpl implements Infrastructure
{public static com.cortexeb.tools.clover.d __CLOVER_315_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private IApplicationSpecification _applicationSpecification;

    private IPropertySource _applicationPropertySource;

    private ResetEventCoordinator _resetEventCoordinator;

    private ComponentMessagesSource _componentMessagesSource;

    private TemplateSource _templateSource;

    private ISpecificationSource _specificationSource;

    private ObjectPool _objectPool;

    private IComponentClassEnhancer _componentClassEnhancer;

    private IPageSource _pageSource;

    private ClassResolver _classResolver;

    private DataSqueezer _dataSqueezer;

    private IScriptSource _scriptSource;

    private ServiceMap _serviceMap;

    public IScriptSource getScriptSource()
    {try { __CLOVER_315_0.M[1532]++;
        __CLOVER_315_0.S[7327]++;return _scriptSource;
    } finally { }}

    public void setScriptSource(IScriptSource scriptSource)
    {try { __CLOVER_315_0.M[1533]++;
        __CLOVER_315_0.S[7328]++;_scriptSource = scriptSource;
    } finally { }}

    public DataSqueezer getDataSqueezer()
    {try { __CLOVER_315_0.M[1534]++;
        __CLOVER_315_0.S[7329]++;return _dataSqueezer;
    } finally { }}

    public void setDataSqueezer(DataSqueezer dataSqueezer)
    {try { __CLOVER_315_0.M[1535]++;
        __CLOVER_315_0.S[7330]++;_dataSqueezer = dataSqueezer;
    } finally { }}

    public void setApplicationPropertySource(IPropertySource source)
    {try { __CLOVER_315_0.M[1536]++;
        __CLOVER_315_0.S[7331]++;_applicationPropertySource = source;
    } finally { }}

    public IPropertySource getApplicationPropertySource()
    {try { __CLOVER_315_0.M[1537]++;
        __CLOVER_315_0.S[7332]++;return _applicationPropertySource;
    } finally { }}

    public ComponentMessagesSource getComponentMessagesSource()
    {try { __CLOVER_315_0.M[1538]++;
        __CLOVER_315_0.S[7333]++;return _componentMessagesSource;
    } finally { }}

    public ResetEventCoordinator getResetEventCoordinator()
    {try { __CLOVER_315_0.M[1539]++;
        __CLOVER_315_0.S[7334]++;return _resetEventCoordinator;
    } finally { }}

    public void setComponentMessagesSource(ComponentMessagesSource source)
    {try { __CLOVER_315_0.M[1540]++;
        __CLOVER_315_0.S[7335]++;_componentMessagesSource = source;
    } finally { }}

    public void setResetEventCoordinator(ResetEventCoordinator coordinator)
    {try { __CLOVER_315_0.M[1541]++;
        __CLOVER_315_0.S[7336]++;_resetEventCoordinator = coordinator;
    } finally { }}

    public TemplateSource getTemplateSource()
    {try { __CLOVER_315_0.M[1542]++;
        __CLOVER_315_0.S[7337]++;return _templateSource;
    } finally { }}

    public void setTemplateSource(TemplateSource source)
    {try { __CLOVER_315_0.M[1543]++;
        __CLOVER_315_0.S[7338]++;_templateSource = source;
    } finally { }}

    public ISpecificationSource getSpecificationSource()
    {try { __CLOVER_315_0.M[1544]++;
        __CLOVER_315_0.S[7339]++;return _specificationSource;
    } finally { }}

    public void setSpecificationSource(ISpecificationSource source)
    {try { __CLOVER_315_0.M[1545]++;
        __CLOVER_315_0.S[7340]++;_specificationSource = source;
    } finally { }}

    public ObjectPool getObjectPool()
    {try { __CLOVER_315_0.M[1546]++;
        __CLOVER_315_0.S[7341]++;return _objectPool;
    } finally { }}

    public void setObjectPool(ObjectPool pool)
    {try { __CLOVER_315_0.M[1547]++;
        __CLOVER_315_0.S[7342]++;_objectPool = pool;
    } finally { }}

    public IComponentClassEnhancer getComponentClassEnhancer()
    {try { __CLOVER_315_0.M[1548]++;
        __CLOVER_315_0.S[7343]++;return _componentClassEnhancer;
    } finally { }}

    public void setComponentClassEnhancer(IComponentClassEnhancer enhancer)
    {try { __CLOVER_315_0.M[1549]++;
        __CLOVER_315_0.S[7344]++;_componentClassEnhancer = enhancer;
    } finally { }}

    public IApplicationSpecification getApplicationSpecification()
    {try { __CLOVER_315_0.M[1550]++;
        __CLOVER_315_0.S[7345]++;return _applicationSpecification;
    } finally { }}

    public void setApplicationSpecification(IApplicationSpecification specification)
    {try { __CLOVER_315_0.M[1551]++;
        __CLOVER_315_0.S[7346]++;_applicationSpecification = specification;
    } finally { }}

    public IPageSource getPageSource()
    {try { __CLOVER_315_0.M[1552]++;
        __CLOVER_315_0.S[7347]++;return _pageSource;
    } finally { }}

    public void setPageSource(IPageSource source)
    {try { __CLOVER_315_0.M[1553]++;
        __CLOVER_315_0.S[7348]++;_pageSource = source;
    } finally { }}

    public ClassResolver getClassResolver()
    {try { __CLOVER_315_0.M[1554]++;
        __CLOVER_315_0.S[7349]++;return _classResolver;
    } finally { }}

    public void setClassResolver(ClassResolver resolver)
    {try { __CLOVER_315_0.M[1555]++;
        __CLOVER_315_0.S[7350]++;_classResolver = resolver;
    } finally { }}

    public ServiceMap getServiceMap()
    {try { __CLOVER_315_0.M[1556]++;
        __CLOVER_315_0.S[7351]++;return _serviceMap;
    } finally { }}

    public void setServiceMap(ServiceMap serviceMap)
    {try { __CLOVER_315_0.M[1557]++;
        __CLOVER_315_0.S[7352]++;_serviceMap = serviceMap;
    } finally { }}
}