/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.services.impl;
import org.apache.commons.logging.Log;
import org.apache.hivemind.ErrorHandler;
import org.apache.hivemind.Location;
import org.apache.hivemind.internal.Module;
import org.apache.hivemind.service.ObjectProvider;
import org.apache.hivemind.util.PropertyUtils;
import org.apache.tapestry.services.Infrastructure;

/**
 * An ObjectProvider that streamlines access to the 
 * central {@link org.apache.tapestry.services.Infrastructure} object.  The locator
 * for this provider is the name of a property of the Infrastructure. 
 *
 * @author Howard Lewis Ship
 * @since 3.1
 */

public class InfrastructureObjectProvider implements ObjectProvider
{public static com.cortexeb.tools.clover.d __CLOVER_316_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private Log _log;
    private ErrorHandler _errorHandler;
    private Infrastructure _infrastructure;

    public Object provideObject(
        Module contributingModule,
        Class propertyType,
        String locator,
        Location location)
    {try { __CLOVER_316_0.M[1558]++;
        __CLOVER_316_0.S[7353]++;try
        {
            __CLOVER_316_0.S[7354]++;return PropertyUtils.read(_infrastructure, locator);
        }
        catch (Throwable ex)
        {
            __CLOVER_316_0.S[7355]++;_errorHandler.error(
                _log,
                ImplMessages.unableToReadInfrastructureProperty(locator, _infrastructure, ex),
                location,
                ex);

            __CLOVER_316_0.S[7356]++;return null;
        }
    } finally { }}

    public void setErrorHandler(ErrorHandler handler)
    {try { __CLOVER_316_0.M[1559]++;
        __CLOVER_316_0.S[7357]++;_errorHandler = handler;
    } finally { }}

    public void setInfrastructure(Infrastructure infrastructure)
    {try { __CLOVER_316_0.M[1560]++;
        __CLOVER_316_0.S[7358]++;_infrastructure = infrastructure;
    } finally { }}

    public void setLog(Log log)
    {try { __CLOVER_316_0.M[1561]++;
        __CLOVER_316_0.S[7359]++;_log = log;
    } finally { }}

}
