/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.spec;

import java.util.ArrayList;
import java.util.List;

import org.apache.tapestry.bean.IBeanInitializer;

/**
 *  A specification of a helper bean for a component.
 *
 *  @author Howard Lewis Ship
 *  @since 1.0.4
 * 
 **/

public class BeanSpecification extends LocatablePropertyHolder implements IBeanSpecification
{public static com.cortexeb.tools.clover.d __CLOVER_343_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    protected String className;
    protected BeanLifecycle lifecycle;

    /** @since 1.0.9 **/
    private String description;

    /**
     *  A List of {@link IBeanInitializer}.
     *
     **/

    protected List initializers;

    public String getClassName()
    {try { __CLOVER_343_0.M[1676]++;
        __CLOVER_343_0.S[7698]++;return className;
    } finally { }}

    public BeanLifecycle getLifecycle()
    {try { __CLOVER_343_0.M[1677]++;
        __CLOVER_343_0.S[7699]++;return lifecycle;
    } finally { }}

    /**
     *  @since 1.0.5
     *
     **/

    public void addInitializer(IBeanInitializer initializer)
    {try { __CLOVER_343_0.M[1678]++;
        __CLOVER_343_0.S[7700]++;if ((((initializers == null) && (++__CLOVER_343_0.CT[1326] != 0)) || (++__CLOVER_343_0.CF[1326] == 0))){
            __CLOVER_343_0.S[7701]++;initializers = new ArrayList();}

        __CLOVER_343_0.S[7702]++;initializers.add(initializer);
    } finally { }}

    /**
     *  Returns the {@link List} of {@link IBeanInitializer}s.  The caller
     *  should not modify this value!.  May return null if there
     *  are no initializers.
     *
     *  @since 1.0.5
     *
     **/

    public List getInitializers()
    {try { __CLOVER_343_0.M[1679]++;
        __CLOVER_343_0.S[7703]++;return initializers;
    } finally { }}

    public String toString()
    {try { __CLOVER_343_0.M[1680]++;
        __CLOVER_343_0.S[7704]++;StringBuffer buffer = new StringBuffer("BeanSpecification[");

        __CLOVER_343_0.S[7705]++;buffer.append(className);
        __CLOVER_343_0.S[7706]++;buffer.append(", lifecycle ");
        __CLOVER_343_0.S[7707]++;buffer.append(lifecycle.getName());

        __CLOVER_343_0.S[7708]++;if ((((initializers != null && initializers.size() > 0) && (++__CLOVER_343_0.CT[1327] != 0)) || (++__CLOVER_343_0.CF[1327] == 0))){
        {
            __CLOVER_343_0.S[7709]++;buffer.append(", ");
            __CLOVER_343_0.S[7710]++;buffer.append(initializers.size());
            __CLOVER_343_0.S[7711]++;buffer.append(" initializers");
        }}

        __CLOVER_343_0.S[7712]++;buffer.append(']');

        __CLOVER_343_0.S[7713]++;return buffer.toString();
    } finally { }}

    public String getDescription()
    {try { __CLOVER_343_0.M[1681]++;
        __CLOVER_343_0.S[7714]++;return description;
    } finally { }}

    public void setDescription(String desc)
    {try { __CLOVER_343_0.M[1682]++;
        __CLOVER_343_0.S[7715]++;description = desc;
    } finally { }}

    /** @since 3.0 **/

    public void setClassName(String className)
    {try { __CLOVER_343_0.M[1683]++;
        __CLOVER_343_0.S[7716]++;this.className = className;
    } finally { }}
    
    /** @since 3.0 **/
    
    public void setLifecycle(BeanLifecycle lifecycle)
    {try { __CLOVER_343_0.M[1684]++;
        __CLOVER_343_0.S[7717]++;this.lifecycle = lifecycle;
    } finally { }}

}