/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.spec;

import org.apache.commons.lang.enum.Enum;

/**
 * Defines the different types of bindings possible for a component. These are used in the
 * {@link IBindingSpecification} and ultimately used to create an instance of
 * {@link org.apache.tapestry.IBinding}.
 * 
 * @author Howard Lewis Ship
 */

public final class BindingType extends Enum
{public static com.cortexeb.tools.clover.d __CLOVER_345_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    /**
     * Indicates that the binding value is a prefixed locator, ready for use
     * with {@link org.apache.tapestry.services.BindingSource}.
     */

    public static final BindingType PREFIXED = new BindingType("PREFIXED");

    public static final BindingType INHERITED = new BindingType("INHERITED");

    /**
     * Indicates a {@link org.apache.tapestry.binding.ListenerBinding}, a specialized kind of
     * binding that encapsulates a component listener as a script. Uses a subclass of
     * {@link BindingSpecification},{@link ListenerBindingSpecification}.
     * {@link IListenerBindingSpecification}.
     * 
     * @since 3.0
     */

    public static final BindingType LISTENER = new BindingType("LISTENER");

    private BindingType(String name)
    {
        super(name);__CLOVER_345_0.S[7722]++;try { __CLOVER_345_0.M[1689]++;
    } finally { }}

}