/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.spec;

import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

/**
 * Defines a contained component.  This includes the information needed to
 * get the contained component's specification, as well as any bindings
 * for the component.
 *
 * @author Howard Lewis Ship
 * 
 **/

public class ContainedComponent extends LocatablePropertyHolder implements IContainedComponent
{public static com.cortexeb.tools.clover.d __CLOVER_347_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
	private String type;

	private String copyOf;
    
    private boolean inheritInformalParameters;

	protected Map bindings;

	private static final int MAP_SIZE = 3;

	/**
	 *  Returns the named binding, or null if the binding does not
	 *  exist.
	 *
	 **/

	public IBindingSpecification getBinding(String name)
	{try { __CLOVER_347_0.M[1724]++;
		__CLOVER_347_0.S[7799]++;if ((((bindings == null) && (++__CLOVER_347_0.CT[1344] != 0)) || (++__CLOVER_347_0.CF[1344] == 0))){
			__CLOVER_347_0.S[7800]++;return null;}

		__CLOVER_347_0.S[7801]++;return (IBindingSpecification) bindings.get(name);
	} finally { }}

	/**
	 *  Returns an umodifiable <code>Collection</code>
	 *  of Strings, each the name of one binding
	 *  for the component.
	 *
	 **/

	public Collection getBindingNames()
	{try { __CLOVER_347_0.M[1725]++;
		__CLOVER_347_0.S[7802]++;if ((((bindings == null) && (++__CLOVER_347_0.CT[1345] != 0)) || (++__CLOVER_347_0.CF[1345] == 0))){
			__CLOVER_347_0.S[7803]++;return Collections.EMPTY_LIST;}

		__CLOVER_347_0.S[7804]++;return Collections.unmodifiableCollection(bindings.keySet());
	} finally { }}

	public String getType()
	{try { __CLOVER_347_0.M[1726]++;
		__CLOVER_347_0.S[7805]++;return type;
	} finally { }}

	public void setBinding(String name, IBindingSpecification spec)
	{try { __CLOVER_347_0.M[1727]++;
		__CLOVER_347_0.S[7806]++;if ((((bindings == null) && (++__CLOVER_347_0.CT[1346] != 0)) || (++__CLOVER_347_0.CF[1346] == 0))){
			__CLOVER_347_0.S[7807]++;bindings = new HashMap(MAP_SIZE);}

		__CLOVER_347_0.S[7808]++;bindings.put(name, spec);
	} finally { }}

	public void setType(String value)
	{try { __CLOVER_347_0.M[1728]++;
		__CLOVER_347_0.S[7809]++;type = value;
	} finally { }}

	/**
	 * 	Sets the String Id of the component being copied from.
	 *  For use by IDE tools like Spindle.
	 * 
	 *  @since 1.0.9
	 **/

	public void setCopyOf(String id)
	{try { __CLOVER_347_0.M[1729]++;
		__CLOVER_347_0.S[7810]++;copyOf = id;
	} finally { }}

	/**
	 * 	Returns the id of the component being copied from.
	 *  For use by IDE tools like Spindle.
	 * 
	 *  @since 1.0.9
	 **/

	public String getCopyOf()
	{try { __CLOVER_347_0.M[1730]++;
		__CLOVER_347_0.S[7811]++;return copyOf;
	} finally { }}

	/**
     * Returns whether the contained component will inherit 
     * the informal parameters of its parent. 
     * 
	 * @since 3.0
	 **/
	public boolean getInheritInformalParameters()
	{try { __CLOVER_347_0.M[1731]++;
		__CLOVER_347_0.S[7812]++;return inheritInformalParameters;
	} finally { }}

	/**
     * Sets whether the contained component will inherit 
     * the informal parameters of its parent. 
     * 
     * @since 3.0
	 */
	public void setInheritInformalParameters(boolean value)
	{try { __CLOVER_347_0.M[1732]++;
		__CLOVER_347_0.S[7813]++;inheritInformalParameters = value;
	} finally { }}

}