/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.test;

import org.apache.hivemind.Location;
import org.apache.hivemind.impl.MessageFormatter;
import org.apache.hivemind.service.ClassFabUtils;

/**
 * Container of static methods to format logging and exception messages, used
 * within the org.apache.tapesty.test package (and a few sub-packages).
 * 
 * <p>Technically, these are messages for the test package, and this class
 * should be called TestMessages ... but that's always a bad idea (it makes
 * the class look like a JUnit test suite).
 * 
 * <p>This class is public, not package private, because some related
 * sub-packages make use of it as well.
 *
 * @author Howard Lewis Ship
 * @since 3.1
 */
public final class ScriptMessages
{public static com.cortexeb.tools.clover.d __CLOVER_373_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private static final MessageFormatter _formatter =
        new MessageFormatter(ScriptMessages.class, "ScriptStrings");

    public static String expectedSubstringMissing(String substring, Location location)
    {try { __CLOVER_373_0.M[1894]++;
        __CLOVER_373_0.S[8291]++;return _formatter.format("expected-substring-missing", substring, location);
    } finally { }}

    public static String expectedRegexpMissing(String regexp, Location location)
    {try { __CLOVER_373_0.M[1895]++;
        __CLOVER_373_0.S[8292]++;return _formatter.format("expected-regexp-missing", regexp, location);
    } finally { }}

    public static String unexpectedAttributeInElement(String attributeName, String elementName)
    {try { __CLOVER_373_0.M[1896]++;
        __CLOVER_373_0.S[8293]++;return _formatter.format("unexpected-attribute-in-element", attributeName, elementName);
    } finally { }}

    public static String missingRequiredAttribute(String attributeName, String elementName)
    {try { __CLOVER_373_0.M[1897]++;
        __CLOVER_373_0.S[8294]++;return _formatter.format("missing-required-attribute", attributeName, elementName);
    } finally { }}

    public static String invalidIntAttribute(
        String attributeName,
        String elementName,
        Location location,
        String attributeValue)
    {try { __CLOVER_373_0.M[1898]++;
        __CLOVER_373_0.S[8295]++;return _formatter.format(
            "invalid-int-attribute",
            new Object[] { attributeName, elementName, location, attributeValue });
    } finally { }}

    public static String incorrectRegexpMatch(
        String expectedMatch,
        Location location,
        String actualMatch)
    {try { __CLOVER_373_0.M[1899]++;
        __CLOVER_373_0.S[8296]++;return _formatter.format("incorrect-regexp-match", expectedMatch, location, actualMatch);
    } finally { }}

    public static String incorrectRegexpMatchCount(
        String pattern,
        Location location,
        int expectedCount,
        int actualCount)
    {try { __CLOVER_373_0.M[1900]++;
        __CLOVER_373_0.S[8297]++;return _formatter.format(
            "incorrect-regexp-match-count",
            new Object[] {
                pattern,
                location,
                new Integer(expectedCount),
                new Integer(actualCount)});
    } finally { }}

    public static String wrongTypeForEnhancement(Class type)
    {try { __CLOVER_373_0.M[1901]++;
        __CLOVER_373_0.S[8298]++;return _formatter.format(
            "wrong-type-for-enhancement",
            ClassFabUtils.getJavaClassName(type));
    } finally { }}

    public static String classNotAbstract(Class type)
    {try { __CLOVER_373_0.M[1902]++;
        __CLOVER_373_0.S[8299]++;return _formatter.format("class-not-abstract", type.getName());
    } finally { }}

    public static String unableToIntrospect(Class type, Throwable cause)
    {try { __CLOVER_373_0.M[1903]++;
        __CLOVER_373_0.S[8300]++;return _formatter.format("unable-to-introspect", type.getName(), cause);
    } finally { }}

    public static String unableToInstantiate(Class abstractClass, Throwable cause)
    {try { __CLOVER_373_0.M[1904]++;
        __CLOVER_373_0.S[8301]++;return _formatter.format("unable-to-instantiate", abstractClass.getName(), cause);
    } finally { }}
}
