/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.test;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import javax.servlet.http.HttpServlet;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.tapestry.test.mock.InitParameterHolder;
import org.apache.tapestry.test.mock.MockContext;
import org.apache.tapestry.test.mock.MockRequest;
import org.apache.tapestry.test.mock.MockResponse;
import org.apache.tapestry.test.mock.MockServletConfig;
import org.apache.tapestry.util.RegexpMatcher;

/**
 * Executes a series of requests and assertions specified by
 * a {@link org.apache.tapestry.test.ScriptDescriptor).
 *
 * @author Howard Lewis Ship
 * @since 3.1
 */
public class ScriptedTestSession
{public static com.cortexeb.tools.clover.d __CLOVER_375_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private ScriptDescriptor _scriptDescriptor;
    private MockContext _context;
    private MockRequest _request;
    private MockResponse _response;
    private RegexpMatcher _matcher = new RegexpMatcher();

    public ScriptedTestSession(ScriptDescriptor descriptor)
    {try { __CLOVER_375_0.M[1906]++;
        __CLOVER_375_0.S[8302]++;_scriptDescriptor = descriptor;
    } finally { }}

    public void execute()
    {try { __CLOVER_375_0.M[1907]++;
        __CLOVER_375_0.S[8303]++;setupForExecute();

        __CLOVER_375_0.S[8304]++;Iterator i = _scriptDescriptor.getRequestDescriptors().iterator();

        __CLOVER_375_0.S[8305]++;while ((((i.hasNext()) && (++__CLOVER_375_0.CT[1407] != 0)) || (++__CLOVER_375_0.CF[1407] == 0))){
        {
            __CLOVER_375_0.S[8306]++;RequestDescriptor rd = (RequestDescriptor) i.next();

            __CLOVER_375_0.S[8307]++;executeRequest(rd);
        }}
    } finally { }}

    private void setupForExecute()
    {try { __CLOVER_375_0.M[1908]++;
        __CLOVER_375_0.S[8308]++;_context = new MockContext(_scriptDescriptor.getRootDirectory());
        __CLOVER_375_0.S[8309]++;_context.setServletContextName(_scriptDescriptor.getContextName());
    } finally { }}

    private void executeRequest(RequestDescriptor rd)
    {try { __CLOVER_375_0.M[1909]++;
        __CLOVER_375_0.S[8310]++;HttpServlet s = getServlet(rd.getServletName());

        __CLOVER_375_0.S[8311]++;_request = new MockRequest(_context, rd.getServletPath());

        __CLOVER_375_0.S[8312]++;loadParameters(_request, rd);

        __CLOVER_375_0.S[8313]++;_response = new MockResponse(_request);

        __CLOVER_375_0.S[8314]++;try
        {
            __CLOVER_375_0.S[8315]++;s.service(_request, _response);
        }
        catch (Exception ex)
        {
            __CLOVER_375_0.S[8316]++;throw new ApplicationRuntimeException(
                "Error executing request: " + ex.getMessage(),
                rd.getLocation(),
                ex);
        }

        __CLOVER_375_0.S[8317]++;rd.executeAssertions(this);
    } finally { }}

    private void loadParameters(MockRequest request, RequestDescriptor rd)
    {try { __CLOVER_375_0.M[1910]++;
        __CLOVER_375_0.S[8318]++;String[] names = rd.getParameterNames();

        __CLOVER_375_0.S[8319]++;for (int i = 0; (((i < names.length) && (++__CLOVER_375_0.CT[1408] != 0)) || (++__CLOVER_375_0.CF[1408] == 0)); i++){
        {
            __CLOVER_375_0.S[8320]++;String[] values = rd.getParameterValues(names[i]);

            __CLOVER_375_0.S[8321]++;request.setParameter(names[i], values);
        }}
    } finally { }}

    private Map _servlets = new HashMap();

    private HttpServlet getServlet(String name)
    {try { __CLOVER_375_0.M[1911]++;
        __CLOVER_375_0.S[8322]++;if ((((name == null) && (++__CLOVER_375_0.CT[1409] != 0)) || (++__CLOVER_375_0.CF[1409] == 0))){
            __CLOVER_375_0.S[8323]++;name = _scriptDescriptor.getDefaultServletDescriptor().getName();}

        __CLOVER_375_0.S[8324]++;HttpServlet result = (HttpServlet) _servlets.get(name);

        __CLOVER_375_0.S[8325]++;if ((((result == null) && (++__CLOVER_375_0.CT[1410] != 0)) || (++__CLOVER_375_0.CF[1410] == 0))){
        {
            __CLOVER_375_0.S[8326]++;result = readyServlet(name);
            __CLOVER_375_0.S[8327]++;_servlets.put(name, result);
        }}

        __CLOVER_375_0.S[8328]++;return result;
    } finally { }}

    private HttpServlet readyServlet(String name)
    {try { __CLOVER_375_0.M[1912]++;
        __CLOVER_375_0.S[8329]++;ServletDescriptor sd = _scriptDescriptor.getServletDescriptor(name);

        __CLOVER_375_0.S[8330]++;HttpServlet result = instantiateServlet(sd);

        __CLOVER_375_0.S[8331]++;MockServletConfig config = new MockServletConfig(name, _context);

        __CLOVER_375_0.S[8332]++;loadInitParameters(config, sd.getInitParameters());

        __CLOVER_375_0.S[8333]++;try
        {
            __CLOVER_375_0.S[8334]++;result.init(config);
        }
        catch (Exception ex)
        {
            __CLOVER_375_0.S[8335]++;throw new ApplicationRuntimeException(
                "Unable to initialize servlet '" + name + "': " + ex.getMessage(),
                sd.getLocation(),
                ex);
        }

        __CLOVER_375_0.S[8336]++;return result;
    } finally { }}

    private void loadInitParameters(InitParameterHolder holder, Map parameters)
    {try { __CLOVER_375_0.M[1913]++;
        __CLOVER_375_0.S[8337]++;Iterator i = parameters.entrySet().iterator();
        __CLOVER_375_0.S[8338]++;while ((((i.hasNext()) && (++__CLOVER_375_0.CT[1411] != 0)) || (++__CLOVER_375_0.CF[1411] == 0))){
        {
            __CLOVER_375_0.S[8339]++;Map.Entry e = (Map.Entry) i.next();

            __CLOVER_375_0.S[8340]++;String name = (String) e.getKey();
            __CLOVER_375_0.S[8341]++;String value = (String) e.getValue();

            __CLOVER_375_0.S[8342]++;holder.setInitParameter(name, value);
        }}
    } finally { }}

    private HttpServlet instantiateServlet(ServletDescriptor sd)
    {try { __CLOVER_375_0.M[1914]++;
        __CLOVER_375_0.S[8343]++;String className = sd.getClassName();
        __CLOVER_375_0.S[8344]++;ClassLoader loader = Thread.currentThread().getContextClassLoader();

        __CLOVER_375_0.S[8345]++;try
        {
            __CLOVER_375_0.S[8346]++;Class servletClass = Class.forName(className, true, loader);

            __CLOVER_375_0.S[8347]++;return (HttpServlet) servletClass.newInstance();
        }
        catch (Exception ex)
        {
            __CLOVER_375_0.S[8348]++;throw new ApplicationRuntimeException(
                "Unable to instantiate servlet '" + sd.getName() + "': " + ex.getMessage(),
                sd.getLocation(),
                ex);
        }
    } finally { }}

    /** Inteaded only for use by the test suite. */

    void setResponse(MockResponse response)
    {try { __CLOVER_375_0.M[1915]++;
        __CLOVER_375_0.S[8349]++;_response = response;
    } finally { }}

    public MockResponse getResponse()
    {try { __CLOVER_375_0.M[1916]++;
        __CLOVER_375_0.S[8350]++;return _response;
    } finally { }}

    public RegexpMatcher getMatcher()
    {try { __CLOVER_375_0.M[1917]++;
        __CLOVER_375_0.S[8351]++;return _matcher;
    } finally { }}

}
