/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.test.mock;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.Collections;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import org.apache.hivemind.ApplicationRuntimeException;

/**
 *  
 * Base class for holders of named attributes such as
 * {@link javax.servlet.http.HttpSession}, 
 * {@link javax.servlet.http.HttpServletRequest}
 * and {@link javax.servlet.ServletContext}.
 *
 *
 * @author Howard Lewis Ship
 * @since 3.1
 */

public class AttributeHolder
{public static com.cortexeb.tools.clover.d __CLOVER_380_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private Map _attributes = new HashMap();

    public Object getAttribute(String name)
    {try { __CLOVER_380_0.M[1934]++;
        __CLOVER_380_0.S[8392]++;return _attributes.get(name);
    } finally { }}

    public Enumeration getAttributeNames()
    {try { __CLOVER_380_0.M[1935]++;
        __CLOVER_380_0.S[8393]++;return getEnumeration(_attributes);
    } finally { }}

    protected Enumeration getEnumeration(Map map)
    {try { __CLOVER_380_0.M[1936]++;
        __CLOVER_380_0.S[8394]++;return Collections.enumeration(map.keySet());
    } finally { }}

    public String[] getAttributeNamesArray()
    {try { __CLOVER_380_0.M[1937]++;
        __CLOVER_380_0.S[8395]++;Set keys = _attributes.keySet();
        __CLOVER_380_0.S[8396]++;int count = keys.size();

        __CLOVER_380_0.S[8397]++;String[] array = new String[count];

        __CLOVER_380_0.S[8398]++;return (String[]) keys.toArray(array);
    } finally { }}

    public void setAttribute(String name, Object value)
    {try { __CLOVER_380_0.M[1938]++;
        __CLOVER_380_0.S[8399]++;_attributes.put(name, value);
    } finally { }}

    public void removeAttribute(String name)
    {try { __CLOVER_380_0.M[1939]++;
        __CLOVER_380_0.S[8400]++;_attributes.remove(name);
    } finally { }}

    /**
     *  Serializes and then deserializes the {@link Map}
     *  containing all attributes.
     * 
     **/

    public void simulateFailover()
    {try { __CLOVER_380_0.M[1940]++;
        __CLOVER_380_0.S[8401]++;byte[] serialized = serializeAttributes();

        __CLOVER_380_0.S[8402]++;_attributes = null;

        __CLOVER_380_0.S[8403]++;Map restoredAttributes = deserializeAttributes(serialized);

        __CLOVER_380_0.S[8404]++;_attributes = restoredAttributes;
    } finally { }}

    private byte[] serializeAttributes()
    {try { __CLOVER_380_0.M[1941]++;
        __CLOVER_380_0.S[8405]++;try
        {
            __CLOVER_380_0.S[8406]++;ByteArrayOutputStream bos = new ByteArrayOutputStream();
            __CLOVER_380_0.S[8407]++;ObjectOutputStream oos = new ObjectOutputStream(bos);

            __CLOVER_380_0.S[8408]++;oos.writeObject(_attributes);

            __CLOVER_380_0.S[8409]++;oos.close();

            __CLOVER_380_0.S[8410]++;return bos.toByteArray();
        }
        catch (IOException ex)
        {
            __CLOVER_380_0.S[8411]++;throw new ApplicationRuntimeException("Unable to serialize attributes.", ex);
        }
    } finally { }}

    private Map deserializeAttributes(byte[] serialized)
    {try { __CLOVER_380_0.M[1942]++;
        __CLOVER_380_0.S[8412]++;try
        {
            __CLOVER_380_0.S[8413]++;ByteArrayInputStream bis = new ByteArrayInputStream(serialized);
            __CLOVER_380_0.S[8414]++;ObjectInputStream ois = new ObjectInputStream(bis);

            __CLOVER_380_0.S[8415]++;Map result = (Map) ois.readObject();

            __CLOVER_380_0.S[8416]++;return result;
        }
        catch (Exception ex)
        {
            __CLOVER_380_0.S[8417]++;throw new ApplicationRuntimeException("Unable to deserialize attributes.", ex);
        }
    } finally { }}
}
