/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.test.mock;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Collections;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import javax.servlet.RequestDispatcher;
import javax.servlet.Servlet;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;

/**
 * Mock implementation of {@link javax.servlet.ServletContext}.
 *
 * @author Howard Lewis Ship
 * @since 3.1
 */

public class MockContext extends AttributeHolder implements ServletContext, InitParameterHolder
{public static com.cortexeb.tools.clover.d __CLOVER_382_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private MockSession _session;

    private static final Map _suffixToContentType = new HashMap();

    static {
        __CLOVER_382_0.S[8418]++;_suffixToContentType.put("html", "text/html");
        __CLOVER_382_0.S[8419]++;_suffixToContentType.put("gif", "image/gif");
        __CLOVER_382_0.S[8420]++;_suffixToContentType.put("png", "image/png");
    }

    private String _rootDirectory;
    private String _servletContextName = "test";
    private Map _initParameters = new HashMap();

    public MockContext()
    {try { __CLOVER_382_0.M[1943]++;
    } finally { }}

    public MockContext(String testDirectory)
    {try { __CLOVER_382_0.M[1944]++;
        __CLOVER_382_0.S[8421]++;_rootDirectory = testDirectory + "/context";
    } finally { }}

    public ServletContext getContext(String name)
    {try { __CLOVER_382_0.M[1945]++;
        __CLOVER_382_0.S[8422]++;return null;
    } finally { }}

    public int getMajorVersion()
    {try { __CLOVER_382_0.M[1946]++;
        __CLOVER_382_0.S[8423]++;return 2;
    } finally { }}

    public int getMinorVersion()
    {try { __CLOVER_382_0.M[1947]++;
        __CLOVER_382_0.S[8424]++;return 1;
    } finally { }}

    public String getMimeType(String path)
    {try { __CLOVER_382_0.M[1948]++;
        __CLOVER_382_0.S[8425]++;int lastx = path.lastIndexOf('.');
        __CLOVER_382_0.S[8426]++;String suffix = path.substring(lastx + 1);

        __CLOVER_382_0.S[8427]++;return (String) _suffixToContentType.get(suffix);
    } finally { }}

    public Set getResourcePaths(String arg0)
    {try { __CLOVER_382_0.M[1949]++;
        __CLOVER_382_0.S[8428]++;return null;
    } finally { }}

    public URL getResource(String path) throws MalformedURLException
    {try { __CLOVER_382_0.M[1950]++;
        __CLOVER_382_0.S[8429]++;if ((((path == null || !path.startsWith("/")) && (++__CLOVER_382_0.CT[1419] != 0)) || (++__CLOVER_382_0.CF[1419] == 0))){
            __CLOVER_382_0.S[8430]++;throw new MalformedURLException("Not a valid context path.");}

        __CLOVER_382_0.S[8431]++;String fullPath = _rootDirectory + path;

        __CLOVER_382_0.S[8432]++;File file = new File(fullPath);

        __CLOVER_382_0.S[8433]++;if ((((file.exists()) && (++__CLOVER_382_0.CT[1420] != 0)) || (++__CLOVER_382_0.CF[1420] == 0))){
            __CLOVER_382_0.S[8434]++;return file.toURL();}

        __CLOVER_382_0.S[8435]++;return null;
    } finally { }}

    public InputStream getResourceAsStream(String path)
    {try { __CLOVER_382_0.M[1951]++;
        __CLOVER_382_0.S[8436]++;try
        {
            __CLOVER_382_0.S[8437]++;URL url = getResource(path);

            __CLOVER_382_0.S[8438]++;if ((((url == null) && (++__CLOVER_382_0.CT[1421] != 0)) || (++__CLOVER_382_0.CF[1421] == 0))){
                __CLOVER_382_0.S[8439]++;return null;}

            __CLOVER_382_0.S[8440]++;return url.openStream();
        }
        catch (MalformedURLException ex)
        {
            __CLOVER_382_0.S[8441]++;return null;
        }
        catch (IOException ex)
        {
            __CLOVER_382_0.S[8442]++;return null;
        }
    } finally { }}

    /**
     *  Gets a dispatcher for the given path.  Path should be a relative path (relative
     *  to the context).  A special case:  "NULL" returns null (i.e., when a 
     *  dispatcher can't be found).
     * 
     **/

    public RequestDispatcher getRequestDispatcher(String path)
    {try { __CLOVER_382_0.M[1952]++;
        __CLOVER_382_0.S[8443]++;if ((((path.endsWith("/NULL")) && (++__CLOVER_382_0.CT[1422] != 0)) || (++__CLOVER_382_0.CF[1422] == 0))){
            __CLOVER_382_0.S[8444]++;return null;}

        __CLOVER_382_0.S[8445]++;StringBuffer buffer = new StringBuffer(_rootDirectory);
        __CLOVER_382_0.S[8446]++;buffer.append(path);

        // Simulate the handling of directories by serving the index.html
        // in the directory.

        __CLOVER_382_0.S[8447]++;if ((((path.endsWith("/")) && (++__CLOVER_382_0.CT[1423] != 0)) || (++__CLOVER_382_0.CF[1423] == 0))){
            __CLOVER_382_0.S[8448]++;buffer.append("index.html");}

        __CLOVER_382_0.S[8449]++;return new MockRequestDispatcher(buffer.toString());
    } finally { }}

    public RequestDispatcher getNamedDispatcher(String name)
    {try { __CLOVER_382_0.M[1953]++;
        __CLOVER_382_0.S[8450]++;return null;
    } finally { }}

    public Servlet getServlet(String name) throws ServletException
    {try { __CLOVER_382_0.M[1954]++;
        __CLOVER_382_0.S[8451]++;return null;
    } finally { }}

    public Enumeration getServlets()
    {try { __CLOVER_382_0.M[1955]++;
        __CLOVER_382_0.S[8452]++;return null;
    } finally { }}

    public Enumeration getServletNames()
    {try { __CLOVER_382_0.M[1956]++;
        __CLOVER_382_0.S[8453]++;return null;
    } finally { }}

    public void log(String message)
    {try { __CLOVER_382_0.M[1957]++;
        __CLOVER_382_0.S[8454]++;log(message, null);
    } finally { }}

    public void log(Exception exception, String message)
    {try { __CLOVER_382_0.M[1958]++;
        __CLOVER_382_0.S[8455]++;log(message, exception);
    } finally { }}

    public void log(String message, Throwable exception)
    {try { __CLOVER_382_0.M[1959]++;
    } finally { }}

    public String getRealPath(String arg0)
    {try { __CLOVER_382_0.M[1960]++;
        __CLOVER_382_0.S[8456]++;return null;
    } finally { }}

    public String getServerInfo()
    {try { __CLOVER_382_0.M[1961]++;
        __CLOVER_382_0.S[8457]++;return "Tapestry Mock Objects";
    } finally { }}

    public String getInitParameter(String name)
    {try { __CLOVER_382_0.M[1962]++;
        __CLOVER_382_0.S[8458]++;return (String) _initParameters.get(name);
    } finally { }}

    public Enumeration getInitParameterNames()
    {try { __CLOVER_382_0.M[1963]++;
        __CLOVER_382_0.S[8459]++;return Collections.enumeration(_initParameters.keySet());
    } finally { }}

    public void setInitParameter(String name, String value)
    {try { __CLOVER_382_0.M[1964]++;
        __CLOVER_382_0.S[8460]++;_initParameters.put(name, value);
    } finally { }}

    public String getServletContextName()
    {try { __CLOVER_382_0.M[1965]++;
        __CLOVER_382_0.S[8461]++;return _servletContextName;
    } finally { }}

    public MockSession createSession()
    {try { __CLOVER_382_0.M[1966]++;
        __CLOVER_382_0.S[8462]++;if ((((_session == null) && (++__CLOVER_382_0.CT[1424] != 0)) || (++__CLOVER_382_0.CF[1424] == 0))){
        {
            __CLOVER_382_0.S[8463]++;String id = Long.toHexString(System.currentTimeMillis());

            __CLOVER_382_0.S[8464]++;_session = new MockSession(this, id);
        }}

        __CLOVER_382_0.S[8465]++;return _session;
    } finally { }}

    public MockSession getSession()
    {try { __CLOVER_382_0.M[1967]++;
        __CLOVER_382_0.S[8466]++;return _session;
    } finally { }}

    public void setServletContextName(String servletContextName)
    {try { __CLOVER_382_0.M[1968]++;
        __CLOVER_382_0.S[8467]++;_servletContextName = servletContextName;
    } finally { }}

    public String getRootDirectory()
    {try { __CLOVER_382_0.M[1969]++;
        __CLOVER_382_0.S[8468]++;return _rootDirectory;
    } finally { }}

    public void setRootDirectory(String rootDirectory)
    {try { __CLOVER_382_0.M[1970]++;
        __CLOVER_382_0.S[8469]++;_rootDirectory = rootDirectory;
    } finally { }}

}
