/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.test.mock;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

/**
 * Used to enable mock testing of internal request forwarding.
 *
 * @author Howard Lewis Ship
 * @since 3.1
 */
public class MockRequestDispatcher implements RequestDispatcher
{public static com.cortexeb.tools.clover.d __CLOVER_384_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);	
	private String _resourcePath;
	
    public MockRequestDispatcher(String resourcePath)
    {try { __CLOVER_384_0.M[2034]++;
    	__CLOVER_384_0.S[8554]++;_resourcePath = resourcePath;
    } finally { }}

    public void forward(ServletRequest request, ServletResponse response)
        throws ServletException, IOException
    {try { __CLOVER_384_0.M[2035]++;
    	__CLOVER_384_0.S[8555]++;if ((((_resourcePath.endsWith("/FAIL_SERVLET")) && (++__CLOVER_384_0.CT[1434] != 0)) || (++__CLOVER_384_0.CF[1434] == 0))){
    		__CLOVER_384_0.S[8556]++;throw new ServletException("Test-directed ServletException from RequestDispatcher forward().");}
    	
    	// For testing purposes, assume we only forward to static HTML files.
    	
     	
    	__CLOVER_384_0.S[8557]++;InputStream in = new FileInputStream(_resourcePath);

   		__CLOVER_384_0.S[8558]++;response.setContentType("test/html");
    	
    	__CLOVER_384_0.S[8559]++;OutputStream out =	response.getOutputStream();

    	
    	__CLOVER_384_0.S[8560]++;byte[] buffer = new byte[1000];
    	
    	__CLOVER_384_0.S[8561]++;while (true){
    	{
    		__CLOVER_384_0.S[8562]++;int length = in.read(buffer);
    		
    		__CLOVER_384_0.S[8563]++;if ((((length < 0) && (++__CLOVER_384_0.CT[1435] != 0)) || (++__CLOVER_384_0.CF[1435] == 0))){
    			__CLOVER_384_0.S[8564]++;break;}
    			
    		__CLOVER_384_0.S[8565]++;out.write(buffer, 0, length);
    	}}
    	
    	__CLOVER_384_0.S[8566]++;in.close();
    	__CLOVER_384_0.S[8567]++;out.close();
    } finally { }}

    public void include(ServletRequest request, ServletResponse response)
        throws ServletException, IOException
    {try { __CLOVER_384_0.M[2036]++;
    	__CLOVER_384_0.S[8568]++;throw new ServletException("MockRequestDispatcher.include() not supported.");
    } finally { }}

}
