/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.util;

import java.util.HashMap;
import java.util.Map;

/**
 *  Used to "uniquify" names within a given context.  A base name
 *  is passed in, and the return value is the base name, or the base name
 *  extended with a suffix to make it unique.
 *
 *  @author Howard Lewis Ship
 *  @since 3.0
 *
 **/

public class IdAllocator
{public static com.cortexeb.tools.clover.d __CLOVER_395_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private Map _generatorMap = new HashMap();

    private static class NameGenerator
    {
        private String _baseId;
        private int _index;

        NameGenerator(String baseId)
        {try { __CLOVER_395_0.M[2147]++;
            __CLOVER_395_0.S[8814]++;_baseId = baseId + "$";
        } finally { }}

        public String nextId()
        {try { __CLOVER_395_0.M[2148]++;
            __CLOVER_395_0.S[8815]++;return _baseId + _index++;
        } finally { }}
    }

    /**
     *  Allocates the id.  Repeated calls for the same name will return
     *  "name", "name_0", "name_1", etc.
     * 
     **/

    public String allocateId(String name)
    {try { __CLOVER_395_0.M[2149]++;
        __CLOVER_395_0.S[8816]++;NameGenerator g = (NameGenerator) _generatorMap.get(name);
        __CLOVER_395_0.S[8817]++;String result = null;

        __CLOVER_395_0.S[8818]++;if ((((g == null) && (++__CLOVER_395_0.CT[1486] != 0)) || (++__CLOVER_395_0.CF[1486] == 0))){
        {
            __CLOVER_395_0.S[8819]++;g = new NameGenerator(name);
            __CLOVER_395_0.S[8820]++;result = name;
        }}
        else{
            __CLOVER_395_0.S[8821]++;result = g.nextId();}

        // Handle the degenerate case, where a base name of the form "foo$0" has been
        // requested.  Skip over any duplicates thus formed.
        
        __CLOVER_395_0.S[8822]++;while ((((_generatorMap.containsKey(result)) && (++__CLOVER_395_0.CT[1487] != 0)) || (++__CLOVER_395_0.CF[1487] == 0))){
            __CLOVER_395_0.S[8823]++;result = g.nextId();}

        __CLOVER_395_0.S[8824]++;_generatorMap.put(result, g);

        __CLOVER_395_0.S[8825]++;return result;
    } finally { }}
    
    /**
     *  Clears the allocator, resetting it to freshly allocated state.
     * 
     **/
    
    public void clear()
    {try { __CLOVER_395_0.M[2150]++;
        __CLOVER_395_0.S[8826]++;_generatorMap.clear();
    } finally { }}
}
