/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.util;

import java.net.MalformedURLException;
import java.util.Locale;

import javax.servlet.ServletContext;

import org.apache.hivemind.util.LocalizedNameGenerator;
import org.apache.hivemind.util.LocalizedResource;

/**
 *  Finds localized resources within the web application context.
 * 
 *  @see javax.servlet.ServletContext
 *
 *  @author Howard Lewis Ship
 *  @since 3.0
 */

public class LocalizedContextResourceFinder
{public static com.cortexeb.tools.clover.d __CLOVER_396_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private ServletContext _context;

    public LocalizedContextResourceFinder(ServletContext context)
    {try { __CLOVER_396_0.M[2151]++;
        __CLOVER_396_0.S[8827]++;_context = context;
    } finally { }}

    /**
     *  Resolves the resource, returning a path representing
     *  the closest match (with respect to the provided locale).
     *  Returns null if no match.
     * 
     *  <p>The provided path is split into a base path
     *  and a suffix (at the last period character).  The locale
     *  will provide different suffixes to the base path
     *  and the first match is returned.
     * 
     **/

    public LocalizedResource resolve(String contextPath, Locale locale)
    {try { __CLOVER_396_0.M[2152]++;
        __CLOVER_396_0.S[8828]++;int dotx = contextPath.lastIndexOf('.');
        __CLOVER_396_0.S[8829]++;String basePath = contextPath.substring(0, dotx);
        __CLOVER_396_0.S[8830]++;String suffix = contextPath.substring(dotx);

        __CLOVER_396_0.S[8831]++;LocalizedNameGenerator generator = new LocalizedNameGenerator(basePath, locale, suffix);

        __CLOVER_396_0.S[8832]++;while ((((generator.more()) && (++__CLOVER_396_0.CT[1488] != 0)) || (++__CLOVER_396_0.CF[1488] == 0))){
        {
            __CLOVER_396_0.S[8833]++;String candidatePath = generator.next();

            __CLOVER_396_0.S[8834]++;if ((((isExistingResource(candidatePath)) && (++__CLOVER_396_0.CT[1489] != 0)) || (++__CLOVER_396_0.CF[1489] == 0))){
                __CLOVER_396_0.S[8835]++;return new LocalizedResource(candidatePath, generator.getCurrentLocale());}
        }}

        __CLOVER_396_0.S[8836]++;return null;
    } finally { }}

    private boolean isExistingResource(String path)
    {try { __CLOVER_396_0.M[2153]++;
        __CLOVER_396_0.S[8837]++;try
        {
            __CLOVER_396_0.S[8838]++;return _context.getResource(path) != null;
        }
        catch (MalformedURLException ex)
        {
            __CLOVER_396_0.S[8839]++;return false;
        }
    } finally { }}
}
