/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.util;

import java.io.Externalizable;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectOutput;

import org.apache.tapestry.Tapestry;

/**
 *  A complex key that may be used as an alternative to nested
 *  {@link java.util.Map}s.
 *
 *  @author Howard Lewis Ship
 *
 **/

public class MultiKey implements Externalizable
{public static com.cortexeb.tools.clover.d __CLOVER_398_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    /**
     *  @since 2.0.4
     * 
     **/
    
    private static final long serialVersionUID = 4465448607415788806L;
    
    private static final int HASH_CODE_UNSET = -1;

    private transient int hashCode = HASH_CODE_UNSET;

    private Object[] keys;

    /**
     *  Public no-arguments constructor needed to be compatible with
     *  {@link Externalizable}; this leaves the new MultiKey in a
     *  non-usable state and shouldn't be used by user code.
     *
     **/

    public MultiKey()
    {try { __CLOVER_398_0.M[2161]++;
    } finally { }}

    /**
     *  Builds a <code>MultiKey</code> from an array of keys.  If the array is not
     *  copied, then it must not be modified.
     * 
     *  @param keys The components of the key.
     *  @param makeCopy If true, a copy of the keys is created.  If false,
     *  the keys are simple retained by the <code>MultiKey</code>.
     *
     *  @throws IllegalArgumentException if keys is null, of if the
     *  first element of keys is null.
     *
     **/

    public MultiKey(Object[] keys, boolean makeCopy)
    {
        super();__CLOVER_398_0.S[8855]++;try { __CLOVER_398_0.M[2162]++;

        __CLOVER_398_0.S[8856]++;if ((((keys == null || keys.length == 0) && (++__CLOVER_398_0.CT[1492] != 0)) || (++__CLOVER_398_0.CF[1492] == 0))){
            __CLOVER_398_0.S[8857]++;throw new IllegalArgumentException(Tapestry.getMessage("MultiKey.null-keys"));}

        __CLOVER_398_0.S[8858]++;if ((((keys[0] == null) && (++__CLOVER_398_0.CT[1493] != 0)) || (++__CLOVER_398_0.CF[1493] == 0))){
            __CLOVER_398_0.S[8859]++;throw new IllegalArgumentException(Tapestry.getMessage("MultiKey.first-element-may-not-be-null"));}

        __CLOVER_398_0.S[8860]++;if ((((makeCopy) && (++__CLOVER_398_0.CT[1494] != 0)) || (++__CLOVER_398_0.CF[1494] == 0))){
        {
            __CLOVER_398_0.S[8861]++;this.keys = new Object[keys.length];
            __CLOVER_398_0.S[8862]++;System.arraycopy(keys, 0, this.keys, 0, keys.length);
        }}
        else{
            __CLOVER_398_0.S[8863]++;this.keys = keys;}
    } finally { }}

    /**
     *  Returns true if:
     *  <ul>
     *  <li>The other object is a <code>MultiKey</code>
     *  <li>They have the same number of key elements
     *  <li>Every element is an exact match or is equal
     *  </ul>
     *
     **/

    public boolean equals(Object other)
    {try { __CLOVER_398_0.M[2163]++;
        __CLOVER_398_0.S[8864]++;int i;

        __CLOVER_398_0.S[8865]++;if ((((other == null) && (++__CLOVER_398_0.CT[1495] != 0)) || (++__CLOVER_398_0.CF[1495] == 0))){
            __CLOVER_398_0.S[8866]++;return false;}

        __CLOVER_398_0.S[8867]++;if ((((keys == null) && (++__CLOVER_398_0.CT[1496] != 0)) || (++__CLOVER_398_0.CF[1496] == 0))){
            __CLOVER_398_0.S[8868]++;throw new IllegalStateException(Tapestry.getMessage("MultiKey.no-keys"));}

        // Would a hashCode check be worthwhile here?

        __CLOVER_398_0.S[8869]++;try
        {
            __CLOVER_398_0.S[8870]++;MultiKey otherMulti = (MultiKey) other;

            __CLOVER_398_0.S[8871]++;if ((((keys.length != otherMulti.keys.length) && (++__CLOVER_398_0.CT[1497] != 0)) || (++__CLOVER_398_0.CF[1497] == 0))){
                __CLOVER_398_0.S[8872]++;return false;}

            __CLOVER_398_0.S[8873]++;for (i = 0; (((i < keys.length) && (++__CLOVER_398_0.CT[1498] != 0)) || (++__CLOVER_398_0.CF[1498] == 0)); i++){
            {
                // On an exact match, continue.  This means that null matches
                // null.

                __CLOVER_398_0.S[8874]++;if ((((keys[i] == otherMulti.keys[i]) && (++__CLOVER_398_0.CT[1499] != 0)) || (++__CLOVER_398_0.CF[1499] == 0))){
                    __CLOVER_398_0.S[8875]++;continue;}

                // If either is null, but not both, then
                // not a match.

                __CLOVER_398_0.S[8876]++;if ((((keys[i] == null || otherMulti.keys[i] == null) && (++__CLOVER_398_0.CT[1500] != 0)) || (++__CLOVER_398_0.CF[1500] == 0))){
                    __CLOVER_398_0.S[8877]++;return false;}

                __CLOVER_398_0.S[8878]++;if ((((!keys[i].equals(otherMulti.keys[i])) && (++__CLOVER_398_0.CT[1501] != 0)) || (++__CLOVER_398_0.CF[1501] == 0))){
                    __CLOVER_398_0.S[8879]++;return false;}

            }}

            // Every key equal.  A match.

            __CLOVER_398_0.S[8880]++;return true;
        }
        catch (ClassCastException e)
        {
        }

        __CLOVER_398_0.S[8881]++;return false;
    } finally { }}

    /**
     *  Returns the hash code of the receiver, which is computed from all the
     *  non-null key elements.  This value is computed once and
     *  then cached, so elements should not change their hash codes 
     *  once created (note that this
     *  is the same constraint that would be used if the individual 
     *  key elements were
     *  themselves {@link java.util.Map} keys.
     * 
     *
     **/

    public int hashCode()
    {try { __CLOVER_398_0.M[2164]++;
        __CLOVER_398_0.S[8882]++;if ((((hashCode == HASH_CODE_UNSET) && (++__CLOVER_398_0.CT[1502] != 0)) || (++__CLOVER_398_0.CF[1502] == 0))){
        {
            __CLOVER_398_0.S[8883]++;hashCode = keys[0].hashCode();

            __CLOVER_398_0.S[8884]++;for (int i = 1; (((i < keys.length) && (++__CLOVER_398_0.CT[1503] != 0)) || (++__CLOVER_398_0.CF[1503] == 0)); i++){
            {
                __CLOVER_398_0.S[8885]++;if ((((keys[i] != null) && (++__CLOVER_398_0.CT[1504] != 0)) || (++__CLOVER_398_0.CF[1504] == 0))){
                    __CLOVER_398_0.S[8886]++;hashCode ^= keys[i].hashCode();}
            }}
        }}

        __CLOVER_398_0.S[8887]++;return hashCode;
    } finally { }}

    /**
    *  Identifies all the keys stored by this <code>MultiKey</code>.
    *
    **/

    public String toString()
    {try { __CLOVER_398_0.M[2165]++;
        __CLOVER_398_0.S[8888]++;StringBuffer buffer;
        __CLOVER_398_0.S[8889]++;int i;

        __CLOVER_398_0.S[8890]++;buffer = new StringBuffer("MultiKey[");

        __CLOVER_398_0.S[8891]++;for (i = 0; (((i < keys.length) && (++__CLOVER_398_0.CT[1505] != 0)) || (++__CLOVER_398_0.CF[1505] == 0)); i++){
        {
            __CLOVER_398_0.S[8892]++;if ((((i > 0) && (++__CLOVER_398_0.CT[1506] != 0)) || (++__CLOVER_398_0.CF[1506] == 0))){
                __CLOVER_398_0.S[8893]++;buffer.append(", ");}

            __CLOVER_398_0.S[8894]++;if ((((keys[i] == null) && (++__CLOVER_398_0.CT[1507] != 0)) || (++__CLOVER_398_0.CF[1507] == 0))){
                __CLOVER_398_0.S[8895]++;buffer.append("<null>");}
            else{
                __CLOVER_398_0.S[8896]++;buffer.append(keys[i]);}
        }}

        __CLOVER_398_0.S[8897]++;buffer.append(']');

        __CLOVER_398_0.S[8898]++;return buffer.toString();
    } finally { }}

    /**
     *  Writes a count of the keys, then writes each individual key.
     *
     **/

    public void writeExternal(ObjectOutput out) throws IOException
    {try { __CLOVER_398_0.M[2166]++;
        __CLOVER_398_0.S[8899]++;out.writeInt(keys.length);

        __CLOVER_398_0.S[8900]++;for (int i = 0; (((i < keys.length) && (++__CLOVER_398_0.CT[1508] != 0)) || (++__CLOVER_398_0.CF[1508] == 0)); i++){
            __CLOVER_398_0.S[8901]++;out.writeObject(keys[i]);}
    } finally { }}

    /**
     *  Reads the state previously written by {@link #writeExternal(ObjectOutput)}.
     *
     **/

    public void readExternal(ObjectInput in) throws IOException, ClassNotFoundException
    {try { __CLOVER_398_0.M[2167]++;
        __CLOVER_398_0.S[8902]++;int count;

        __CLOVER_398_0.S[8903]++;count = in.readInt();
        __CLOVER_398_0.S[8904]++;keys = new Object[count];

        __CLOVER_398_0.S[8905]++;for (int i = 0; (((i < count) && (++__CLOVER_398_0.CT[1509] != 0)) || (++__CLOVER_398_0.CF[1509] == 0)); i++){
            __CLOVER_398_0.S[8906]++;keys[i] = in.readObject();}
    } finally { }}
}