/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.util;

/**
 *  Used to split a string into substrings based on a single character
 *  delimiter.  A fast, simple version of
 *  {@link java.util.StringTokenizer}.
 *
 *  @author Howard Lewis Ship
 * 
 **/

public class StringSplitter
{public static com.cortexeb.tools.clover.d __CLOVER_404_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private char delimiter;

    public StringSplitter(char delimiter)
    {try { __CLOVER_404_0.M[2184]++;
        __CLOVER_404_0.S[8949]++;this.delimiter = delimiter;
    } finally { }}

    public char getDelimiter()
    {try { __CLOVER_404_0.M[2185]++;
        __CLOVER_404_0.S[8950]++;return delimiter;
    } finally { }}

    /**
     *  Splits a string on the delimter into an array of String
     *  tokens.  The delimiters are not included in the tokens.  Null
     *  tokens (caused by two consecutive delimiter) are reduced to an
     *  empty string. Leading delimiters are ignored.
     *
     **/

    public String[] splitToArray(String value)
    {try { __CLOVER_404_0.M[2186]++;
        __CLOVER_404_0.S[8951]++;char[] buffer;
        __CLOVER_404_0.S[8952]++;int i;
        __CLOVER_404_0.S[8953]++;String[] result;
        __CLOVER_404_0.S[8954]++;int resultCount = 0;
        __CLOVER_404_0.S[8955]++;int start;
        __CLOVER_404_0.S[8956]++;int length;
        __CLOVER_404_0.S[8957]++;String token;
        __CLOVER_404_0.S[8958]++;String[] newResult;
        __CLOVER_404_0.S[8959]++;boolean first = true;

        __CLOVER_404_0.S[8960]++;buffer = value.toCharArray();

        __CLOVER_404_0.S[8961]++;result = new String[3];

        __CLOVER_404_0.S[8962]++;start = 0;
        __CLOVER_404_0.S[8963]++;length = 0;

        __CLOVER_404_0.S[8964]++;for (i = 0; (((i < buffer.length) && (++__CLOVER_404_0.CT[1515] != 0)) || (++__CLOVER_404_0.CF[1515] == 0)); i++){
        {
            __CLOVER_404_0.S[8965]++;if ((((buffer[i] != delimiter) && (++__CLOVER_404_0.CT[1516] != 0)) || (++__CLOVER_404_0.CF[1516] == 0))){
            {
                __CLOVER_404_0.S[8966]++;length++;
                __CLOVER_404_0.S[8967]++;continue;
            }}

            // This is used to ignore leading delimiter(s).

            __CLOVER_404_0.S[8968]++;if ((((length > 0 || !first) && (++__CLOVER_404_0.CT[1517] != 0)) || (++__CLOVER_404_0.CF[1517] == 0))){
            {
                __CLOVER_404_0.S[8969]++;token = new String(buffer, start, length);

                __CLOVER_404_0.S[8970]++;if ((((resultCount == result.length) && (++__CLOVER_404_0.CT[1518] != 0)) || (++__CLOVER_404_0.CF[1518] == 0))){
                {
                    __CLOVER_404_0.S[8971]++;newResult = new String[result.length * 2];

                    __CLOVER_404_0.S[8972]++;System.arraycopy(result, 0, newResult, 0, result.length);

                    __CLOVER_404_0.S[8973]++;result = newResult;
                }}

                __CLOVER_404_0.S[8974]++;result[resultCount++] = token;

                __CLOVER_404_0.S[8975]++;first = false;
            }}

            __CLOVER_404_0.S[8976]++;start = i + 1;
            __CLOVER_404_0.S[8977]++;length = 0;
        }}

        // Special case:  if the string contains no delimiters
        // then it isn't really split.  Wrap the input string
        // in an array and return.  This is a little optimization
        // to prevent a new String instance from being
        // created unnecessarily.

        __CLOVER_404_0.S[8978]++;if ((((start == 0 && length == buffer.length) && (++__CLOVER_404_0.CT[1519] != 0)) || (++__CLOVER_404_0.CF[1519] == 0))){
        {
            __CLOVER_404_0.S[8979]++;result = new String[1];
            __CLOVER_404_0.S[8980]++;result[0] = value;
            __CLOVER_404_0.S[8981]++;return result;
        }}

        // If the string is all delimiters, then this
        // will result in a single empty token.

        __CLOVER_404_0.S[8982]++;token = new String(buffer, start, length);

        __CLOVER_404_0.S[8983]++;newResult = new String[resultCount + 1];
        __CLOVER_404_0.S[8984]++;System.arraycopy(result, 0, newResult, 0, resultCount);
        __CLOVER_404_0.S[8985]++;newResult[resultCount] = token;

        __CLOVER_404_0.S[8986]++;return newResult;
    } finally { }}
}