/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.util.io;

import org.apache.tapestry.services.DataSqueezer;

/**
 *  Squeezes a {@link Boolean}.
 *
 *  @author Howard Lewis Ship
 *
 **/

class BooleanAdaptor implements ISqueezeAdaptor
{public static com.cortexeb.tools.clover.d __CLOVER_410_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private static final String PREFIX = "TF";

    /**
     *  Registers using the prefixes 'T' and 'F' (for TRUE and FALSE).
     *
     **/

    public void register(DataSqueezer squeezer)
    {try { __CLOVER_410_0.M[2224]++;
        __CLOVER_410_0.S[9223]++;squeezer.register(PREFIX, Boolean.class, this);
    } finally { }}

    /**
     *  Squeezes the {@link Boolean} data to either 'T' or 'F'.
     *
     **/

    public String squeeze(DataSqueezer squeezer, Object data)
    {try { __CLOVER_410_0.M[2225]++;
        __CLOVER_410_0.S[9224]++;Boolean bool = (Boolean) data;

        __CLOVER_410_0.S[9225]++;if ((((bool.booleanValue()) && (++__CLOVER_410_0.CT[1567] != 0)) || (++__CLOVER_410_0.CF[1567] == 0))){
            __CLOVER_410_0.S[9226]++;return "T";}
        else{
            __CLOVER_410_0.S[9227]++;return "F";}
    } finally { }}

    /**
     *  Unsqueezes the string to either {@link Boolean#TRUE} or {@link Boolean#FALSE},
     *  depending on the prefix character.
     *
     **/

    public Object unsqueeze(DataSqueezer squeezer, String string)
    {try { __CLOVER_410_0.M[2226]++;
        __CLOVER_410_0.S[9228]++;char ch = string.charAt(0);

        __CLOVER_410_0.S[9229]++;if ((((ch == 'T') && (++__CLOVER_410_0.CT[1568] != 0)) || (++__CLOVER_410_0.CF[1568] == 0))){
            __CLOVER_410_0.S[9230]++;return Boolean.TRUE;}

        __CLOVER_410_0.S[9231]++;return Boolean.FALSE;
    } finally { }}

}