/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.util.io;

import org.apache.tapestry.services.DataSqueezer;

/**
 *  Squeezes a {@link Float}.
 *
 *  @author Howard Lewis Ship
 *
 **/

class FloatAdaptor implements ISqueezeAdaptor
{public static com.cortexeb.tools.clover.d __CLOVER_417_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private static final String PREFIX = "f";

    /**
     *  Registers using the prefix 'f'.
     *
     **/

    public void register(DataSqueezer squeezer)
    {try { __CLOVER_417_0.M[2253]++;
        __CLOVER_417_0.S[9346]++;squeezer.register(PREFIX, Float.class, this);
    } finally { }}

    /**
     *  Invoked <code>toString()</code> on data (which is type {@link Float}),
     *  and prefixs the result.
     *
     **/

    public String squeeze(DataSqueezer squeezer, Object data)
    {try { __CLOVER_417_0.M[2254]++;
        __CLOVER_417_0.S[9347]++;return PREFIX + data.toString();
    } finally { }}

    /**
     *  Constructs a {@link Float} from the string, after stripping
     *  the prefix.
     *
     **/

    public Object unsqueeze(DataSqueezer squeezer, String string)
    {try { __CLOVER_417_0.M[2255]++;
        __CLOVER_417_0.S[9348]++;return new Float(string.substring(1));
    } finally { }}

}