/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.util.io;

import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectStreamClass;

import org.apache.hivemind.ClassResolver;

/**
 *  Specialized subclass of {@link java.io.ObjectInputStream}
 *  that knows how to resolve classes with a non-default
 *  class loader (represented by an instance of
 *  {@link org.apache.tapestry.IResourceResolver}).
 *
 *  @author Howard Lewis Ship
 *  @since 3.0
 *
 **/

public class ResolvingObjectInputStream extends ObjectInputStream
{public static com.cortexeb.tools.clover.d __CLOVER_421_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private ClassResolver _resolver;

    public ResolvingObjectInputStream(ClassResolver resolver, InputStream input) throws IOException
    {
        super(input);__CLOVER_421_0.S[9355]++;try { __CLOVER_421_0.M[2262]++;

        __CLOVER_421_0.S[9356]++;_resolver = resolver;
    } finally { }}

    /**
     *  Overrides the default implementation to
     *  have the resource resolver find the class.
     * 
     **/

    protected Class resolveClass(ObjectStreamClass v) throws IOException, ClassNotFoundException
    {try { __CLOVER_421_0.M[2263]++;
        __CLOVER_421_0.S[9357]++;return _resolver.findClass(v.getName());
    } finally { }}
}