/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.util.text;

import java.util.HashMap;
import java.util.Map;

/**
 * The default implementation of a character translator source.
 * Returns a standard HTML translator that encodes everything that is non-safe
 * or an HTML translator that encodes only non-safe ASCII symbols 
 * if the encoding is a unicode one. 
 * 
 * @author mb
 * @since 3.1
 */
public class DefaultCharacterTranslatorSource implements ICharacterTranslatorSource
{public static com.cortexeb.tools.clover.d __CLOVER_430_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
	private static final ICharacterTranslator DEFAULT_TRANSLATOR = new MarkupCharacterTranslator();
	private static final ICharacterTranslator UNICODE_TRANSLATOR = new MarkupCharacterTranslator(false);

	private final static Map _translators;
	
	static {
		__CLOVER_430_0.S[9517]++;_translators = new HashMap();
		__CLOVER_430_0.S[9518]++;_translators.put("UTF-8", UNICODE_TRANSLATOR);
		__CLOVER_430_0.S[9519]++;_translators.put("UTF-7", UNICODE_TRANSLATOR);
		__CLOVER_430_0.S[9520]++;_translators.put("UTF-16", UNICODE_TRANSLATOR);
		__CLOVER_430_0.S[9521]++;_translators.put("UTF-16BE", UNICODE_TRANSLATOR);
		__CLOVER_430_0.S[9522]++;_translators.put("UTF-16LE", UNICODE_TRANSLATOR);
	}
	
	/**
	 * Returns a translator that encodes all non-safe characters into their HTML equivalents.
	 * 
	 * @see org.apache.tapestry.util.text.ICharacterTranslatorSource#getDefaultTranslator()
	 */
	public ICharacterTranslator getDefaultTranslator() {try { __CLOVER_430_0.M[2298]++;
		__CLOVER_430_0.S[9523]++;return DEFAULT_TRANSLATOR;
	} finally { }}

	/**
	 * If the encoding is a Unicode one, returns a translator that encodes only the 
	 * non-safe ASCII characters and leaves the others untouched.
	 * Otherwise, returns the default translator.
	 * 
	 * @see org.apache.tapestry.util.text.ICharacterTranslatorSource#getTranslator(java.lang.String)
	 */
	public ICharacterTranslator getTranslator(String encoding) {try { __CLOVER_430_0.M[2299]++;
		__CLOVER_430_0.S[9524]++;ICharacterTranslator translator = (ICharacterTranslator) _translators.get(encoding.toUpperCase());
		__CLOVER_430_0.S[9525]++;if ((((translator != null) && (++__CLOVER_430_0.CT[1625] != 0)) || (++__CLOVER_430_0.CF[1625] == 0))){
			__CLOVER_430_0.S[9526]++;return translator;}
		__CLOVER_430_0.S[9527]++;return getDefaultTranslator();
	} finally { }}
	
}
