/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.util.text;

import java.io.IOException;
import java.io.Reader;

/**
 * A Reader that provides some additional functionality, such as peek().
 * 
 * @author mb
 * @since 3.1
 */
public class ExtendedReader extends Reader
{public static com.cortexeb.tools.clover.d __CLOVER_431_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private Reader _reader;
    private boolean _hasBufferedChar = false;
    private char _bufferedChar;
    
    /**
     * Creates a new extended reader that reads from the provided object
     * 
     * @param in the Reader to get data from
     */
    public ExtendedReader(Reader in)
    {try { __CLOVER_431_0.M[2300]++;
        __CLOVER_431_0.S[9528]++;_reader = in;
    } finally { }}

    /**
     * Returns the next character in the stream without actually comitting the read.
     * Multiple consequtive invocations of this method should return the same value.
     * 
     * @return the next character waiting in the stream or -1 if the end of the stream is reached
     * @throws IOException if an error occurs
     */
    public synchronized int peek() throws IOException
    {try { __CLOVER_431_0.M[2301]++;
        __CLOVER_431_0.S[9529]++;if ((((!_hasBufferedChar) && (++__CLOVER_431_0.CT[1626] != 0)) || (++__CLOVER_431_0.CF[1626] == 0))){ {
            __CLOVER_431_0.S[9530]++;int bufferedChar = read();
            __CLOVER_431_0.S[9531]++;if ((((bufferedChar < 0) && (++__CLOVER_431_0.CT[1627] != 0)) || (++__CLOVER_431_0.CF[1627] == 0))){
                __CLOVER_431_0.S[9532]++;return bufferedChar;}
            __CLOVER_431_0.S[9533]++;_bufferedChar = (char) bufferedChar;
            __CLOVER_431_0.S[9534]++;_hasBufferedChar = true;
        }}
        __CLOVER_431_0.S[9535]++;return _bufferedChar;
    } finally { }}
    
    /**
     * Determines whether the end of the stream is reached
     * 
     * @return true if at the end of stream
     * @throws IOException if an error occurs
     */
    public synchronized boolean isEndOfStream() throws IOException
    {try { __CLOVER_431_0.M[2302]++;
        __CLOVER_431_0.S[9536]++;return peek() < 0;
    } finally { }}

    /**
     * Skips the next characters until a character that does not match the provided rule is reached.
     * 
     * @param matcher the object determining whether a character should be skipped
     * @throws IOException if an error occurs
     */
    public synchronized void skipCharacters(ICharacterMatcher matcher) throws IOException
    {try { __CLOVER_431_0.M[2303]++;
        __CLOVER_431_0.S[9537]++;while (true){ {
            __CLOVER_431_0.S[9538]++;if ((((isEndOfStream()) && (++__CLOVER_431_0.CT[1628] != 0)) || (++__CLOVER_431_0.CF[1628] == 0))){
                __CLOVER_431_0.S[9539]++;break;}
            __CLOVER_431_0.S[9540]++;char ch = (char) peek();
            __CLOVER_431_0.S[9541]++;if ((((!matcher.matches(ch)) && (++__CLOVER_431_0.CT[1629] != 0)) || (++__CLOVER_431_0.CF[1629] == 0))){
                __CLOVER_431_0.S[9542]++;break;}
            __CLOVER_431_0.S[9543]++;read();
        }}
    } finally { }}
    
    /**
     * Reads the next characters until a character that does not match the provided rule is reached.
     * 
     * @param matcher the object determining whether a character should be read
     * @return the string of characters read
     * @throws IOException if an error occurs
     */
    public synchronized String readCharacters(ICharacterMatcher matcher) throws IOException
    {try { __CLOVER_431_0.M[2304]++;
        __CLOVER_431_0.S[9544]++;StringBuffer buf = new StringBuffer();
        __CLOVER_431_0.S[9545]++;while (true){ {
            __CLOVER_431_0.S[9546]++;if ((((isEndOfStream()) && (++__CLOVER_431_0.CT[1630] != 0)) || (++__CLOVER_431_0.CF[1630] == 0))){
                __CLOVER_431_0.S[9547]++;break;}
            __CLOVER_431_0.S[9548]++;char ch = (char) peek();
            __CLOVER_431_0.S[9549]++;if ((((!matcher.matches(ch)) && (++__CLOVER_431_0.CT[1631] != 0)) || (++__CLOVER_431_0.CF[1631] == 0))){
                __CLOVER_431_0.S[9550]++;break;}
            __CLOVER_431_0.S[9551]++;buf.append(read());
        }}
        __CLOVER_431_0.S[9552]++;return buf.toString();
    } finally { }}
    
    /** 
     * @see java.io.FilterReader#read(char[], int, int)
     */
    public synchronized int read(char[] cbuf, int off, int len) throws IOException
    {try { __CLOVER_431_0.M[2305]++;
        __CLOVER_431_0.S[9553]++;if ((((len <= 0) && (++__CLOVER_431_0.CT[1632] != 0)) || (++__CLOVER_431_0.CF[1632] == 0))){
            __CLOVER_431_0.S[9554]++;return 0;}
        
        __CLOVER_431_0.S[9555]++;boolean extraChar = _hasBufferedChar;
        __CLOVER_431_0.S[9556]++;if ((((_hasBufferedChar) && (++__CLOVER_431_0.CT[1633] != 0)) || (++__CLOVER_431_0.CF[1633] == 0))){ {
            __CLOVER_431_0.S[9557]++;_hasBufferedChar = false;
            __CLOVER_431_0.S[9558]++;cbuf[off++] = _bufferedChar;
            __CLOVER_431_0.S[9559]++;len--;
        }}

        __CLOVER_431_0.S[9560]++;int read = _reader.read(cbuf, off, len);
        __CLOVER_431_0.S[9561]++;if ((((extraChar) && (++__CLOVER_431_0.CT[1634] != 0)) || (++__CLOVER_431_0.CF[1634] == 0))){
            __CLOVER_431_0.S[9562]++;read++;}
        __CLOVER_431_0.S[9563]++;return read;
    } finally { }}
    
    /** 
     * @see java.io.FilterReader#ready()
     */
    public synchronized boolean ready() throws IOException
    {try { __CLOVER_431_0.M[2306]++;
        __CLOVER_431_0.S[9564]++;if ((((_hasBufferedChar) && (++__CLOVER_431_0.CT[1635] != 0)) || (++__CLOVER_431_0.CF[1635] == 0))){
            __CLOVER_431_0.S[9565]++;return true;}
        __CLOVER_431_0.S[9566]++;return _reader.ready();
    } finally { }}
    
    /** 
     * @see java.io.FilterReader#markSupported()
     */
    public synchronized boolean markSupported()
    {try { __CLOVER_431_0.M[2307]++;
        __CLOVER_431_0.S[9567]++;return false;
    } finally { }}
    
    /** 
     * @see java.io.FilterReader#reset()
     */
    public synchronized void reset() throws IOException
    {try { __CLOVER_431_0.M[2308]++;
        __CLOVER_431_0.S[9568]++;_hasBufferedChar = false;
        __CLOVER_431_0.S[9569]++;_reader.reset();
    } finally { }}
    
    /** 
     * @see java.io.FilterReader#skip(long)
     */
    public synchronized long skip(long n) throws IOException
    {try { __CLOVER_431_0.M[2309]++;
        __CLOVER_431_0.S[9570]++;if ((((_hasBufferedChar && n > 0) && (++__CLOVER_431_0.CT[1636] != 0)) || (++__CLOVER_431_0.CF[1636] == 0))){ {
            __CLOVER_431_0.S[9571]++;_hasBufferedChar = false;
            __CLOVER_431_0.S[9572]++;n--;
        }}
        __CLOVER_431_0.S[9573]++;return _reader.skip(n);
    } finally { }}

    /** 
     * @see java.io.Reader#close()
     */
    public synchronized void close() throws IOException
    {try { __CLOVER_431_0.M[2310]++;
        __CLOVER_431_0.S[9574]++;_hasBufferedChar = false;
        __CLOVER_431_0.S[9575]++;_reader.close();
    } finally { }}
    
}
