/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.util.text;

/**
 * An object that encodes a character according to rules of the HTML specification, 
 * so that it will be properly parsed by a browser irrespectively of the character
 * encoding used in the HTML output.
 * 
 * @author mb
 * @since 3.1
 */
public class MarkupCharacterTranslator implements ICharacterTranslator
{public static com.cortexeb.tools.clover.d __CLOVER_438_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private static final String SAFE_CHARACTERS =
        "01234567890"
            + "abcdefghijklmnopqrstuvwxyz"
            + "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
            + "\t\n\r !#$%'()*+,-./:;=?@[\\]^_`{|}~";

    private static final String[][] ENTITIES = {
    	{ "\"", "&quot;" }, 
		{ "<", "&lt;" },
		{ ">", "&gt;" },
		{ "&", "&amp;" }
    };
    
    private static final ICharacterMatcher SAFE_MATCHER = new AsciiCharacterMatcher(SAFE_CHARACTERS);
    private static final ICharacterTranslator ENTITY_TRANSLATOR = new AsciiCharacterTranslator(ENTITIES);
    
    private boolean _encodeNonAscii;
    private ICharacterMatcher _safeMatcher;
    private ICharacterTranslator _entityTranslator;
	
    public MarkupCharacterTranslator()
    {
    	this(true);__CLOVER_438_0.S[9661]++;try { __CLOVER_438_0.M[2330]++;
    } finally { }}
    
    public MarkupCharacterTranslator(boolean encodeNonAscii)
    {
    	this(encodeNonAscii, SAFE_MATCHER, ENTITY_TRANSLATOR);__CLOVER_438_0.S[9662]++;try { __CLOVER_438_0.M[2331]++;
    } finally { }}
    
    public MarkupCharacterTranslator(boolean encodeNonAscii, ICharacterMatcher safeMatcher, ICharacterTranslator entityTranslator)
    {try { __CLOVER_438_0.M[2332]++;
    	__CLOVER_438_0.S[9663]++;_encodeNonAscii = encodeNonAscii;
    	__CLOVER_438_0.S[9664]++;_safeMatcher = safeMatcher;
    	__CLOVER_438_0.S[9665]++;_entityTranslator = entityTranslator;
    } finally { }}

    public MarkupCharacterTranslator(boolean encodeNonAscii, String safeCharacters, String[][] entities)
    {try { __CLOVER_438_0.M[2333]++;
    	__CLOVER_438_0.S[9666]++;_encodeNonAscii = encodeNonAscii;
    	__CLOVER_438_0.S[9667]++;_safeMatcher = new AsciiCharacterMatcher(safeCharacters);
    	__CLOVER_438_0.S[9668]++;_entityTranslator = new AsciiCharacterTranslator(entities);
    } finally { }}
    
	/**
	 * @see org.apache.tapestry.util.text.IMarkupCharacterTranslator#translateAttribute(char)
	 */
	public String translate(char ch) {try { __CLOVER_438_0.M[2334]++;
		__CLOVER_438_0.S[9669]++;if ((((ch >= 128 && !_encodeNonAscii) && (++__CLOVER_438_0.CT[1652] != 0)) || (++__CLOVER_438_0.CF[1652] == 0))){
			__CLOVER_438_0.S[9670]++;return null;}
		
		__CLOVER_438_0.S[9671]++;if ((((_safeMatcher.matches(ch)) && (++__CLOVER_438_0.CT[1653] != 0)) || (++__CLOVER_438_0.CF[1653] == 0))){
			__CLOVER_438_0.S[9672]++;return null;}

		__CLOVER_438_0.S[9673]++;String entity = _entityTranslator.translate(ch);
		__CLOVER_438_0.S[9674]++;if ((((entity != null) && (++__CLOVER_438_0.CT[1654] != 0)) || (++__CLOVER_438_0.CF[1654] == 0))){
			__CLOVER_438_0.S[9675]++;return entity;}
		
		// needs to use a NumberFormat here to be fully compliant, 
		// but this is accepted fine by the browsers
		__CLOVER_438_0.S[9676]++;return "&#" + (int) ch + ";";
	} finally { }}
}
