/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.util.xml;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.hivemind.Location;
import org.apache.hivemind.Resource;
import org.apache.hivemind.impl.LocationImpl;
import org.xml.sax.SAXParseException;

/**
 *  Exception thrown if there is any kind of error parsing the
 *  an XML document. 
 *
 *  @see org.apache.tapestry.parse.SpecificationParser
 *
 *  @author Howard Lewis Ship
 *  @since 0.2.10
 *
 **/

public class DocumentParseException extends ApplicationRuntimeException
{public static com.cortexeb.tools.clover.d __CLOVER_441_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private Resource _documentLocation;

    public DocumentParseException(String message, Throwable rootCause)
    {
        this(message, null, null, rootCause);__CLOVER_441_0.S[9691]++;try { __CLOVER_441_0.M[2342]++;
    } finally { }}

    public DocumentParseException(String message, Resource documentLocation)
    {
        this(message, documentLocation, null);__CLOVER_441_0.S[9692]++;try { __CLOVER_441_0.M[2343]++;
    } finally { }}

    public DocumentParseException(String message, Resource documentLocation, Throwable rootCause)
    {
        this(message, documentLocation, null, rootCause);__CLOVER_441_0.S[9693]++;try { __CLOVER_441_0.M[2344]++;
    } finally { }}

    public DocumentParseException(String message, Location location, Throwable rootCause)
    {
        this(message, (((location == null ) && (++__CLOVER_441_0.CT[1660] != 0)) || (++__CLOVER_441_0.CF[1660] == 0))? null : location.getResource(), location, rootCause);__CLOVER_441_0.S[9694]++;try { __CLOVER_441_0.M[2345]++;
    } finally { }}

    private DocumentParseException(
        String message,
        Resource documentLocation,
        Location location,
        Throwable rootCause)
    {
        super(message, null, location, rootCause);__CLOVER_441_0.S[9695]++;try { __CLOVER_441_0.M[2346]++;

        __CLOVER_441_0.S[9696]++;_documentLocation = documentLocation;
    } finally { }}

    public DocumentParseException(
        String message,
        Resource documentLocation,
        SAXParseException rootCause)
    {
        this(
            message,
            documentLocation,
            (((rootCause == null
                || documentLocation == null
                    ) && (++__CLOVER_441_0.CT[1661] != 0)) || (++__CLOVER_441_0.CF[1661] == 0))? null
                    : new LocationImpl(
                        documentLocation,
                        rootCause.getLineNumber(),
                        rootCause.getColumnNumber()),
            rootCause);__CLOVER_441_0.S[9697]++;try { __CLOVER_441_0.M[2347]++;
    } finally { }}

    public DocumentParseException(String message)
    {
        this(message, null, null, null);__CLOVER_441_0.S[9698]++;try { __CLOVER_441_0.M[2348]++;
    } finally { }}

    public DocumentParseException(Throwable rootCause)
    {
        this(rootCause.getMessage(), rootCause);__CLOVER_441_0.S[9699]++;try { __CLOVER_441_0.M[2349]++;
    } finally { }}

    public DocumentParseException(SAXParseException rootCause)
    {
        this(rootCause.getMessage(), (Throwable) rootCause);__CLOVER_441_0.S[9700]++;try { __CLOVER_441_0.M[2350]++;
    } finally { }}

    public Resource getDocumentLocation()
    {try { __CLOVER_441_0.M[2351]++;
        __CLOVER_441_0.S[9701]++;return _documentLocation;
    } finally { }}
}