/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.valid;

import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRender;
import org.apache.tapestry.IRequestCycle;

/**
 *  A wrapper around {@link String} that allows the String to
 *  be renderred.  This is primarily used to present
 *  error messages.
 *
 *  @author Howard Lewis Ship
 *
 **/

public class RenderString implements IRender
{public static com.cortexeb.tools.clover.d __CLOVER_456_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private String _string;
    private boolean _raw = false;

    public RenderString(String string)
    {try { __CLOVER_456_0.M[2527]++;
        __CLOVER_456_0.S[10193]++;_string = string;
    } finally { }}

    /**
     *  @param string the string to render
     *  @param raw if true, the String is rendered as-is, with no filtering.
     *  If false (the default), the String is filtered.
     *
     **/

    public RenderString(String string, boolean raw)
    {try { __CLOVER_456_0.M[2528]++;
        __CLOVER_456_0.S[10194]++;_string = string;
        __CLOVER_456_0.S[10195]++;_raw = raw;
    } finally { }}

    /**
     *  Renders the String to the writer.  Does nothing if the string is null.
     *  If raw is true, uses {@link IMarkupWriter#printRaw(String)}, otherwise
     *  {@link IMarkupWriter#print(String)}.
     * 
     *
     **/

    public void render(IMarkupWriter writer, IRequestCycle cycle)
    {try { __CLOVER_456_0.M[2529]++;
        __CLOVER_456_0.S[10196]++;if ((((_string == null) && (++__CLOVER_456_0.CT[1739] != 0)) || (++__CLOVER_456_0.CF[1739] == 0))){
            __CLOVER_456_0.S[10197]++;return;}

        __CLOVER_456_0.S[10198]++;if ((((_raw) && (++__CLOVER_456_0.CT[1740] != 0)) || (++__CLOVER_456_0.CF[1740] == 0))){
            __CLOVER_456_0.S[10199]++;writer.printRaw(_string);}
        else{
            __CLOVER_456_0.S[10200]++;writer.print(_string);}
    } finally { }}

    public String getString()
    {try { __CLOVER_456_0.M[2530]++;
        __CLOVER_456_0.S[10201]++;return _string;
    } finally { }}

    public boolean isRaw()
    {try { __CLOVER_456_0.M[2531]++;
        __CLOVER_456_0.S[10202]++;return _raw;
    } finally { }}

    public String toString()
    {try { __CLOVER_456_0.M[2532]++;
        __CLOVER_456_0.S[10203]++;ToStringBuilder builder = new ToStringBuilder(this);
        __CLOVER_456_0.S[10204]++;builder.append("string", _string);
        __CLOVER_456_0.S[10205]++;builder.append("raw", _raw);

        __CLOVER_456_0.S[10206]++;return builder.toString();
    } finally { }}
}
