/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.valid;

import java.util.HashMap;
import java.util.Map;

import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.form.IFormComponent;

/**
 *  Simple validation of strings, to enforce required, and minimum length
 *  (maximum length is enforced in the client browser, by setting a maximum input
 *  length on the text field).
 *
 *
 *  @author Howard Lewis Ship
 *  @since 1.0.8
 *
 **/

public class StringValidator extends BaseValidator
{public static com.cortexeb.tools.clover.d __CLOVER_457_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private int _minimumLength;

    private String _minimumLengthMessage;

    /** @since 2.2 **/

    private String _scriptPath = "/org/apache/tapestry/valid/StringValidator.script";

    public StringValidator()
    {try { __CLOVER_457_0.M[2533]++;
    } finally { }}

    private StringValidator(boolean required)
    {
        super(required);__CLOVER_457_0.S[10207]++;try { __CLOVER_457_0.M[2534]++;
    } finally { }}

    public String toString(IFormComponent field, Object value)
    {try { __CLOVER_457_0.M[2535]++;
        __CLOVER_457_0.S[10208]++;if ((((value == null) && (++__CLOVER_457_0.CT[1741] != 0)) || (++__CLOVER_457_0.CF[1741] == 0))){
            __CLOVER_457_0.S[10209]++;return null;}

        __CLOVER_457_0.S[10210]++;return value.toString();
    } finally { }}

    public Object toObject(IFormComponent field, String input) throws ValidatorException
    {try { __CLOVER_457_0.M[2536]++;
        __CLOVER_457_0.S[10211]++;if ((((checkRequired(field, input)) && (++__CLOVER_457_0.CT[1742] != 0)) || (++__CLOVER_457_0.CF[1742] == 0))){
            __CLOVER_457_0.S[10212]++;return null;}

        __CLOVER_457_0.S[10213]++;if ((((_minimumLength > 0 && input.length() < _minimumLength) && (++__CLOVER_457_0.CT[1743] != 0)) || (++__CLOVER_457_0.CF[1743] == 0))){
            __CLOVER_457_0.S[10214]++;throw new ValidatorException(
                buildMinimumLengthMessage(field),
                ValidationConstraint.MINIMUM_WIDTH);}

        __CLOVER_457_0.S[10215]++;return input;
    } finally { }}

    public int getMinimumLength()
    {try { __CLOVER_457_0.M[2537]++;
        __CLOVER_457_0.S[10216]++;return _minimumLength;
    } finally { }}

    public void setMinimumLength(int minimumLength)
    {try { __CLOVER_457_0.M[2538]++;
        __CLOVER_457_0.S[10217]++;_minimumLength = minimumLength;
    } finally { }}

    /** 
     * 
     *  @since 2.2
     * 
     **/

    public void renderValidatorContribution(
        IFormComponent field,
        IMarkupWriter writer,
        IRequestCycle cycle)
    {try { __CLOVER_457_0.M[2539]++;
        __CLOVER_457_0.S[10218]++;if ((((!isClientScriptingEnabled()) && (++__CLOVER_457_0.CT[1744] != 0)) || (++__CLOVER_457_0.CF[1744] == 0))){
            __CLOVER_457_0.S[10219]++;return;}

        __CLOVER_457_0.S[10220]++;if ((((!(isRequired() || _minimumLength > 0)) && (++__CLOVER_457_0.CT[1745] != 0)) || (++__CLOVER_457_0.CF[1745] == 0))){
            __CLOVER_457_0.S[10221]++;return;}

        __CLOVER_457_0.S[10222]++;Map symbols = new HashMap();

        __CLOVER_457_0.S[10223]++;if ((((isRequired()) && (++__CLOVER_457_0.CT[1746] != 0)) || (++__CLOVER_457_0.CF[1746] == 0))){
            __CLOVER_457_0.S[10224]++;symbols.put("requiredMessage", buildRequiredMessage(field));}

        __CLOVER_457_0.S[10225]++;if ((((_minimumLength > 0) && (++__CLOVER_457_0.CT[1747] != 0)) || (++__CLOVER_457_0.CF[1747] == 0))){
            __CLOVER_457_0.S[10226]++;symbols.put("minimumLengthMessage", buildMinimumLengthMessage(field));}

        __CLOVER_457_0.S[10227]++;processValidatorScript(_scriptPath, cycle, field, symbols);
    } finally { }}

    /**
     *  @since 2.2
     * 
     **/

    public String getScriptPath()
    {try { __CLOVER_457_0.M[2540]++;
        __CLOVER_457_0.S[10228]++;return _scriptPath;
    } finally { }}

    /**
     *  Allows a developer to use the existing validation logic with a different client-side
     *  script.  This is often sufficient to allow application-specific error presentation
     *  (perhaps by using DHTML to update the content of a &lt;span&gt; tag, or to use
     *  a more sophisticated pop-up window than <code>window.alert()</code>).
     * 
     *  @since 2.2
     * 
     **/

    public void setScriptPath(String scriptPath)
    {try { __CLOVER_457_0.M[2541]++;
        __CLOVER_457_0.S[10229]++;_scriptPath = scriptPath;
    } finally { }}

    /** @since 3.0 */
    public String getMinimumLengthMessage()
    {try { __CLOVER_457_0.M[2542]++;
        __CLOVER_457_0.S[10230]++;return _minimumLengthMessage;
    } finally { }}

    /** 
     * Overrides the <code>field-too-short</code> bundle key.
     * Parameter {0} is the minimum length.
     * Parameter {1} is the display name of the field.
     * 
     * @since 3.0
     */

    public void setMinimumLengthMessage(String string)
    {try { __CLOVER_457_0.M[2543]++;
        __CLOVER_457_0.S[10231]++;_minimumLengthMessage = string;
    } finally { }}

    /** @since 3.0 */

    protected String buildMinimumLengthMessage(IFormComponent field)
    {try { __CLOVER_457_0.M[2544]++;
        __CLOVER_457_0.S[10232]++;String pattern =
            getPattern(_minimumLengthMessage, "field-too-short", field.getPage().getLocale());

        __CLOVER_457_0.S[10233]++;return formatString(pattern, Integer.toString(_minimumLength), field.getDisplayName());
    } finally { }}

}