/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.valid;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Locale;
import java.util.Map;
import java.util.ResourceBundle;
import java.util.Vector;

import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.form.IFormComponent;
import org.apache.tapestry.util.StringSplitter;

/**
 *
 *  @since 3.0
 *
 **/
public class UrlValidator extends BaseValidator {public static com.cortexeb.tools.clover.d __CLOVER_458_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
	private int _minimumLength;
	private String _minimumLengthMessage;
	private String _invalidUrlFormatMessage;
	private String _disallowedProtocolMessage;
	private Collection _allowedProtocols;

	private String _scriptPath = "/org/apache/tapestry/valid/UrlValidator.script"; //$NON-NLS-1$

	public UrlValidator() {try { __CLOVER_458_0.M[2545]++;
	} finally { }}

	private UrlValidator(boolean required) {
		super(required);__CLOVER_458_0.S[10234]++;try { __CLOVER_458_0.M[2546]++;
	} finally { }}

	public String toString(IFormComponent field, Object value) {try { __CLOVER_458_0.M[2547]++;
		__CLOVER_458_0.S[10235]++;if ((((value == null) && (++__CLOVER_458_0.CT[1748] != 0)) || (++__CLOVER_458_0.CF[1748] == 0))){
			__CLOVER_458_0.S[10236]++;return null;}

		__CLOVER_458_0.S[10237]++;return value.toString();
	} finally { }}

	public Object toObject(IFormComponent field, String input)
		throws ValidatorException {try { __CLOVER_458_0.M[2548]++;
		__CLOVER_458_0.S[10238]++;if ((((checkRequired(field, input)) && (++__CLOVER_458_0.CT[1749] != 0)) || (++__CLOVER_458_0.CF[1749] == 0))){
			__CLOVER_458_0.S[10239]++;return null;}

		__CLOVER_458_0.S[10240]++;if ((((_minimumLength > 0 && input.length() < _minimumLength) && (++__CLOVER_458_0.CT[1750] != 0)) || (++__CLOVER_458_0.CF[1750] == 0))){
			__CLOVER_458_0.S[10241]++;throw new ValidatorException(
				buildMinimumLengthMessage(field),
				ValidationConstraint.MINIMUM_WIDTH);}

		__CLOVER_458_0.S[10242]++;if ((((!isValidUrl(input)) && (++__CLOVER_458_0.CT[1751] != 0)) || (++__CLOVER_458_0.CF[1751] == 0))){
			__CLOVER_458_0.S[10243]++;throw new ValidatorException(
				buildInvalidUrlFormatMessage(field),
				ValidationConstraint.URL_FORMAT);}

		__CLOVER_458_0.S[10244]++;if ((((!isAllowedProtocol(input)) && (++__CLOVER_458_0.CT[1752] != 0)) || (++__CLOVER_458_0.CF[1752] == 0))){ {
			__CLOVER_458_0.S[10245]++;throw new ValidatorException(
				buildDisallowedProtocolMessage(field),
				ValidationConstraint.DISALLOWED_PROTOCOL);
		}}

		__CLOVER_458_0.S[10246]++;return input;
	} finally { }}

	public int getMinimumLength() {try { __CLOVER_458_0.M[2549]++;
		__CLOVER_458_0.S[10247]++;return _minimumLength;
	} finally { }}

	public void setMinimumLength(int minimumLength) {try { __CLOVER_458_0.M[2550]++;
		__CLOVER_458_0.S[10248]++;_minimumLength = minimumLength;
	} finally { }}

	public void renderValidatorContribution(
		IFormComponent field,
		IMarkupWriter writer,
		IRequestCycle cycle) {try { __CLOVER_458_0.M[2551]++;
		__CLOVER_458_0.S[10249]++;if ((((!isClientScriptingEnabled()) && (++__CLOVER_458_0.CT[1753] != 0)) || (++__CLOVER_458_0.CF[1753] == 0))){
			__CLOVER_458_0.S[10250]++;return;}

		__CLOVER_458_0.S[10251]++;Map symbols = new HashMap();

		__CLOVER_458_0.S[10252]++;if ((((isRequired()) && (++__CLOVER_458_0.CT[1754] != 0)) || (++__CLOVER_458_0.CF[1754] == 0))){
			__CLOVER_458_0.S[10253]++;symbols.put("requiredMessage", buildRequiredMessage(field));} //$NON-NLS-1$

		__CLOVER_458_0.S[10254]++;if ((((_minimumLength > 0) && (++__CLOVER_458_0.CT[1755] != 0)) || (++__CLOVER_458_0.CF[1755] == 0))){
			__CLOVER_458_0.S[10255]++;symbols.put("minimumLengthMessage", //$NON-NLS-1$
			buildMinimumLengthMessage(field));}

		__CLOVER_458_0.S[10256]++;symbols.put("urlFormatMessage", buildInvalidUrlFormatMessage(field)); //$NON-NLS-1$

		__CLOVER_458_0.S[10257]++;symbols.put("urlDisallowedProtocolMessage", //$NON-NLS-1$
		buildDisallowedProtocolMessage(field));

		__CLOVER_458_0.S[10258]++;symbols.put("urlRegexpProtocols", buildUrlRegexpProtocols()); //$NON-NLS-1$

		__CLOVER_458_0.S[10259]++;processValidatorScript(_scriptPath, cycle, field, symbols);
	} finally { }}

	private String buildUrlRegexpProtocols() {try { __CLOVER_458_0.M[2552]++;
		__CLOVER_458_0.S[10260]++;if((((_allowedProtocols == null) && (++__CLOVER_458_0.CT[1756] != 0)) || (++__CLOVER_458_0.CF[1756] == 0))){ {
			__CLOVER_458_0.S[10261]++;return null;
		}}
		__CLOVER_458_0.S[10262]++;String regexp = "/("; //$NON-NLS-1$
		__CLOVER_458_0.S[10263]++;Iterator iter = _allowedProtocols.iterator();
		__CLOVER_458_0.S[10264]++;while ((((iter.hasNext()) && (++__CLOVER_458_0.CT[1757] != 0)) || (++__CLOVER_458_0.CF[1757] == 0))){ {
			__CLOVER_458_0.S[10265]++;String protocol = (String) iter.next();
			__CLOVER_458_0.S[10266]++;regexp += protocol;
			__CLOVER_458_0.S[10267]++;if ((((iter.hasNext()) && (++__CLOVER_458_0.CT[1758] != 0)) || (++__CLOVER_458_0.CF[1758] == 0))){ {
				__CLOVER_458_0.S[10268]++;regexp += "|"; //$NON-NLS-1$
			}}
		}}
		__CLOVER_458_0.S[10269]++;regexp += "):///"; //$NON-NLS-1$
		__CLOVER_458_0.S[10270]++;return regexp;
	} finally { }}

	public String getScriptPath() {try { __CLOVER_458_0.M[2553]++;
		__CLOVER_458_0.S[10271]++;return _scriptPath;
	} finally { }}

	public void setScriptPath(String scriptPath) {try { __CLOVER_458_0.M[2554]++;
		__CLOVER_458_0.S[10272]++;_scriptPath = scriptPath;
	} finally { }}

	protected boolean isValidUrl(String url) {try { __CLOVER_458_0.M[2555]++;
		__CLOVER_458_0.S[10273]++;boolean bIsValid;
		__CLOVER_458_0.S[10274]++;try {
			__CLOVER_458_0.S[10275]++;new URL(url);
			__CLOVER_458_0.S[10276]++;bIsValid = true;
		} catch (MalformedURLException mue) {
			__CLOVER_458_0.S[10277]++;bIsValid = false;
		}
		__CLOVER_458_0.S[10278]++;return bIsValid;
	} finally { }}

	protected boolean isAllowedProtocol(String url) {try { __CLOVER_458_0.M[2556]++;
		__CLOVER_458_0.S[10279]++;boolean bIsAllowed = false;
		__CLOVER_458_0.S[10280]++;if ((((_allowedProtocols != null) && (++__CLOVER_458_0.CT[1759] != 0)) || (++__CLOVER_458_0.CF[1759] == 0))){ {
			__CLOVER_458_0.S[10281]++;URL oUrl;
			__CLOVER_458_0.S[10282]++;try {
				__CLOVER_458_0.S[10283]++;oUrl = new URL(url);
			} catch (MalformedURLException e) {
				__CLOVER_458_0.S[10284]++;return false;
			}
			__CLOVER_458_0.S[10285]++;String actualProtocol = oUrl.getProtocol();
			__CLOVER_458_0.S[10286]++;Iterator iter = _allowedProtocols.iterator();
			__CLOVER_458_0.S[10287]++;while ((((iter.hasNext()) && (++__CLOVER_458_0.CT[1760] != 0)) || (++__CLOVER_458_0.CF[1760] == 0))){ {
				__CLOVER_458_0.S[10288]++;String protocol = (String) iter.next();
				__CLOVER_458_0.S[10289]++;if ((((protocol.equals(actualProtocol)) && (++__CLOVER_458_0.CT[1761] != 0)) || (++__CLOVER_458_0.CF[1761] == 0))){ {
					__CLOVER_458_0.S[10290]++;bIsAllowed = true;
					__CLOVER_458_0.S[10291]++;break;
				}}
			}}
		}} else{ {
			__CLOVER_458_0.S[10292]++;bIsAllowed = true;
		}}
		__CLOVER_458_0.S[10293]++;return bIsAllowed;
	} finally { }}

	public String getInvalidUrlFormatMessage() {try { __CLOVER_458_0.M[2557]++;
		__CLOVER_458_0.S[10294]++;return _invalidUrlFormatMessage;
	} finally { }}

	public String getMinimumLengthMessage() {try { __CLOVER_458_0.M[2558]++;
		__CLOVER_458_0.S[10295]++;return _minimumLengthMessage;
	} finally { }}

	public void setInvalidUrlFormatMessage(String string) {try { __CLOVER_458_0.M[2559]++;
		__CLOVER_458_0.S[10296]++;_invalidUrlFormatMessage = string;
	} finally { }}

	public String getDisallowedProtocolMessage() {try { __CLOVER_458_0.M[2560]++;
		__CLOVER_458_0.S[10297]++;return _disallowedProtocolMessage;
	} finally { }}

	public void setDisallowedProtocolMessage(String string) {try { __CLOVER_458_0.M[2561]++;
		__CLOVER_458_0.S[10298]++;_disallowedProtocolMessage = string;
	} finally { }}

	public void setMinimumLengthMessage(String string) {try { __CLOVER_458_0.M[2562]++;
		__CLOVER_458_0.S[10299]++;_minimumLengthMessage = string;
	} finally { }}

	protected String buildMinimumLengthMessage(IFormComponent field) {try { __CLOVER_458_0.M[2563]++;
			__CLOVER_458_0.S[10300]++;String pattern = getPattern(_minimumLengthMessage, "field-too-short", //$NON-NLS-1$
	field.getPage().getLocale());

		__CLOVER_458_0.S[10301]++;return formatString(
			pattern,
			Integer.toString(_minimumLength),
			field.getDisplayName());
	} finally { }}

	protected String buildInvalidUrlFormatMessage(IFormComponent field) {try { __CLOVER_458_0.M[2564]++;
			__CLOVER_458_0.S[10302]++;String pattern = getPattern(_invalidUrlFormatMessage, "invalid-url-format", //$NON-NLS-1$
	field.getPage().getLocale());

		__CLOVER_458_0.S[10303]++;return formatString(pattern, field.getDisplayName());
	} finally { }}

	protected String buildDisallowedProtocolMessage(IFormComponent field) {try { __CLOVER_458_0.M[2565]++;
		__CLOVER_458_0.S[10304]++;if((((_allowedProtocols == null) && (++__CLOVER_458_0.CT[1762] != 0)) || (++__CLOVER_458_0.CF[1762] == 0))){ {
			__CLOVER_458_0.S[10305]++;return null;
		}}
			__CLOVER_458_0.S[10306]++;String pattern = getPattern(_disallowedProtocolMessage, "disallowed-protocol", //$NON-NLS-1$
	field.getPage().getLocale());

		__CLOVER_458_0.S[10307]++;String allowedProtocols = ""; //$NON-NLS-1$
		__CLOVER_458_0.S[10308]++;Iterator iter = _allowedProtocols.iterator();
		__CLOVER_458_0.S[10309]++;while ((((iter.hasNext()) && (++__CLOVER_458_0.CT[1763] != 0)) || (++__CLOVER_458_0.CF[1763] == 0))){ {
			__CLOVER_458_0.S[10310]++;String protocol = (String) iter.next();
			__CLOVER_458_0.S[10311]++;if ((((!allowedProtocols.equals("")) && (++__CLOVER_458_0.CT[1764] != 0)) || (++__CLOVER_458_0.CF[1764] == 0))){ { //$NON-NLS-1$
				__CLOVER_458_0.S[10312]++;if((((iter.hasNext()) && (++__CLOVER_458_0.CT[1765] != 0)) || (++__CLOVER_458_0.CF[1765] == 0))){ {
					__CLOVER_458_0.S[10313]++;allowedProtocols += ", "; //$NON-NLS-1$
				}} else{ {
					__CLOVER_458_0.S[10314]++;allowedProtocols += " or "; //$NON-NLS-1$
				}}
			}}
			__CLOVER_458_0.S[10315]++;allowedProtocols += protocol;			
		}}

		__CLOVER_458_0.S[10316]++;return formatString(pattern, allowedProtocols);
	} finally { }}

	protected String getPattern(String override, String key, Locale locale) {try { __CLOVER_458_0.M[2566]++;
		__CLOVER_458_0.S[10317]++;if ((((override != null) && (++__CLOVER_458_0.CT[1766] != 0)) || (++__CLOVER_458_0.CF[1766] == 0))){
			__CLOVER_458_0.S[10318]++;return override;}

		__CLOVER_458_0.S[10319]++;ResourceBundle strings;
		__CLOVER_458_0.S[10320]++;String string;
		__CLOVER_458_0.S[10321]++;try {
				__CLOVER_458_0.S[10322]++;strings = ResourceBundle.getBundle("net.sf.cendil.tapestry.valid.ValidationStrings", //$NON-NLS-1$
	locale);
			__CLOVER_458_0.S[10323]++;string = strings.getString(key);
		} catch (Exception exc) {
				__CLOVER_458_0.S[10324]++;strings = ResourceBundle.getBundle("org.apache.tapestry.valid.ValidationStrings", //$NON-NLS-1$
	locale);
			__CLOVER_458_0.S[10325]++;string = strings.getString(key);
		}

		__CLOVER_458_0.S[10326]++;return string;
	} finally { }}

	/**
	 * @param protocols comma separated list of allowed protocols
	 */
	public void setAllowedProtocols(String protocols) {try { __CLOVER_458_0.M[2567]++;
		__CLOVER_458_0.S[10327]++;StringSplitter spliter = new StringSplitter(',');
		//String[] aProtocols = protocols.split(","); //$NON-NLS-1$
		__CLOVER_458_0.S[10328]++;String[] aProtocols = spliter.splitToArray(protocols); //$NON-NLS-1$
		__CLOVER_458_0.S[10329]++;_allowedProtocols = new Vector();
		__CLOVER_458_0.S[10330]++;for (int i = 0; (((i < aProtocols.length) && (++__CLOVER_458_0.CT[1767] != 0)) || (++__CLOVER_458_0.CF[1767] == 0)); i++){ {
			__CLOVER_458_0.S[10331]++;_allowedProtocols.add(aProtocols[i]);
		}}
	} finally { }}

}