/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.wml;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.tapestry.IBinding;
import org.apache.tapestry.IForm;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.Tapestry;
import org.apache.tapestry.form.AbstractFormComponent;

/**
 *  A base class for building components that correspond to WML postfield elements.
 *  All such components must be wrapped (directly or indirectly) by
 *  a {@link Go} component.
 *
 *  @author David Solis
 *  @since 3.0
 *
 **/

public abstract class AbstractPostfield extends AbstractFormComponent
{public static com.cortexeb.tools.clover.d __CLOVER_463_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);

    /**
     *  Returns the {@link org.apache.tapestry.wml.Go} wrapping this component.
     *
     *  @throws  ApplicationRuntimeException if the component is not wrapped by a
     * {@link org.apache.tapestry.wml.Go}.
     *
     **/

    public IForm getForm(IRequestCycle cycle)
    {try { __CLOVER_463_0.M[2601]++;
        __CLOVER_463_0.S[10492]++;IForm result = Go.get(cycle);

        __CLOVER_463_0.S[10493]++;if ((((result == null) && (++__CLOVER_463_0.CT[1804] != 0)) || (++__CLOVER_463_0.CF[1804] == 0))){
            __CLOVER_463_0.S[10494]++;throw new ApplicationRuntimeException(
                Tapestry.getMessage("Postfield.must-be-contained-by-go"),
                this,
                null,
                null);}

        __CLOVER_463_0.S[10495]++;setForm(result);

        __CLOVER_463_0.S[10496]++;return result;
    } finally { }}

    /**
     *  @see org.apache.tapestry.AbstractComponent#renderComponent(IMarkupWriter, IRequestCycle)
     **/

    protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle)
    {try { __CLOVER_463_0.M[2602]++;
        __CLOVER_463_0.S[10497]++;IForm form = getForm(cycle);

        __CLOVER_463_0.S[10498]++;boolean rewinding = form.isRewinding();

        __CLOVER_463_0.S[10499]++;if ((((!rewinding && cycle.isRewinding()) && (++__CLOVER_463_0.CT[1805] != 0)) || (++__CLOVER_463_0.CF[1805] == 0))){
            __CLOVER_463_0.S[10500]++;return;}

        __CLOVER_463_0.S[10501]++;String name = form.getElementId(this);

        __CLOVER_463_0.S[10502]++;if ((((rewinding) && (++__CLOVER_463_0.CT[1806] != 0)) || (++__CLOVER_463_0.CF[1806] == 0))){
        {
            __CLOVER_463_0.S[10503]++;rewind(cycle);
            __CLOVER_463_0.S[10504]++;return;
        }}

        __CLOVER_463_0.S[10505]++;writer.beginEmpty("postfield");

        __CLOVER_463_0.S[10506]++;writer.attribute("name", name);
        __CLOVER_463_0.S[10507]++;String varName = getVarName();
        __CLOVER_463_0.S[10508]++;writer.attributeRaw("value", (((varName != null ) && (++__CLOVER_463_0.CT[1807] != 0)) || (++__CLOVER_463_0.CF[1807] == 0))? getEncodedVarName(varName) : "");

        __CLOVER_463_0.S[10509]++;renderInformalParameters(writer, cycle);

        __CLOVER_463_0.S[10510]++;writer.closeTag();
    } finally { }}

    protected abstract void rewind(IRequestCycle cycle);

    private String getEncodedVarName(String varName)
    {try { __CLOVER_463_0.M[2603]++;
        __CLOVER_463_0.S[10511]++;return "$(" + varName + ")";
    } finally { }}

    public boolean isDisabled()
    {try { __CLOVER_463_0.M[2604]++;
        __CLOVER_463_0.S[10512]++;return false;
    } finally { }}

    public abstract String getVarName();

    public abstract IBinding getValueBinding();

    public void updateValue(Object value)
    {try { __CLOVER_463_0.M[2605]++;
        __CLOVER_463_0.S[10513]++;getValueBinding().setObject(value);
    } finally { }}

    public abstract IForm getForm();
    public abstract void setForm(IForm form);

    public abstract String getName();
    public abstract void setName(String name);
}
