/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.wml;

import org.apache.tapestry.AbstractComponent;
import org.apache.tapestry.IBinding;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.Tapestry;

/**
 *  The Input element specifies a text entry object.
 *
 *  @author David Solis
 *  @since 3.0
 *
 **/

public abstract class Input extends AbstractComponent
{public static com.cortexeb.tools.clover.d __CLOVER_470_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);

	/**
	 *  @see AbstractComponent#renderComponent(IMarkupWriter, IRequestCycle)
	 **/

	protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle)
	{try { __CLOVER_470_0.M[2619]++;
		__CLOVER_470_0.S[10560]++;boolean render = !cycle.isRewinding();

		__CLOVER_470_0.S[10561]++;if ((((render) && (++__CLOVER_470_0.CT[1815] != 0)) || (++__CLOVER_470_0.CF[1815] == 0))){
		{
			__CLOVER_470_0.S[10562]++;writer.beginEmpty("input");

			__CLOVER_470_0.S[10563]++;writer.attribute("type", (((isHidden() ) && (++__CLOVER_470_0.CT[1816] != 0)) || (++__CLOVER_470_0.CF[1816] == 0))? "password" : "text");

            __CLOVER_470_0.S[10564]++;writer.attribute("name", getName());

			__CLOVER_470_0.S[10565]++;String title = getTitle();
			__CLOVER_470_0.S[10566]++;if ((((Tapestry.isNonBlank(title)) && (++__CLOVER_470_0.CT[1817] != 0)) || (++__CLOVER_470_0.CF[1817] == 0))){
				__CLOVER_470_0.S[10567]++;writer.attribute("title", title);}

			__CLOVER_470_0.S[10568]++;String format = getFormat();
            __CLOVER_470_0.S[10569]++;if ((((Tapestry.isNonBlank(format)) && (++__CLOVER_470_0.CT[1818] != 0)) || (++__CLOVER_470_0.CF[1818] == 0))){
				__CLOVER_470_0.S[10570]++;writer.attribute("format", format);}

            __CLOVER_470_0.S[10571]++;boolean emptyok = isEmptyok();
            __CLOVER_470_0.S[10572]++;if ((((emptyok != false) && (++__CLOVER_470_0.CT[1819] != 0)) || (++__CLOVER_470_0.CF[1819] == 0))){
				__CLOVER_470_0.S[10573]++;writer.attribute("emptyok", emptyok);}

			__CLOVER_470_0.S[10574]++;renderInformalParameters(writer, cycle);

			__CLOVER_470_0.S[10575]++;String value = readValue();
			__CLOVER_470_0.S[10576]++;if ((((Tapestry.isNonBlank(value)) && (++__CLOVER_470_0.CT[1820] != 0)) || (++__CLOVER_470_0.CF[1820] == 0))){
				__CLOVER_470_0.S[10577]++;writer.attribute("value", value);}

			__CLOVER_470_0.S[10578]++;writer.closeTag();
		}}
	} finally { }}

	public abstract String getTitle();

	public abstract String getName();

	public abstract String getFormat();

	public abstract boolean isHidden();

	public abstract boolean isEmptyok();

	public abstract IBinding getValueBinding();

	public String readValue()
    {try { __CLOVER_470_0.M[2620]++;
		__CLOVER_470_0.S[10579]++;return getValueBinding().getString();
	} finally { }}

}
