/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.wml;

import java.io.CharArrayWriter;
import java.io.PrintWriter;

import org.apache.tapestry.IMarkupWriter;

/**
 *  Subclass of {@link org.apache.tapestry.wml.WMLWriter} that is nested.  A nested writer
 *  buffers its output, then inserts it into its parent writer when it is
 *  closed.
 *
 *  @author David Solis
 *  @since 0.2.9
 * 
 **/

public class NestedWMLWriter extends WMLWriter
{public static com.cortexeb.tools.clover.d __CLOVER_471_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private IMarkupWriter _parent;
    private CharArrayWriter _internalBuffer;

    public NestedWMLWriter(IMarkupWriter parent)
    {
        super(parent.getContentType());__CLOVER_471_0.S[10580]++;try { __CLOVER_471_0.M[2621]++;

        __CLOVER_471_0.S[10581]++;_parent = parent;

        __CLOVER_471_0.S[10582]++;_internalBuffer = new CharArrayWriter();

       __CLOVER_471_0.S[10583]++;setWriter(new PrintWriter(_internalBuffer));
    } finally { }}

    /**
     *  Invokes the {@link WMLWriter#close() super-class
     *  implementation}, then gets the data accumulated in the
     *  internal buffer and provides it to the containing writer using
     *  {@link IMarkupWriter#printRaw(char[], int, int)}.
     *
     **/

    public void close()
    {try { __CLOVER_471_0.M[2622]++;
        __CLOVER_471_0.S[10584]++;super.close();

        __CLOVER_471_0.S[10585]++;char[] data = _internalBuffer.toCharArray();

        __CLOVER_471_0.S[10586]++;_parent.printRaw(data, 0, data.length);

        __CLOVER_471_0.S[10587]++;_internalBuffer = null;
        __CLOVER_471_0.S[10588]++;_parent = null;
    } finally { }}
}