/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.wml;

import org.apache.tapestry.AbstractComponent;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;

/**
 *  The onevent element binds a task to a particular intrinsic event for the immediately enclosing element, ie,
 *  specifying an onevent element inside an "XYZ" element associates an intrinsic event binding with the "XYZ" element.
 *  The user agent must ignore any onevent element specifying a type that does not correspond to a legal intrinsic event
 *  for the immediately enclosing element.
 *
 *  @author David Solis
 *  @since 3.0
 *
 **/

public abstract class OnEvent extends AbstractComponent
{public static com.cortexeb.tools.clover.d __CLOVER_472_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    /**
     *  @see AbstractComponent#renderComponent(IMarkupWriter, IRequestCycle)
     **/

    protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle)
    {try { __CLOVER_472_0.M[2623]++;
        __CLOVER_472_0.S[10589]++;boolean render = !cycle.isRewinding();

        __CLOVER_472_0.S[10590]++;if ((((render) && (++__CLOVER_472_0.CT[1821] != 0)) || (++__CLOVER_472_0.CF[1821] == 0))){
        {
            __CLOVER_472_0.S[10591]++;writer.begin("onevent");

            __CLOVER_472_0.S[10592]++;writer.attribute("type", getType());

            __CLOVER_472_0.S[10593]++;renderInformalParameters(writer, cycle);
        }}

        __CLOVER_472_0.S[10594]++;renderBody(writer, cycle);

        __CLOVER_472_0.S[10595]++;if ((((render) && (++__CLOVER_472_0.CT[1822] != 0)) || (++__CLOVER_472_0.CF[1822] == 0))){
        {
            __CLOVER_472_0.S[10596]++;writer.end();
        }}
    } finally { }}

    public abstract String getType();

}
