/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.wml;

import org.apache.tapestry.AbstractComponent;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.Tapestry;

/**
 *  This component serves as a container for one item that is listed as a choice in a {@link Select}. A {@link Select}
 *  offers a selection of choices from which usersu may choose one or more items. The select list is created using a
 *  select element which contains a collection of option elements. A string or text describing the item appears between
 *  the opening and closing option tags.
 *
 *  In order to have a dynamic onpick attribute it is better to use a concrete class of
 *  {@link org.apache.tapestry.link.ILinkRenderer} with the {@link OptionRenderer}.
 *
 *  @author David Solis
 *  @since 3.0
 *
 **/

public abstract class Option extends AbstractComponent {public static com.cortexeb.tools.clover.d __CLOVER_473_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);

	/**
	 *  @see org.apache.tapestry.AbstractComponent#renderComponent(IMarkupWriter, IRequestCycle)
	 **/

	protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle)
    {try { __CLOVER_473_0.M[2624]++;
        __CLOVER_473_0.S[10597]++;boolean render = !cycle.isRewinding();

        __CLOVER_473_0.S[10598]++;if ((((render) && (++__CLOVER_473_0.CT[1823] != 0)) || (++__CLOVER_473_0.CF[1823] == 0))){
        {
            __CLOVER_473_0.S[10599]++;writer.begin("option");

            __CLOVER_473_0.S[10600]++;String value = getValue();
            __CLOVER_473_0.S[10601]++;if ((((Tapestry.isNonBlank(value)) && (++__CLOVER_473_0.CT[1824] != 0)) || (++__CLOVER_473_0.CF[1824] == 0))){
                __CLOVER_473_0.S[10602]++;writer.attribute("value", value);}

            __CLOVER_473_0.S[10603]++;renderInformalParameters(writer, cycle);

            __CLOVER_473_0.S[10604]++;renderBody(writer, cycle);

            __CLOVER_473_0.S[10605]++;writer.end();
        }}
	} finally { }}

    public abstract String getValue();
}
