/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.wml;

import org.apache.tapestry.util.text.AsciiCharacterMatcher;
import org.apache.tapestry.util.text.AsciiCharacterTranslator;
import org.apache.tapestry.util.text.ICharacterMatcher;
import org.apache.tapestry.util.text.ICharacterTranslator;
import org.apache.tapestry.util.text.ICharacterTranslatorSource;
import org.apache.tapestry.util.text.MarkupCharacterTranslator;

/**
 * The WML implementation of a character translator source.
 * Returns a WML translator that encodes everything that is non-safe.
 * 
 * Some code borrowed from WMLWriter (by David Solis)
 * 
 * @author mb
 * @since 3.1
 */
public class WMLCharacterTranslatorSource implements ICharacterTranslatorSource
{public static com.cortexeb.tools.clover.d __CLOVER_481_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private static final String SAFE_CHARACTERS =
        "01234567890"
            + "abcdefghijklmnopqrstuvwxyz"
            + "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
            + "\t\n\r !\"#%'()*+,-./:;=?@[\\]^_`{|}~";

    private static final String[][] ENTITIES = {
        	{ "\"", "&quot;" }, 
    		{ "<", "&lt;" },
    		{ ">", "&gt;" },
    		{ "&", "&amp;" },
    		{ "$", "$$" }
        };

    private static final ICharacterMatcher SAFE_MATCHER = new AsciiCharacterMatcher(SAFE_CHARACTERS);
    private static final ICharacterTranslator ENTITY_TRANSLATOR = new AsciiCharacterTranslator(ENTITIES);

    private static final ICharacterTranslator WML_TRANSLATOR = new MarkupCharacterTranslator(true, SAFE_MATCHER, ENTITY_TRANSLATOR);

	/**
	 * @see org.apache.tapestry.util.text.ICharacterTranslatorSource#getDefaultTranslator()
	 */
	public ICharacterTranslator getDefaultTranslator() {try { __CLOVER_481_0.M[2635]++;
		__CLOVER_481_0.S[10672]++;return WML_TRANSLATOR;
	} finally { }}

	/**
	 * @see org.apache.tapestry.util.text.ICharacterTranslatorSource#getTranslator(java.lang.String)
	 */
	public ICharacterTranslator getTranslator(String encoding) {try { __CLOVER_481_0.M[2636]++;
		__CLOVER_481_0.S[10673]++;return getDefaultTranslator();
	} finally { }}
}
